unit UnitClassPalette;
// Date: 19/04/2012
// Statut: Fonctionnel
// L'objet TPalette256 est conçu autour de la palette TOPOROBOT
// par conséquent, seules les deux premières méthodes sont utilisées
// 22/07/2015: Epurage du code

{$mode DELPHI}{$H+}
{$PACKRECORDS 1}
interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees,
  Common,
  Graphics,
  SysUtils, Classes;

//type TArray256Colors = array[0..255] of TColor;
const COLORS_TABLE_SIZE = 256;
type TArray256Colors = array of TColor;
type

{ TPalette256 }

 TPalette256 = class
    procedure GenerateWeb216Palette; deprecated;
    procedure GenerateACADPalette; deprecated;
    procedure GenerateGrayScalePalette; deprecated;
  private
    FColorArray    : TArray256Colors;
    procedure ViderTableCouleurs();
  public
    procedure GenerateTOPOROBOTPalette();
    function  GetColorByIndex(const Idx: Integer):TColor;

end;

implementation

procedure TPalette256.GenerateTOPOROBOTPalette;
const
  M13107 = 13107;
  M4369  = 4369;
var
  M: TMacintoshColor;
  i,j,k,q,r: integer;
begin
  AfficherMessage(Format('%s.GenerateTOPOROBOTPalette',[ClassName]));
  ViderTableCouleurs();

  FColorArray[0]:=clWhite;
  FColorArray[1]:=clBlack;
  FColorArray[2]:=GetPCColor(30583, 30583, 30583);
  FColorArray[3]:=GetPCColor(21845, 21845, 21845);
  FColorArray[4]:=GetPCColor(65535, 65535, 0);
  FColorArray[5]:=GetPCColor(65535, 26214, 0); {5}
  FColorArray[6]:=GetPCColor(56797, 0, 0); {6}
  FColorArray[7]:=GetPCColor(65535, 0, 39321); {7}
  FColorArray[8]:=GetPCColor(26214, 0, 39321); {8}
  FColorArray[9]:=GetPCColor(0, 0, 56797); {9}
  FColorArray[10]:=GetPCColor(0, 39321, 65535); {10}
  FColorArray[11]:=GetPCColor(0, 61166, 0); {11}
  FColorArray[12]:=GetPCColor(0, 26214, 0); {12}
  for i:=1 to 2 do
    FColorArray[12+i]:=GetPCColor(M13107*(i+1), M13107 * i, M13107 * (i-1));
  FColorArray[15]:=GetPCColor(48059, 48059, 48059);
  for i:=16 to 19 do
    FColorArray[i]:=GetPCColor(5*M13107, 5*M13107, M13107 * (20-i));
  // palette calculée
  // jusqu'… la couleur 36
  q:=19;
  for i:=4 downto 2 do
    for j:=5 downto 0 do begin
      q:=q+1;
      FColorArray[q]:=GetPCColor(5*M13107, i*M13107, j*M13107);
    end;
  q:=36;
  for i:=5 downto 0 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(5*M13107, M13107, i*13107);
  end;
  //**************** OK jusqu'… la couleur 42
  for i:=5 downto 4 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(5*M13107,0, i*13107);
  end;
  for i:=2 downto 0 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(5*M13107,0, i*13107);
  end;
  // OK jusqu'… la couleur 47
  for j:=5 downto 0 do
    for k:=5 downto 0 do begin
      q:=q+1;
      FColorArray[q]:=GetPCColor(4*M13107,j*M13107, k*M13107);
    end;
  // OK jusqu'… la couleur 83
  for j:=5 downto 3 do
    for k:=5 downto 0 do begin
      q:=q+1;
      FColorArray[q]:=GetPCColor(3*M13107,j*M13107, k*M13107);
    end;
  // OK jusqu'… la couleur 101
  for k:=5 downto 2 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(3*M13107,2*M13107, k*M13107);
  end;
  q:=q+1;
  FColorArray[q]:=GetPCColor(3*M13107,2*M13107, 0);
  // OK jusqu'… la couleur 106
  for j:=1 downto 0 do
    for k:=5 downto 0 do begin
      q:=q+1;
      FColorArray[q]:=GetPCColor(3*M13107,j*M13107, k*M13107);
    end;
  // OK jusqu'… la couleur 118
  for j:=5 downto 1 do
    for k:=5 downto 0 do begin
      q:=q+1;
      FColorArray[q]:=GetPCColor(2*M13107,j*M13107, k*M13107);
    end;
  // OK jusqu'… la couleur 147
  q:=q-1;
  for k:=5 downto 4 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(2*M13107,0, k*M13107);
  end;
  for k:=2 downto 0 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(2*M13107,0, k*M13107);
  end;
  // OK jusqu'… la couleur 152.
  for j:=5 downto 0 do
    for k:=5 downto 0 do begin
      q:=q+1;
      FColorArray[q]:=GetPCColor(M13107,j*M13107, k*M13107);
    end;
  //OK jusqu'… la couleur 188
  for j:=5 downto 4 do
    for k:=5 downto 0 do begin
      q:=q+1;
      FColorArray[q]:=GetPCColor(0,j*M13107, k*M13107);
    end;
  //OK jusqu'… la couleur 200
  for k:=4 downto 0 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(0, 3*M13107, k*M13107);
  end;
  //OK jusqu'… la couleur 205
  for k:=5 downto 1 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(0, 2*M13107, k*M13107);
  end;
  for k:=5 downto 0 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(0, M13107, k*M13107);
  end;
  for k:=5 downto 1 do begin
    q:=q+1;
    FColorArray[q]:=GetPCColor(0, 0, k*M13107);
  end;
  // OK jusqu'… la couleur 221
  q:=q+1; FColorArray[q]:=GetPCColor(61166, 0, 0);
  q:=q+1; FColorArray[q]:=GetPCColor(48059, 0, 0);
  r:=0;
  for i:=1 to 7 do begin
    q:=q+1;
    r:=r + IIF((i mod 2 <>0), M4369, 2*M4369);
    FColorArray[q]:=GetPCColor(48059 - r, 0, 0);
  end;
  // OK jusqu'… la couleur 230
  q:=q+1; FColorArray[q]:=GetPCColor(0, 56797, 0);
  q:=q+1; FColorArray[q]:=GetPCColor(0, 48059, 0);
  r:=0;
  for j:=1 to 7 do begin
    q:=q+1;
    r:=r + IIF((j mod 2 <>0), M4369, 2*M4369);
    FColorArray[q]:=GetPCColor(0, 48059 - r, 0);
  end;
  // OK jusqu'… la couleur 239
  q:=q+1; FColorArray[q]:=GetPCColor(0, 0, 61166);
  q:=q+1; FColorArray[q]:=GetPCColor(0, 0, 48059);
  r:=0;
  for j:=1 to 7 do begin
    q:=q+1;
    r:=r + IIF((j mod 2 <>0), M4369, 2*M4369);
    FColorArray[q]:=GetPCColor(0, 0,48059 - r);
  end;
  r:=61166; FColorArray[q+1]:=GetPCColor(r,r,r);
  r:=56797; FColorArray[q+2]:=GetPCColor(r,r,r);
  r:=43690; FColorArray[q+3]:=GetPCColor(r,r,r);
  r:=34952; FColorArray[q+4]:=GetPCColor(r,r,r);
  for i:=1 to 3 do begin
    r:=r div 2;
    FColorArray[q+4+i]:=GetPCColor(r,r,r);
  end;
end;
procedure TPalette256.GenerateGrayScalePalette;
var
  i: byte;
begin
 AfficherMessage(ClassName+'.GenerateGrayScalePalette');
 ViderTableCouleurs();
 for i:=0 to High(FColorArray) do begin
   FColorArray[i] := RGBToColor(i,i,i);
 end;
end;



procedure TPalette256.GenerateACADPalette;
var
  i: integer;
begin
  AfficherMessage(ClassName+'.GenerateACADPalette');
  ViderTableCouleurs();
  for i:=0 to 255 do FColorArray[i]:=Acad2RGB(i);


end;
procedure TPalette256.GenerateWeb216Palette;
var
  i, j, k  : integer;
  r,g,b    : byte;
  IdxColor : integer;
begin
  AfficherMessage(ClassName+'.GenerateWeb216Palette');
  ViderTableCouleurs();
  for i:=1 to 6 do
    for j:=1 to 6 do
      for k:=1 to 6 do
        begin
          IdxColor:=(i-1)*36+
                    (j-1)*6+
                    (k-1);
          r:=255 - (i-1) * 51;
          g:=255 - (j-1) * 51;
          b:=255 - (k-1) * 51;
          FColorArray[IdxColor]:=RGBToColor(r,g,b);
        end;
end;
function TPalette256.GetColorByIndex(const Idx: Integer): TColor;
begin
  try
    Result := self.FColorArray[Idx]; // sous GDB, provoque un External SIGSEGV
  except
    Result := clSilver;
  end;
end;

procedure TPalette256.ViderTableCouleurs;
var
  i: Integer;
begin
  SetLength(FColorArray, COLORS_TABLE_SIZE);
  for i:= 0 to COLORS_TABLE_SIZE - 1 do FColorArray[i] := clSilver;
end;


end.

