unit cadreDistoX;

{$INCLUDE CompilationParameters.inc}
interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees,
  Common,
  unitdistox,
  unitUtilsComposants,
  CallDialogsStdVersion,
  Classes, SysUtils, FileUtil, graphics, curredit, SynEdit,
  LazSerial,
  Forms, Dialogs, Controls, StdCtrls, ComCtrls, ExtCtrls, Grids, Spin, Buttons, PairSplitter, EditBtn, Types;

type

  { TCdrDistoX }

  TCdrDistoX = class(TFrame)
    btnCalcCalibration: TButton;
    btnCheckCalibration: TButton;
    btnCloseDistoX: TButton;
    btnOpenDistoX: TButton;
    btnOuvrirCSV: TButton;
    btnReadParamCalibration: TButton;
    btnSauvegarder: TButton;
    btnSendParamsCalibrationToDistoX: TButton;
    btnViderListeVisees: TButton;
    btnRetrieveBlocsMemoireDistoX: TButton;
    Button1: TButton;
    Button10: TButton;
    Button11: TButton;
    btnViderJournaux: TButton;
    Button12: TButton;
    Button13: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    chkNonLinearCalibration: TCheckBox;
    chkReadingData: TCheckBox;
    cmbPorts: TComboBox;
    btnDistoXConnected: TColorButton;
    btnLectureDataActivee: TColorButton;
    editAzimut1: TCurrencyEdit;
    editAzimut2: TCurrencyEdit;
    editAzimut3: TCurrencyEdit;
    editAzimut4: TCurrencyEdit;
    editAzimut5: TCurrencyEdit;
    editAzimutMoy: TCurrencyEdit;
    editLong2: TCurrencyEdit;
    editLong3: TCurrencyEdit;
    editLong4: TCurrencyEdit;
    editLong5: TCurrencyEdit;
    editLongMoy: TCurrencyEdit;
    editPente1: TCurrencyEdit;
    editPente2: TCurrencyEdit;
    editPente3: TCurrencyEdit;
    editPente4: TCurrencyEdit;
    editPente5: TCurrencyEdit;
    editPenteMoy: TCurrencyEdit;
    editToleranceLongueurs: TCurrencyEdit;
    editNbRetries: TCurrencyEdit;
    editBlockDebut: TSpinEdit;
    editBlockFin: TSpinEdit;
    editToleranceAzimut: TCurrencyEdit;
    editLong1: TCurrencyEdit;
    editTolerancePente: TCurrencyEdit;
    editJournalPrincipal: TFileNameEdit;
    editJournalSecurite: TFileNameEdit;
    grdMesuresGMDistoX: TStringGrid;
    grdViseesDistoX: TStringGrid;
    grbxStatutDistoX: TGroupBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lbDistoXCalibrationMode: TStaticText;
    lbDistoXLaserStatus: TStaticText;
    lbDistoXNumSerie: TLabel;
    lbDistoXReadingData: TStaticText;
    lbActionsEnCours: TStaticText;
    lbDistoXBeepOn: TStaticText;
    lbDistoXVersionFirmware: TLabel;
    lbDistoXVersionHardware: TLabel;
    lbQualiteCalibration: TStaticText;
    lbQualiteAzimut: TStaticText;
    lbQualitePente: TStaticText;
    PageControl1: TPageControl;
    PairSplitter1: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    pnlStatutDistoX: TPanel;
    pnlCalibration: TPanel;
    pnlDistoXActive: TPanel;
    ProgressBar1: TProgressBar;
    memoJournal: TSynEdit;
    lbQualiteLong: TStaticText;
    lbViseeIsValide: TStaticText;
    tabDataDistoX: TTabSheet;
    tabCalibration: TTabSheet;
    tabDumpDistoX: TTabSheet;
    tabConnexion: TTabSheet;
    btnDistoXBeepON: TToggleBox;
    procedure btnCalcCalibrationClick(Sender: TObject);
    procedure btnCheckCalibrationClick(Sender: TObject);
    procedure btnCloseDistoXClick(Sender: TObject);
    procedure btnDistoXBeepONChange(Sender: TObject);
    procedure btnDistoXConnectedClick(Sender: TObject);
    procedure btnMySerialTFileStreamCloseClick(Sender: TObject);
    procedure btnMySerialTFileStreamOpenClick(Sender: TObject);
    procedure btnOpenDistoXClick(Sender: TObject);
    procedure btnOuvrirCSVClick(Sender: TObject);
    procedure btnReadParamCalibrationClick(Sender: TObject);
    procedure btnSauvegarderClick(Sender: TObject);
    procedure btnViderJournauxClick(Sender: TObject);
    procedure btnViderListeViseesClick(Sender: TObject);
    procedure btnRetrieveBlocsMemoireDistoXClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure AfficherGrdMesuresDistoX();
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure chkReadingDataChange(Sender: TObject);
    procedure lbDistoXBeepOnClick(Sender: TObject);
  private
    { private declarations }
    FMySerialTFileStream: TFileStream;
    FPilotageDistoX   : TPilotageDistoX;
    FProcAttrapperVisee: TProcedureOfObject;
    FProcTraiterMesureRecue: TProcedureOfObject;
    procedure ActiverOnglets(const B: boolean);
    function  OuvrirLeDistoX(const ComPort: string; const Tentative: integer): boolean;
    procedure FermerLeDistoX();

    procedure AfficherProgressOperationMemoireDistoX(const Etape: string; const Done, Starting, Ending: Integer);
    procedure AfficherRowMesureDistoX(const NumRow: integer; const V: TMesureViseeDistoX);

    procedure RecupererEtTraiterViseeRecue(const V: TMesureViseeDistoX);
    procedure ExtraireEtAfficherInfosDistoX();


    procedure PreparerGrilleMesuresCalibrationDX();
    procedure PreparerGrilleMesuresDistoX();

    procedure toto(const L0, az0, P0: double);
  public
    { public declarations }
    function  InitialiserCadreDistoX(): boolean;

    procedure Finaliser();
    function  ReconnecterDistoX(): boolean;
    procedure DeconnecterDistoX();
    function  GetNumeroSerieDistoX(): integer;
    function  getNbMesuresDistoX(): integer;
    function  GetViseefromDistoX(const Idx: integer): TMesureViseeDistoX;
    procedure ViderLesMesuresDistoX();
    procedure SetWaitingMesuresDistoX(const B: boolean);
    function  getPtrDistoX(): TPilotageDistoX;
  end;

implementation

{$R *.lfm}

{ TCdrDistoX }
procedure TCdrDistoX.ActiverOnglets(const B: boolean);
begin
  tabDumpDistoX.Enabled  := B;
  tabCalibration.Enabled := B;
  tabDataDistoX.Enabled  := B;
end;
function  TCdrDistoX.OuvrirLeDistoX(const ComPort: string; const Tentative: integer): boolean;
var
  WU: Boolean;
begin
  result := false;
  ActiverOnglets(false);
  AfficherMessage(format('%s.OuvrirLeDistoX sur port %s - Tentative #%d', [ClassName, ComPort, Tentative]));
  FPilotageDistoX.SetLazSerialDevice(ComPort);
  FPilotageDistoX.SetAccuracies(editToleranceLongueurs.Value,
                                  editToleranceAzimut.Value,
                                  editTolerancePente.Value);


  FPilotageDistoX.SetLabelActionsProcessing(lbActionsEnCours);
  FPilotageDistoX.SetReadingTopoData(false);
  FPilotageDistoX.SetProcProgression(AfficherProgressOperationMemoireDistoX);
  FPilotageDistoX.SetProcNotifySuccessConnexion(ExtraireEtAfficherInfosDistoX);


  WU := FPilotageDistoX.OpenDistoXConnexion();
  if (WU) then
  begin
    pnlDistoXActive.Enabled := WU;
    ExtraireEtAfficherInfosDistoX();
    lbActionsEnCours.Caption:= 'DistoX2 connecté';
    SetBtnVoyantMode(btnDistoXConnected, WU);
    FPilotageDistoX.SetProcTransmitViseeToTableau(RecupererEtTraiterViseeRecue);
    FPilotageDistoX.SetReadingTopoData(chkReadingData.Checked);

    PageControl1.ActivePageIndex := 1;
    ActiverOnglets(True);
    Exit(true);
  end;
  SetBtnVoyantMode(btnDistoXConnected, false);
  pnlDistoXActive.Enabled := false;
  result := false;
  Application.ProcessMessages;


end;

procedure TCdrDistoX.FermerLeDistoX();
begin
  AfficherMessage(format('%s.FermerLeDistoX()', [ClassName]));
  FPilotageDistoX.CloseDistoXConnexion();
  //SetBtnVoyantMode(btnDistoXConnected, FPilotageDistoX.Active);
  ExtraireEtAfficherInfosDistoX();

  pnlDistoXActive.Enabled := false;
  lbActionsEnCours.Caption:= 'DistoX2 déconnecté';
  ActiverOnglets(false);
  chkReadingData.Checked := false;
end;

procedure TCdrDistoX.AfficherProgressOperationMemoireDistoX(const Etape: string; const Done, Starting, Ending: Integer);
begin
  ProgressBar1.Min := Starting;
  ProgressBar1.Max := Ending;
  ProgressBar1.Position := Done;
  lbActionsEnCours.Caption := Etape;
end;
procedure TCdrDistoX.RecupererEtTraiterViseeRecue(const V: TMesureViseeDistoX);
var
  n: Integer;
begin
  memoJournal.Lines.add(format('RecupererEtTraiterViseeRecue: %.3f %.3f %.3f', [V.Longueur, V.Azimut, V.Pente]));
  memoJournal.CaretY := memoJournal.Lines.Count - 1;
  AfficherGrdMesuresDistoX();
  //n := FPilotageDistoX.GetNbViseesAcquises();
  //grdMesuresGMDistoX.RowCount := n + 3;
  //AfficherRowMesureDistoX(n - 1, V);
end;


procedure TCdrDistoX.ExtraireEtAfficherInfosDistoX();
const DEVICE_UNKNOWN = 'Inconnu';
var
  QDevice, QVersionFirmware, QVersionHardware: String;
begin
  if (FPilotageDistoX.Active) then
  begin
    QDevice          := Format('%d'   , [FPilotageDistoX.ExtractNumSerieFromDistoX()]);
    QVersionFirmware := Format('%.2f' , [FPilotageDistoX.ExtractVersionFirmWareFromDistoX() / 100.0]);
  end
  else
  begin
    QDevice          := DEVICE_UNKNOWN;
    QVersionFirmware := DEVICE_UNKNOWN;
  end;
  QVersionHardware := '--';
  //QVersionHardware := Format('%d'   , [FPilotageDistoX.ExtractVersionHardwareFromDistoX()]);
  lbDistoXNumSerie.Caption          := 'Device  : ' + QDevice;
  lbDistoXVersionFirmware.Caption   := 'Firmware: ' + QVersionFirmware;
  lbDistoXVersionHardware.Caption   := 'Hardware: ' + QVersionHardware;

end;

procedure TCdrDistoX.btnCalcCalibrationClick(Sender: TObject);
var
  EWE: Double;
begin
  FPilotageDistoX.SetNonLinearCalibration(chkNonLinearCalibration.Checked);
  FPilotageDistoX.CalculerCalibration();
  EWE := FPilotageDistoX.GetDelta;
  lbQualiteCalibration.Caption := Format('%.3f', [EWE]);
end;

procedure TCdrDistoX.btnCheckCalibrationClick(Sender: TObject);
begin
  if (GHTopoQuestionOuiNon('Ceci effacera les données de calibration en cours - Continuer')) then
  begin
    FPilotageDistoX.CheckMethodeCalibration();
    FPilotageDistoX.SetDataGMInGrid(grdMesuresGMDistoX);
  end;
end;

procedure TCdrDistoX.btnCloseDistoXClick(Sender: TObject);
begin
  FermerLeDistoX();
end;

procedure TCdrDistoX.btnDistoXBeepONChange(Sender: TObject);
begin
  lbDistoXBeepOn.Color := IIF(btnDistoXBeepON.Checked, clGreen, clred);
  //FPilotageDistoX.SetBeepOnOff(btnDistoXBeepON.Checked);
end;



procedure TCdrDistoX.btnDistoXConnectedClick(Sender: TObject);
begin

end;

procedure TCdrDistoX.btnMySerialTFileStreamCloseClick(Sender: TObject);
begin
  try

  finally
    FMySerialTFileStream.Free;
  end;
end;

procedure TCdrDistoX.btnMySerialTFileStreamOpenClick(Sender: TObject);
begin

end;

procedure TCdrDistoX.PreparerGrilleMesuresDistoX();
const
  NB_MAX_VISEES_DISTOX = 2000;
var
  i: Integer;
begin
  // grille de données pour GHTopo
  grdViseesDistoX.RowCount := GHTOPO_GRID_NB_LINES;
  // EWE := Format('[%s] Mesure %d: (Tir %d): L = %.3f, Az = %.3f, P = %.3f - %s',
  grdViseesDistoX.ColCount := 8;
  grdViseesDistoX.FixedCols:= 0;
  grdViseesDistoX.ColWidths[0] := 60;
  grdViseesDistoX.ColWidths[1] := LARGEUR_COLONNES_HORODATE;
  grdViseesDistoX.ColWidths[2] := LARGEUR_COLONNES_DISTOX_ID;
  grdViseesDistoX.ColWidths[3] := LARGEUR_COLONNES_BLOCK_SEGMENT;
  grdViseesDistoX.ColWidths[4] := LARGEUR_COLONNES_LAP;
  grdViseesDistoX.ColWidths[5] := LARGEUR_COLONNES_LAP;
  grdViseesDistoX.ColWidths[6] := LARGEUR_COLONNES_LAP;
  grdViseesDistoX.ColWidths[7] := LARGEUR_COLONNES_TRAME_HEXA;
  // Sous Delphi, utiliser l'option goAlwaysShowEditor
  grdViseesDistoX.Options := [goAlwaysShowEditor, goAutoAddRows,
                             goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
                             goRangeSelect, goEditing, goTabs]; // ,goAlwaysShowEditor
  grdViseesDistoX.Cells[0, 0] := '';
  grdViseesDistoX.Cells[1, 0] := 'Horodate';
  grdViseesDistoX.Cells[2, 0] := 'Appareil';
  grdViseesDistoX.Cells[3, 0] := 'Block';
  grdViseesDistoX.Cells[4, 0] := 'Longueur';
  grdViseesDistoX.Cells[5, 0] := 'Azimut';
  grdViseesDistoX.Cells[6, 0] := 'Pente';
  grdViseesDistoX.Cells[7, 0] := 'Trame';
  for i := 1 to grdViseesDistoX.RowCount - 1 do grdViseesDistoX.Cells[0, i] := Format('%d', [i]);

end;

procedure TCdrDistoX.PreparerGrilleMesuresCalibrationDX();
const
  NB_MAX_MESURES_CALIB_DISTOX = 2000;
var
  i: Integer;
begin
  grdMesuresGMDistoX.ColCount := 1 + 3 + 3 + 3;
  grdMesuresGMDistoX.RowCount := 1 + NB_MAX_MESURES_CALIB_DISTOX;
  for i := 1 to NB_MAX_MESURES_CALIB_DISTOX do grdMesuresGMDistoX.Cells[0, i] := Format('%d', [i]);
end;

function TCdrDistoX.InitialiserCadreDistoX(): boolean;
var
  MatResultat: TMatrix3x3;
begin
  AfficherMessage(Format('%s.InitialiserCadreDistoX()', [ClassName]));
  //FDocuTopo := DT;
  Result := False;
  ActiverOnglets(false);
  FProcAttrapperVisee := nil;
  self.Caption := Format(GetResourceString(rsUTILS_DISTOX_CAPTION), ['']);
  //FCommPortOpened := False;
  pnlDistoXActive.Enabled := false;
  // Pas opérationnel => on désactive
  tabCalibration.Visible := false;
  tabDumpDistoX.Visible  := false;
  // vidage du journal
  memoJournal.Lines.Clear;
  try
     RemplirComboBoxCOMPorts(cmbPorts, 0);
     // voyants
     SetVoyantMode(lbDistoXCalibrationMode, false);
     SetVoyantMode(lbDistoXReadingData    , false);
     SetVoyantMode(lbDistoXLaserStatus    , false);
     SetBtnVoyantMode(btnDistoXConnected  , false);
     SetBtnVoyantMode(btnLectureDataActivee, false);
     // grilles
     PreparerGrilleMesuresCalibrationDX();
     PreparerGrilleMesuresDistoX();


     result  := True;
     // démarrage du pilote du DistoX
     //{$IFDEF MSWINDOWS}
     FPilotageDistoX := TPilotageDistoX.Create(Application);
     editJournalPrincipal.FileName := FPilotageDistoX.GetFilenameJournalPrincipal();
     editJournalSecurite.FileName  := FPilotageDistoX.GetFilenameJournalSecurite();

     ///{$ELSE}
     //FPilotageDistoX := TPilotageDistoX.Create(Application);
     //{$ENDIF}
     // onglet Visées
     PageControl1.ActivePageIndex := 0;
     Result := True;
  except
    ShowMessage('InitialiserCadreDistoX KO');
  end;
end;





procedure TCdrDistoX.btnOpenDistoXClick(Sender: TObject);
const
  ECHEC_CONNEXION = 'Echec de connexion (ex: DistoX non allumé, pas de BlueTooth, ...';
var
  EWE: String;
  i: Integer;
  WU: Boolean;
begin
  PageControl1.ActivePageIndex := 0;



  //FPilotageDistoX.SetTimeoutDelay(10000);
  for i := 1 to editNbRetries.AsInteger do
  begin
    lbActionsEnCours.Caption := Format('Connexion au DistoX: Tentative %d / %d', [i, editNbRetries.AsInteger]);
    if (OuvrirLeDistoX(trim(cmbPorts.Text), i)) then
    begin
      //FPilotageDistoX.SetBeepOnOff(true);

      Exit;
    end;
  end;
  lbActionsEnCours.Caption := ECHEC_CONNEXION;
  ShowMessage(ECHEC_CONNEXION);
end;

procedure TCdrDistoX.btnOuvrirCSVClick(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
begin
  QFileName := '';
  if (GHTopoQuestionOuiNon('Données non enregistrées - Continuer')) then
  begin
    if (DoDialogOpenFile('Fichiers CSV (*.csv)|*.csv|Tous (*.*)|*.*', '.csv', QFileName)) then
    begin
      FPilotageDistoX.ChargerDonneesViseesBrutes(QFileName);
      AfficherGrdMesuresDistoX();
    end;
  end;
end;

procedure TCdrDistoX.btnReadParamCalibrationClick(Sender: TObject);
begin
  if (not FPilotageDistoX.Active) then Exit;
  FPilotageDistoX.ReadCalibrationParametersFromDistoX();
  ShowMessage('Params calib lus');
end;

procedure TCdrDistoX.btnSauvegarderClick(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  QFileName := Format('Donnees_DistoX_%s.csv', [DatePascalToDateHeureCondensee(Now())]);
  if (DoDialogSaveFile('Fichiers csv|*.csv', '.csv', QFileName, QFilterIndex)) then
  begin
    FPilotageDistoX.SauverDonneesViseesBrutes(QFileName);
  end;
end;

procedure TCdrDistoX.btnViderJournauxClick(Sender: TObject);
begin
  if (GHTopoQuestionOuiNon('Vider les journaux')) then FPilotageDistoX.ViderJournaux();
end;

procedure TCdrDistoX.btnViderListeViseesClick(Sender: TObject);
begin
  if (GHTopoQuestionOuiNon('Vider la liste des stations')) then
  begin
    FPilotageDistoX.ViderListeMesuresTopo(True);
    AfficherGrdMesuresDistoX();
  end;
end;

procedure TCdrDistoX.Button1Click(Sender: TObject);
begin
  if (FPilotageDistoX.Active) then FPilotageDistoX.DemanderUneMesure();
  //chkReadingDataChange(Self);
end;

procedure TCdrDistoX.btnRetrieveBlocsMemoireDistoXClick(Sender: TObject);
var
  V0, V1: Integer;
begin
  if (not FPilotageDistoX.Active) then Exit;
  V0 := editBlockDebut.Value;
  V1 := editBlockFin.Value;
  if (V1 < V0) then
  begin
    Swap(V0, V1);
    editBlockDebut.Value := V0;
    editBlockFin.Value   := V1;
  end;
  PageControl1.ActivePageIndex := 0;
  try
    FPilotageDistoX.ReadDataSection(V0, V1);
    AfficherGrdMesuresDistoX();
  finally
  end;
end;

procedure TCdrDistoX.Button10Click(Sender: TObject);
begin
   FPilotageDistoX.SetAccuracies(editToleranceLongueurs.Value,
                                 editToleranceAzimut.Value,
                                 editTolerancePente.Value);
end;

procedure TCdrDistoX.Button11Click(Sender: TObject);
  procedure Cuicui(const EditL, EditA, EditP: TCurrencyEdit);
  var
    V: TMesureViseeDistoX;
  begin
    V.TimeStamp := Now(); V.Longueur  := EditL.Value; V.Azimut := EditA.Value; V.Pente := EditP.Value;
    FPilotageDistoX.AddMesureVisee(V, True);
    //FPilotageDistoX.EcrireMesureDansJournaux(V);
  end;
const
  COLOR_LB_QUALITE = clGreen;
var
  QVisee: TUneVisee;
  QErr: TErrorConstruireUneViseeValide;
  EWE: Boolean;
begin
  Cuicui(editLong1, editAzimut1, editPente1);
  Cuicui(editLong2, editAzimut2, editPente2);
  Cuicui(editLong3, editAzimut3, editPente3);
  Cuicui(editLong4, editAzimut4, editPente4);
  Cuicui(editLong5, editAzimut5, editPente5);

  EWE := FPilotageDistoX.ConstruireUneViseeValide(tgDEFAULT, 0, 1, 1, QVisee, QErr);
  editLongMoy.Value   := QVisee.Longueur;
  editAzimutMoy.Value := QVisee.Azimut;
  editPenteMoy.Value  := QVisee.Pente;
  lbQualiteLong.Color    := IIF(errCVV_OUTBOUNDS_LONGUEUR in QERR, clRed, COLOR_LB_QUALITE);
  lbQualiteAzimut.Color  := IIF(errCVV_OUTBOUNDS_AZIMUT   in QERR, clRed, COLOR_LB_QUALITE);
  lbQualitePente.Color   := IIF(errCVV_OUTBOUNDS_PENTE    in QERR, clRed, COLOR_LB_QUALITE);
  lbViseeIsValide.Caption := Format('La visée est %sVALIDE', [IIF(EWE, '', 'IN')]);
end;

procedure TCdrDistoX.Button12Click(Sender: TObject);
begin
  //FPilotageDistoX.set;
end;

procedure TCdrDistoX.Button13Click(Sender: TObject);
begin
  if (FPilotageDistoX.Active) then
  begin
    FPilotageDistoX.DemanderUneVisee();
  end;
end;

procedure TCdrDistoX.Button2Click(Sender: TObject);
begin
  AfficherGrdMesuresDistoX();
end;


procedure TCdrDistoX.Button6Click(Sender: TObject);
begin
  GRDCCopierUnTableau(grdViseesDistoX);
end;

procedure TCdrDistoX.Button7Click(Sender: TObject);
var
  QVisee: TUneVisee;
  QErrMsg: string;
  EWE: Boolean;
  QERR: TErrorConstruireUneViseeValide;
begin
  toto(8.66, 180.0, 45.00);
  EWE := FPilotageDistoX.ConstruireUneViseeValide(tgDEFAULT, 0,1,1, QVisee, QERR);
  AfficherMessageErreur(Format(' %d: L=%.3f, A=%.3f, P=%.3f', [0, QVisee.Longueur, QVisee.Azimut, QVisee.Pente]));
  //AfficherMessageErreur(QErrMsg);
end;

procedure TCdrDistoX.Button8Click(Sender: TObject);
var
  QVisee: TUneVisee;
  QErrMsg: string;
  EWE: Boolean;
  QErr: TErrorConstruireUneViseeValide;
begin
  toto(14.77, 270.0, 0.00);
  EWE := FPilotageDistoX.ConstruireUneViseeValide(tgDEFAULT, 0,1,1, QVisee, QErr);
  AfficherMessageErreur(Format(' %d: L=%.3f, A=%.3f, P=%.3f', [0, QVisee.Longueur, QVisee.Azimut, QVisee.Pente]));
  //AfficherMessageErreur(QErrMsg);
end;

procedure TCdrDistoX.Button9Click(Sender: TObject);
var
  QVisee: TUneVisee;
  QErrMsg: string;
  EWE: Boolean;
  QErr: TErrorConstruireUneViseeValide;
begin
  toto(10.77, 90.0, -45.00);
  EWE := FPilotageDistoX.ConstruireUneViseeValide(tgDEFAULT, 0,1,1, QVisee, QErr);
  AfficherMessageErreur(Format(' %d: L=%.3f, A=%.3f, P=%.3f', [0, QVisee.Longueur, QVisee.Azimut, QVisee.Pente]));
  //AfficherMessageErreur(QErrMsg);
end;

procedure TCdrDistoX.chkReadingDataChange(Sender: TObject);
begin
  FPilotageDistoX.SetReadingTopoData(chkReadingData.Checked);
  SetBtnVoyantMode(btnLectureDataActivee, FPilotageDistoX.IsAcquiringTopoData());
end;

procedure TCdrDistoX.lbDistoXBeepOnClick(Sender: TObject);
begin

end;



procedure TCdrDistoX.Finaliser();
begin
  try
    FermerLeDistoX();
  finally
    //FPilotageDistoX.Free; Libéré par le parent. Ne pas utiliser .Free()
  end;
end;


function TCdrDistoX.ReconnecterDistoX(): boolean;
begin
  Result := FPilotageDistoX.OpenDistoXConnexion();
end;



procedure TCdrDistoX.DeconnecterDistoX();
begin
  FPilotageDistoX.CloseDistoXConnexion();
end;

function TCdrDistoX.GetNumeroSerieDistoX(): integer;
begin
  Result := FPilotageDistoX.ExtractNumSerieFromDistoX();
end;

function TCdrDistoX.getNbMesuresDistoX(): integer;
begin
  result := FPilotageDistoX.GetNbMesuresAcquises();
end;

function TCdrDistoX.GetViseefromDistoX(const Idx: integer): TMesureViseeDistoX;
begin
  Result := FPilotageDistoX.GetMesureVisee(Idx);
end;

procedure TCdrDistoX.ViderLesMesuresDistoX();
begin
  FPilotageDistoX.ViderListeMesuresTopo(True);
end;

procedure TCdrDistoX.SetWaitingMesuresDistoX(const B: boolean);
begin
  FPilotageDistoX.SetReadingTopoData(B);
end;

function TCdrDistoX.getPtrDistoX(): TPilotageDistoX;
begin
  result := FPilotageDistoX;
end;


procedure TCdrDistoX.AfficherRowMesureDistoX(const NumRow: integer; const V: TMesureViseeDistoX);
begin
  grdViseesDistoX.Cells[0, NumRow+1] := Format('%d'  , [NumRow]);
  grdViseesDistoX.Cells[1, NumRow+1] := Format('%s'  , [DateTimeToStr(V.TimeStamp)]);
  grdViseesDistoX.Cells[2, NumRow+1] := Format('%d'  , [V.DistoXSerialNumber]);
  grdViseesDistoX.Cells[3, NumRow+1] := Format('%.2d:%.2d'  , [V.Block, V.Segment]);
  grdViseesDistoX.Cells[4, NumRow+1] := Format('%.3f', [V.Longueur]);
  grdViseesDistoX.Cells[5, NumRow+1] := Format('%.3f', [V.Azimut]);
  grdViseesDistoX.Cells[6, NumRow+1] := Format('%.3f', [V.Pente]);
  grdViseesDistoX.Cells[7, NumRow+1] := Format('%s'  , [V.HexaData]);
end;

procedure TCdrDistoX.AfficherGrdMesuresDistoX();
var
  i, Nb: Integer;
  EWE: TMesureViseeDistoX;
begin
  Nb := FPilotageDistoX.GetNbMesuresAcquises();
  if (Nb = 0) then Exit;

  grdViseesDistoX.RowCount := Nb + 1;
  for i := 0 to Nb-1 do
  begin
    EWE := FPilotageDistoX.GetMesureVisee(i);
    AfficherRowMesureDistoX(i, EWE);
  end;
end;

procedure TCdrDistoX.Button3Click(Sender: TObject);
var
  QVisee: TUneVisee;
  QErrMsg: string;
  EWE: Boolean;
  QErr: TErrorConstruireUneViseeValide;
begin
  EWE := FPilotageDistoX.ConstruireUneViseeValide(tgDEFAULT, 0,1,1, QVisee, QErr);
  AfficherMessageErreur(Format(' %d: L=%.3f, A=%.3f, P=%.3f', [0, QVisee.Longueur, QVisee.Azimut, QVisee.Pente]));
  AfficherMessageErreur(QErrMsg);
end;

procedure TCdrDistoX.Button4Click(Sender: TObject);
var
  V: TMesureViseeDistoX;
  n, i: Integer;
begin
  V.TimeStamp := Now(); V.Longueur  := 22.92; V.Azimut := 275.00; V.Pente := -12.00;
  FPilotageDistoX.AddMesureVisee(V, True);
  V.TimeStamp := Now(); V.Longueur  := 22.87; V.Azimut := 274.48; V.Pente := -12.25;
  FPilotageDistoX.AddMesureVisee(V, True);
  V.TimeStamp := Now(); V.Longueur  := 22.94; V.Azimut := 275.03; V.Pente := -11.93;
  FPilotageDistoX.AddMesureVisee(V, True);
  V.TimeStamp := Now(); V.Longueur  := 22.96; V.Azimut := 274.78; V.Pente := -12.66;
  FPilotageDistoX.AddMesureVisee(V, True);
  FPilotageDistoX.SetAccuracies(editToleranceLongueurs.Value,
                                editToleranceAzimut.Value,
                                editTolerancePente.Value);
  n := FPilotageDistoX.GetNbMesuresAcquises();
  for i := 0 to n - 1 do
  begin
    V := FPilotageDistoX.GetMesureVisee(i);
    AfficherMessageErreur(Format(' %d: L=%.3f, A=%.3f, P=%.3f', [i, V.Longueur, V.Azimut, V.Pente]));
  end;

end;

procedure TCdrDistoX.toto(const L0, az0, P0: double);
var
  i, n: Integer;
  V: TMesureViseeDistoX;
begin

  V.TimeStamp := Now(); V.Longueur  := L0 + 0.05; V.Azimut := az0 + 0.34; V.Pente := P0 + 0.05;
  FPilotageDistoX.AddMesureVisee(V, True);
  V.TimeStamp := Now(); V.Longueur  := L0 - 0.01; V.Azimut := az0 - 0.34; V.Pente := P0 - 0.02;
  FPilotageDistoX.AddMesureVisee(V, True);
  V.TimeStamp := Now(); V.Longueur  := L0 + 0.04; V.Azimut := az0 + 0.55; V.Pente := P0 + 0.15;
  FPilotageDistoX.AddMesureVisee(V, True);
  V.TimeStamp := Now(); V.Longueur  := L0 - 0.02; V.Azimut := az0 - 0.11; V.Pente := P0 - 0.35;
  FPilotageDistoX.AddMesureVisee(V, True);
  V.TimeStamp := Now(); V.Longueur  := L0 + 0.22; V.Azimut := az0 + 0.21; V.Pente := P0 + 0.04;
  FPilotageDistoX.AddMesureVisee(V, True);

  n := FPilotageDistoX.GetNbMesuresAcquises();
  for i := 0 to n - 1 do
  begin
    V := FPilotageDistoX.GetMesureVisee(i);
    AfficherMessageErreur(Format(' %d: L=%.3f, A=%.3f, P=%.3f', [i, V.Longueur, V.Azimut, V.Pente]));
  end;
  AfficherMessageErreur('');
end;

procedure TCdrDistoX.Button5Click(Sender: TObject);
var
  QVisee: TUneVisee;
  QErrMsg: string;
  EWE: Boolean;
  QErr: TErrorConstruireUneViseeValide;
begin
  toto(22.92, 0.00, 0.00);
  QErrMsg:='';
  EWE := FPilotageDistoX.ConstruireUneViseeValide(tgDEFAULT, 0,1,1, QVisee, QErr);
  AfficherMessageErreur(Format(' %d: L=%.3f, A=%.3f, P=%.3f', [0, QVisee.Longueur, QVisee.Azimut, QVisee.Pente]));
  AfficherMessageErreur(QErrMsg);

end;

end.

