unit CadreListesSimples;
// TODO: Remplacer cmbListeSelectionnee par un ensemble de boutons
// [Entrees][Codes][Séances]

{$INCLUDE CompilationParameters.inc}

interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees,
  Common,
  UnitClassPalette,
  ToporobotClasses2012,
  UnitEntitesExtended,
  Graphics,
  CallDialogsStdVersion,
  unitUtilsComposants,
  Classes, SysUtils, FileUtil, Forms, Dialogs, Controls, ExtCtrls, ComCtrls, StdCtrls, Buttons, ActnList, Types, LCLType;

type

  { TCdrListesSimples }

  TCdrListesSimples = class(TFrame)
    acAddItem: TAction;
    acDeleteItem: TAction;
    acEditItem: TAction;
    acExportListesCSV: TAction;
    acFind: TAction;
    acGotoByNumero: TAction;
    acHelpListesSimples: TAction;
    acnlstProjectManager: TActionList;
    acSort: TAction;
    editSearch: TEdit;
    hcColsTitres: THeaderControl;
    imglstProjectManager: TImageList;
    lsbListe: TListBox;
    Panel1: TPanel;
    rgbxTypesListes: TRadioGroup;
    SpeedButton1: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    lbNbreElements: TStaticText;
    procedure acAddItemExecute(Sender: TObject);
    procedure acDeleteItemExecute(Sender: TObject);
    procedure acEditItemExecute(Sender: TObject);
    procedure acExportListesCSVExecute(Sender: TObject);
    procedure acFindExecute(Sender: TObject);
    procedure acGotoByNumeroExecute(Sender: TObject);
    procedure acHelpListesSimplesExecute(Sender: TObject);
    procedure acSortExecute(Sender: TObject);
    procedure editSearchKeyPress(Sender: TObject; var Key: char);

    procedure hcColsTitresSectionResize(HeaderControl: TCustomHeaderControl; Section: THeaderSection);
    procedure lsbListeDblClick(Sender: TObject);
    procedure lsbListeDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
    procedure rgbxTypesListesSelectionChanged(Sender: TObject);
  private
    { private declarations }
    FModeBDD          : TModeBDD;
    FDocumentToporobot: TToporobotStructure2012;
    FBDDEntites       : TBDDEntites;
    FPalette256       : TPalette256;

    FNumeroEntree     : integer;
    FNumeroReseau     : integer;
    FNumeroSecteur    : integer;
    FNumeroExpe       : integer;
    FNumeroCode       : integer;
    FNumeroAnnotation : integer;
    FNumeroNoteVersion: integer;
    FNumeroPOI        : integer;
    procedure AfficherNbElements();
    procedure InitCaptions();
    procedure InitHeaderListesSimples();
    procedure ListerLesCodes(const QIdx: integer);
    procedure ListerLesEntrees(const QIdx: integer);
    procedure ListerLesExpes(const QIdx: integer);
    procedure ListerLesPOI(const QIdx: integer);
    procedure ListerLesReseaux(const QIdx: integer);
    procedure ListerLesSecteurs(const QIdx: integer);
    procedure ListerLesAnnotations(const QIdx: integer);
    {$IFDEF SUPPORT_NOTES_VERSION}
    procedure ListerLesNotesVersion(const QIdx: integer);
    {$endif SUPPORT_NOTES_VERSION}
    procedure ListerListesSimples(const QModeBDD: TModeBDD);
  public
    { public declarations }
    function Initialiser(const FD: TToporobotStructure2012;
                         const FE: TBDDEntites;
                         const FP: TPalette256; const M: TModeBDD): boolean;
    procedure SetPtrBDDEntites(const B : TBDDEntites);

  end;

implementation

{$R *.lfm}

{ TCdrListesSimples }
function TCdrListesSimples.Initialiser(const FD: TToporobotStructure2012;
                                       const FE: TBDDEntites;
                                       const FP: TPalette256;
                                       const M : TModeBDD): boolean;
begin
  Result := false;
  lsbListe.ItemHeight := 22;
  try
    FNumeroEntree      := 0;
    FNumeroReseau      := 0;
    FNumeroSecteur     := 0;
    FNumeroExpe        := 0;
    FNumeroCode        := 0;
    FNumeroAnnotation  := 0;
    FNumeroNoteVersion := 0;
    FNumeroPOI         := 0;
    FModeBDD           := M;
    FDocumentToporobot := FD;
    FBDDEntites        := FE;
    FPalette256        := FP;
    ListerListesSimples(FModeBDD);
    InitCaptions();
  except
  end;
end;

procedure TCdrListesSimples.SetPtrBDDEntites(const B: TBDDEntites);
begin
  FBDDEntites := B;
end;



procedure TCdrListesSimples.acAddItemExecute(Sender: TObject);
var
  n: Integer;
  EWE: String;
  EE: TEntrance;
  RS: TReseau;
  SS: TSecteur;
  CC: TCode;
  EX: TExpe;
begin
  case FModeBDD of
    mbddENTRANCES  : EWE := GetResourceString(rsDLG_BDD_INSERT_ENTREE);
    mbddRESEAUX    : EWE := GetResourceString(rsDLG_BDD_INSERT_RESEAU);
    mbddSECTEURS   : EWE := GetResourceString(rsDLG_BDD_INSERT_SECTEUR);
    mbddCODES      : EWE := GetResourceString(rsDLG_BDD_INSERT_CODE);
    mbddEXPES      : EWE := GetResourceString(rsDLG_BDD_INSERT_EXPE);
    mbddANNOTATIONS: Exit; // les annotations ne s'ajoutent que via le plan
    mbddRELEASE_NOTES : EWE := GetResourceString(rsDLG_BDD_INSERT_NoteVersion);
    mbddPOI           : exit; // les POI sont reconstruits depuis les commentaires des stations
  else
    ;
  end;
  if (not GHTopoQuestionOuiNon(EWE)) then Exit;
  n := lsbListe.Count - 1;
  case FModeBDD of
    mbddENTRANCES: // entrées
      begin

        EE := MakeTEntrance('Nouvelle entrée', '', 0.00, 0.00, 0.00, 0, 0, '');
        ShowMessage(BoolToStr(assigned(FBDDEntites), 'FBDDEntites transmis', 'FBDDEntites KO'));
        if (EditerEntrance(FDocumentToporobot, n, FBDDEntites , EE)) then
        begin
          FDocumentToporobot.AddEntree(EE);
          n := FDocumentToporobot.GetNbEntrees();
          ListerLesEntrees(n - 1);
        end;
      end;
    mbddRESEAUX  : // réseaux
      begin
        RS := MakeTReseau(clBlue, 0, 'Nouveau réseau', '');
        if (EditerReseau(FDocumentToporobot, n, RS)) then
        begin
          FDocumentToporobot.AddReseau(RS);
          n := FDocumentToporobot.GetNbReseaux();
          ListerLesReseaux(n - 1);
        end;
      end;
    mbddSECTEURS : // secteurs;
      begin
        SS := MakeTSecteur(clRed, 'Nouveau secteur');
        if (EditerSecteur(FDocumentToporobot, n, SS)) then
        begin
          FDocumentToporobot.AddSecteur(SS);
          n := FDocumentToporobot.GetNbSecteurs();
          ListerLesSecteurs(n - 1);
        end;
      end;
    mbddCODES: // codes
      begin
        // attraper le dernier code
        n := FDocumentToporobot.GetNbCodes();
        CC := FDocumentToporobot.GetCode(n - 1);
        CC.IDCode := 1 + FDocumentToporobot.getMaxIdxCode();
        if (EditerCode(FDocumentToporobot, n, CC)) then
        begin
          FDocumentToporobot.AddCode(CC);
          n := FDocumentToporobot.GetNbCodes();
          ListerLesCodes(n - 1);
        end;
      end;
    mbddEXPES: // expés
      begin
        n := FDocumentToporobot.GetNbExpes();
        EX := FDocumentToporobot.GetExpe(n - 1);
        EX.IDExpe := 1 + FDocumentToporobot.getMaxIdxExpe();
        if (EditerExpe(FDocumentToporobot, n, EX)) then
        begin
          FDocumentToporobot.AddExpe(EX);
          n := FDocumentToporobot.GetNbExpes();
          ListerLesExpes(n - 1);
        end;
      end;
    mbddRELEASE_NOTES: // notes de version
      begin
        pass;
      end;
  else
    pass;
  end;
end;

procedure TCdrListesSimples.acDeleteItemExecute(Sender: TObject);
var
  QIdx: integer;
begin
  QIdx := lsbListe.ItemIndex;
  if (QIdx < 1) then Exit;
  if (GHTopoQuestionOuiNon(Format(GetResourceString(rsMSG_WARN_DELETE_ITEM), [QIdx]))) then
  begin
    case FModeBDD of
      mbddENTRANCES    : if (FDocumentToporobot.RemoveEntree(QIdx))  then ListerLesEntrees(0);
      mbddRESEAUX      : if (FDocumentToporobot.RemoveReseau(QIdx))  then ListerLesReseaux(0);
      mbddSECTEURS     : if (FDocumentToporobot.RemoveSecteur(QIdx)) then ListerLesSecteurs(0);
      mbddCODES        : if (FDocumentToporobot.RemoveCode(QIdx))    then ListerLesCodes(0);
      mbddEXPES        : if (FDocumentToporobot.RemoveExpe(QIdx))    then ListerLesExpes(0);
      mbddANNOTATIONS  : if (FDocumentToporobot.RemoveAnnotation(QIdx))   then ListerLesAnnotations(0);
      {$IFDEF SUPPORT_NOTES_VERSION}
      mbddRELEASE_NOTES: if (FDocumentToporobot.RemoveNoteVersion(QIdx))  then ListerLesNotesVersion(0);
      {$endif SUPPORT_NOTES_VERSION}
    else
      pass;
    end;
  end;
end;

procedure TCdrListesSimples.acEditItemExecute(Sender: TObject);
var
  n: Integer;
  RS: TReseau;
  EE: TEntrance;
  SS: TSecteur;
  CC: TCode;
  EX: TExpe;
  AA: TAnnotation;
begin
  n := lsbListe.ItemIndex;
  if (n < 0) then Exit;
  case FModeBDD of
    mbddENTRANCES: // entrées
      begin
        EE := FDocumentToporobot.GetEntree(n);
        if (EditerEntrance(FDocumentToporobot, n, FBDDEntites, EE)) then
        begin
          FDocumentToporobot.PutEntree(n, EE);
          ListerLesEntrees(n);
        end;
      end;
    mbddRESEAUX  : // réseaux
      begin
        RS := FDocumentToporobot.GetReseau(n);
        if (EditerReseau(FDocumentToporobot, n, RS)) then
        begin
          FDocumentToporobot.PutReseau(n, RS);
          ListerLesReseaux(n);
        end;
      end;
    mbddSECTEURS : // secteurs;
      begin
        SS := FDocumentToporobot.GetSecteur(n);
        if (EditerSecteur(FDocumentToporobot, n, SS)) then
        begin
          FDocumentToporobot.PutSecteur(n, SS);
          ListerLesSecteurs(n);
        end;
      end;
    mbddCODES: // codes
      begin
        if (n < 1) then Exit; // expé et code 0 ne sont pas modifiables
        CC := FDocumentToporobot.GetCode(n);
        if (EditerCode(FDocumentToporobot, n, CC)) then
        begin
          FDocumentToporobot.PutCode(n, CC);
          ListerLesCodes(n);
        end;
      end;
    mbddEXPES: // expés
      begin
        if (n < 1) then Exit; // expé et code 0 ne sont pas modifiables
        EX := FDocumentToporobot.GetExpe(n);
        if (EditerExpe(FDocumentToporobot, n, EX)) then
        begin
          FDocumentToporobot.PutExpe(n, EX);
          ListerLesExpes(n);
        end;
      end;
    mbddANNOTATIONS: // annotations
      begin
        AA := FDocumentToporobot.GetAnnotation(n);
        if (EditerAnnotation(FDocumentToporobot, n, AA)) then
        begin
          FDocumentToporobot.PutAnnotation(n, AA);
          ListerLesAnnotations(n);
        end;
      end;
    mbddRELEASE_NOTES: // notes de version
      begin
        pass;
      end;
    mbddPOI:
      begin
        pass;
      end;
  else
    ;
  end;
end;

procedure TCdrListesSimples.acExportListesCSVExecute(Sender: TObject);
var
  WU: TStringDirectoryFilename;
  EWE: String;
  QFilterIndex: integer;
begin
  case FModeBDD of
    mbddENTRANCES    : EWE := 'Entrees';
    mbddRESEAUX      : EWE := 'Reseaux';
    mbddSECTEURS     : EWE := 'Secteurs';
    mbddCODES        : EWE := 'Codes';
    mbddEXPES        : EWE := 'Expes';
    mbddANNOTATIONS  : EWE := 'Annotations';
    mbddRELEASE_NOTES: EWE := 'Release_notes';
    mbddPOI          : EWE := 'Points Of Interest';
  end;
  WU := Format('Liste001_%s.csv', [EWE]);
  if (DoDialogSaveFile('CSV file (*.csv)|*.csv|', '.csv', WU, QFilterIndex)) then
  begin
    case FModeBDD of
      mbddENTRANCES     : FDocumentToporobot.ExportListeEntreesCSV(WU);
      mbddRESEAUX       : FDocumentToporobot.ExportListeReseauxCSV(WU);
      mbddSECTEURS      : FDocumentToporobot.ExportListeSecteursCSV(WU);
      mbddCODES         : FDocumentToporobot.ExportListeCodesCSV(WU);
      mbddEXPES         : FDocumentToporobot.ExportListeExpesCSV(WU);
      mbddANNOTATIONS   : FDocumentToporobot.ExportListeAnnotationsCSV(WU);
      mbddRELEASE_NOTES : pass; //// notes de version
      mbddPOI           : pass;
    end;
  end;
end;

procedure TCdrListesSimples.acFindExecute(Sender: TObject);
var
  QIdx: integer;
begin
  if (FindIdxOccurrenceInListBox(lsbListe, trim(editSearch.Text), QIdx)) then
    lsbListe.ItemIndex := QIdx
  else
    ShowMessage(GetResourceString(rsMATCHNOTFOUND));
end;

procedure TCdrListesSimples.acGotoByNumeroExecute(Sender: TObject);
var
  zdar: String;
  miou: String;
  EWE, WU: Integer;
begin
  miou := '';
  case FModeBDD of
    mbddENTRANCES    : zdar := rsDLG_FIND_ENTRANCE_BY_TEXT;
    mbddRESEAUX      : zdar := rsDLG_FIND_RESEAU_BY_TEXT;
    mbddSECTEURS     : zdar := rsDLG_FIND_SECTEUR_BY_TEXT;
    mbddCODES        : zdar := rsDLG_FIND_CODE_BY_TEXT;
    mbddEXPES        : zdar := rsDLG_FIND_EXPE_BY_TEXT;
    mbddANNOTATIONS  : Exit; // sans objet pour l'instant
    mbddRELEASE_NOTES: Exit; // notes de version
    mbddPOI          : Exit;
  end;
  if (not GHTopoInputQuery(GetResourceString(zdar),
                           GetResourceString(rsDLG_FIND_PROMPT),
                           miou)) then Exit;
  EWE := StrToIntDef(miou, 0);
  case FModeBDD of
    mbddENTRANCES: WU := FDocumentToporobot.GetIdxEntreeByNumero(EWE);
    mbddRESEAUX  : WU := FDocumentToporobot.GetIdxReseauByNumero(EWE);
    mbddSECTEURS : WU := FDocumentToporobot.GetIdxSecteurByNumero(EWE);
    mbddCODES    : WU := FDocumentToporobot.GetIdxCodeByNumero(EWE);
    mbddEXPES    : WU := FDocumentToporobot.GetIdxExpeByNumero(EWE);
  else
    pass;
  end;
  if (WU = -1) then
  begin
    ShowMessage(GetResourceString(rsMATCHNOTFOUND));
    Exit;
  end;
end;

procedure TCdrListesSimples.acHelpListesSimplesExecute(Sender: TObject);
begin
  DisplayHelpSystem('LISTES_SIMPLES');
end;

procedure TCdrListesSimples.acSortExecute(Sender: TObject);
begin
  case FModeBDD of
    mbddENTRANCES: ;
    mbddRESEAUX  : ;
    mbddSECTEURS : ;
    mbddCODES:
      begin
        FDocumentToporobot.SortCodes;
        ListerLesCodes(0);
      end;
    mbddEXPES:
      begin
        FDocumentToporobot.SortExpes;
        ListerLesExpes(0);
      end;
    mbddANNOTATIONS    : pass;
    mbddRELEASE_NOTES  : pass; // notes de version
    mbddPOI            : pass;
  else
    pass;
  end;
end;

procedure TCdrListesSimples.AfficherNbElements();
  procedure MiouMiou(const Miou: string; const Nb: integer); inline;
  begin
    lbNbreElements.Caption := format(GetResourceString(Miou), [Nb]);
  end;
begin
  case FModeBDD of
    mbddENTRANCES     : MiouMiou(rsNB_ELEMENTS_ENTRANCES  , FDocumentToporobot.GetNbEntrees());
    mbddRESEAUX       : MiouMiou(rsNB_ELEMENTS_RESEAUX    , FDocumentToporobot.GetNbReseaux());
    mbddSECTEURS      : MiouMiou(rsNB_ELEMENTS_SECTEURS   , FDocumentToporobot.GetNbSecteurs());
    mbddCODES         : MiouMiou(rsNB_ELEMENTS_CODES      , FDocumentToporobot.GetNbCodes());
    mbddEXPES         : MiouMiou(rsNB_ELEMENTS_EXPES      , FDocumentToporobot.GetNbExpes());
    mbddANNOTATIONS   : MiouMiou(rsNB_ELEMENTS_ANNOTATIONS, FDocumentToporobot.GetNbAnnotations());
    mbddPOI           : MiouMiou(rsNB_ELEMENTS_POI        , FDocumentToporobot.GetNbPointsOfInterests());
  end;
end;

procedure TCdrListesSimples.editSearchKeyPress(Sender: TObject; var Key: char);
begin
  if (key = #13) then acFindExecute(self);
end;



procedure TCdrListesSimples.hcColsTitresSectionResize(HeaderControl: TCustomHeaderControl; Section: THeaderSection);
begin
  lsbListe.Invalidate;
end;



procedure TCdrListesSimples.InitCaptions;
var
  WU: String;
  procedure SetAcHint(const A: TAction; const H: string);
  begin
    A.Hint    := GetResourceString(H);
    A.Caption := A.Hint;
  end;
begin
  //lbTable.Caption := GetResourceString(rsTABLE);
  rgbxTypesListes.Items.Clear;
    rgbxTypesListes.Items.Add(rsTBS_ENTRANCE);
    {$IFDEF GROS_MINET}
    ;
    {$ELSE}
    rgbxTypesListes.Items.Add(rsTBS_RESEAUX);
    rgbxTypesListes.Items.Add(rsTBS_SECTEURS);
    {$ENDIF}
    rgbxTypesListes.Items.Add(rsTBS_CODES);
    rgbxTypesListes.Items.Add(rsTBS_TRIPS);
    {$IFDEF GROS_MINET}
    ;
    {$ELSE}
    rgbxTypesListes.Items.Add(rsTBS_ANNOTATIONS);
      {$IFDEF SUPPORT_NOTES_VERSION}
      rgbxTypesListes.Items.Add(rsTBS_RELEASE_NOTES);
      {$endif SUPPORT_NOTES_VERSION}
    rgbxTypesListes.Items.Add(rsTBS_POI);
    {$ENDIF}
    rgbxTypesListes.ItemIndex := 0;
  SetAcHint(acEditItem   , rsDLG_BDD_APPLY_MODIFS);
  SetAcHint(acFind       , rsDLG_BDD_FIND);
  SetAcHint(acSort       , rsDLG_BDD_SORT);
  SetAcHint(acGotoByNumero     , rsDLG_BDD_COTO_BY_NUMERO);
  SetAcHint(acExportListesCSV  , rsDLG_BDD_EXPORT_CSV);
  SetAcHint(acHelpListesSimples, rsDLG_BDD_HELP_LISTES);
  case FModeBDD of
    mbddDISABLED : WU := '';
    mbddENTRANCES: WU := rsDLG_BDD_ADD_ENTREE;
    mbddRESEAUX  : WU := rsDLG_BDD_ADD_RESEAU;
    mbddSECTEURS : WU := rsDLG_BDD_ADD_SECTEUR;
    mbddCODES    : WU := rsDLG_BDD_ADD_CODE;
    mbddEXPES    : WU := rsDLG_BDD_ADD_EXPE;
  else
    WU := '';
  end;
  SetAcHint(acAddItem    , WU);
  case FModeBDD of
    mbddDISABLED : WU := '';
    mbddENTRANCES: WU := rsDLG_BDD_REMOVE_ENTREE;
    mbddRESEAUX  : WU := rsDLG_BDD_REMOVE_RESEAU;
    mbddSECTEURS : WU := rsDLG_BDD_REMOVE_SECTEUR;
    mbddCODES    : WU := rsDLG_BDD_REMOVE_CODE;
    mbddEXPES    : WU := rsDLG_BDD_REMOVE_EXPE;
  else
    WU := '';
  end;
  SetAcHint(acDeleteItem , WU);
end;
//***************** Gestion de la liste ****************************************
procedure TCdrListesSimples.ListerListesSimples(const QModeBDD: TModeBDD);
begin
  FModeBDD := QModeBDD;
  InitHeaderListesSimples();
  case QModeBDD of
    mbddENTRANCES: ListerLesEntrees(FNumeroEntree);
    mbddRESEAUX  : ListerLesReseaux(FNumeroReseau);
    mbddSECTEURS : ListerLesSecteurs(FNumeroSecteur);
    mbddEXPES    : ListerLesExpes(FNumeroExpe);
    mbddCODES    : ListerLesCodes(FNumeroCode);
    mbddANNOTATIONS: ListerLesAnnotations(FNumeroAnnotation);
    mbddPOI        : ListerLesPOI(FNumeroPOI);
    {$IFDEF SUPPORT_NOTES_VERSION}
    mbddRELEASE_NOTES: ListerLesNotesVersion(FNumeroNoteVersion);
    {$endif SUPPORT_NOTES_VERSION}
  end;
  // DONE: bouton de tri actif uniquement pour codes et expés
  acSort.Enabled := (QModeBDD in [mbddCODES, mbddEXPES]);
end;

procedure TCdrListesSimples.lsbListeDblClick(Sender: TObject);
begin
  acEditItem.Execute;
end;

// lister les entrées
procedure TCdrListesSimples.ListerLesEntrees(const QIdx: integer);
var
  i: Integer;
  E: TEntrance;
  EWE: Integer;
begin
  EWE := QIdx;
  lsbListe.Enabled:=False;
  lsbListe.Clear;
  for i:= 0 to FDocumentToporobot.GetNbEntrees() - 1 do
  begin
    E := FDocumentToporobot.GetEntree(i);
    lsbListe.Items.Add(Format('%d: %.0f, %.0f, %.0f - %s', [i, E.eXEntree, E.eYEntree, E.eZEntree, E.eNomEntree]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocumentToporobot.GetNbEntrees() - 1;
    FNumeroEntree:= EWE;
  end;
  lsbListe.ItemIndex := EWE;
  lsbListe.Enabled:=True;
end;
// lister les réseaux
procedure TCdrListesSimples.ListerLesReseaux(const QIdx: integer);
var
  i: Integer;
  R: TReseau;
  EWE: Integer;
begin
  EWE := QIdx;
  lsbListe.Enabled:=False;
  lsbListe.Clear;
  for i:= 0 to FDocumentToporobot.GetNbReseaux - 1 do
  begin
    R := FDocumentToporobot.GetReseau(i);
    lsbListe.Items.Add(Format('%d: %s', [i, R.NomReseau]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocumentToporobot.GetNbReseaux - 1;
    FNumeroReseau := EWE;
  end;
  lsbListe.ItemIndex := EWE;
  lsbListe.Enabled:=True;
end;
// lister les secteurs
procedure TCdrListesSimples.ListerLesSecteurs(const QIdx: integer);
var
  i: Integer;
  S: TSecteur;
  EWE: Integer;
begin
  EWE := QIdx;
  lsbListe.Clear;
  lsbListe.Enabled:=False;

  for i:= 0 to FDocumentToporobot.GetNbSecteurs - 1 do
  begin
    S := FDocumentToporobot.GetSecteur(i);
    lsbListe.Items.Add(Format('%d: %s', [i, S.NomSecteur]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocumentToporobot.GetNbSecteurs - 1;
    FNumeroSecteur := EWE;
  end;
  lsbListe.ItemIndex := EWE;
  lsbListe.Enabled:=True;
end;
procedure TCdrListesSimples.ListerLesAnnotations(const QIdx: integer);
var
  EWE, i: Integer;
  A: TAnnotation;
begin
  lsbListe.Clear;
  if (FDocumentToporobot.GetNbAnnotations() = 0) then exit;
  EWE := QIdx;
  lsbListe.Enabled:=False;


  for i:= 0 to FDocumentToporobot.GetNbAnnotations() - 1 do
  begin
    A := FDocumentToporobot.GetAnnotation(i);
    lsbListe.Items.Add(Format('%d: %d.%d - %.3f, %.3f, %.3f - %d.%d - %s',
                      [i,
                       A.Basepoint.eSerie, A.Basepoint.ePoint,
                       A.Offset.X, A.Offset.Y, A.Offset.Z,
                       A.IdxStyle, A.PosPtDeBase,
                       A.Texte]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocumentToporobot.GetNbAnnotations() - 1;
    FNumeroAnnotation := EWE;
  end;
  lsbListe.ItemIndex := EWE;
  lsbListe.Enabled:=True;
end;

// lister les expés
procedure TCdrListesSimples.ListerLesExpes(const QIdx: integer);
var
  i: Integer;
  E: TExpe;
  EWE: Integer;
begin
  EWE := QIdx;
  lsbListe.Enabled:=False;
  lsbListe.Clear;
  for i:= 0 to FDocumentToporobot.GetNbExpes - 1 do
  begin
    E := FDocumentToporobot.GetExpe(i);
    lsbListe.Items.Add(Format('%d: %.2d/%.2d/%.4d - %s', [E.IDExpe, E.JourExpe, E.MoisExpe, E.AnneeExpe, E.Commentaire]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocumentToporobot.GetNbExpes - 1;
    FNumeroExpe := EWE;
  end;
  lsbListe.ItemIndex := EWE;
  lsbListe.Enabled:=True;
end;
{$IFDEF SUPPORT_NOTES_VERSION}
procedure TCdrListesSimples.ListerLesNotesVersion(const QIdx: integer);
var
  NV: TReleaseNotes;
  EWE, i: Integer;
begin
  lsbListe.Clear;
  if (FDocumentToporobot.GetNbNotesVersion() = 0) then exit;
  EWE := QIdx;
  lsbListe.Enabled:=False;

  for i:= 0 to FDocumentToporobot.GetNbNotesVersion() - 1 do
  begin
    NV := FDocumentToporobot.GetNoteVersion(i);
    lsbListe.Items.Add(Format('%d: %s %s - %s', [i, DatePascalToDateSQL(NV.Date), NV.Author, NV.Description]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocumentToporobot.GetNbCodes - 1;
    FNumeroCode := EWE;
  end;
  lsbListe.ItemIndex := EWE;
  lsbListe.Enabled:=True;
end;
{$endif SUPPORT_NOTES_VERSION}
// lister les codes
procedure TCdrListesSimples.ListerLesCodes(const QIdx: integer);
var
  i: Integer;
  C: TCode;
  EWE: Integer;
begin
  EWE := QIdx;
  lsbListe.Enabled:=False;
  lsbListe.Clear;
  for i:= 0 to FDocumentToporobot.GetNbCodes - 1 do
  begin
    C := FDocumentToporobot.GetCode(i);
    lsbListe.Items.Add(Format('%d: %s', [C.IDCode, C.Commentaire]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocumentToporobot.GetNbCodes - 1;
    FNumeroCode := EWE;
  end;
  lsbListe.ItemIndex := EWE;
  lsbListe.Enabled:=True;
end;
procedure TCdrListesSimples.ListerLesPOI(const QIdx: integer);
var
  i, Nb: integer;
  MyPOI: TPointOfInterest;
begin
  lsbListe.Enabled := false;
  lsbListe.Clear;
  Nb := FDocumentToporobot.GetNbPointsOfInterests();
  if (Nb = 0) then Exit;
  for i := 0 to Nb - 1 do
  begin
    MyPOI := FDocumentToporobot.GetPointOfInterest(i);
    lsbListe.Items.Add(Format('%d.%d: %s', [MyPOI.Serie, MyPOI.Station, MyPOI.Description]));
  end;

  lsbListe.Enabled := True;
end;

//******************************************************************************
procedure TCdrListesSimples.InitHeaderListesSimples();
const
  LC_ID_NUMERIQUES    = 80;
  LC_ID_SERIE_STATION = 110;
var
 ht: THeaderSection;
 FNbItems: Integer;
 miou: String;
 procedure AjouterTitreColonne(const Titre: string; const LGMin, LG: integer);
 begin
   ht := hcColsTitres.Sections.Add;
   ht.Text := Titre;
   ht.MinWidth := LGMin;
   ht.Width    := LG;
 end;
 procedure AjouterTitreColonneRes(const RS: string; const LGMin, LG: integer);
 begin
   AjouterTitreColonne(GetResourceString(RS), LGMin, LG);
 end;
begin
  // purge des titres des headers
  hcColsTitres.Sections.Clear;
  case FModeBDD of
    mbddENTRANCES:
      begin
        miou := GetResourceString(rsTBS_ENTRANCE);
        FNbItems          := FDocumentToporobot.GetNbEntrees;
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_ENTREES_ID, LC_ID_NUMERIQUES, LC_ID_NUMERIQUES);
          AjouterTitreColonneRes(rsSELECT_LISTE_ENTREES_NOM, 150, 400);
          AjouterTitreColonneRes(rsSELECT_LISTE_ENTREES_REF, 80, 80);
          AjouterTitreColonneRes('IDTerrain', 160, 160);
          AjouterTitreColonneRes(rsSELECT_LISTE_ENTREES_X, 80, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_ENTREES_Y, 80, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_ENTREES_Z, 80, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_OBSERV, 400, 400);
        end;
      end;
    mbddRESEAUX:
      begin
        miou := GetResourceString(rsTBS_RESEAUX);
        FNbItems := FDocumentToporobot.GetNbReseaux;
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_RESEAUX_ID, LC_ID_NUMERIQUES, LC_ID_NUMERIQUES);
          AjouterTitreColonneRes(rsSELECT_LISTE_RESEAUX_COLOR, 60, 60);
          AjouterTitreColonneRes(rsSELECT_LISTE_RESEAUX_NOM, 150, 300);
          AjouterTitreColonneRes(rsSELECT_LISTE_OBSERV, 400, 400);
        end;
      end;
    mbddSECTEURS:
      begin
        miou := GetResourceString(rsTBS_SECTEURS);
        FNbItems := FDocumentToporobot.GetNbSecteurs;
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_SECTEURS_ID, LC_ID_NUMERIQUES, LC_ID_NUMERIQUES);
          AjouterTitreColonneRes(rsSELECT_LISTE_SECTEURS_COLOR, 60, 60);
          AjouterTitreColonneRes(rsSELECT_LISTE_SECTEURS_NOM, 400, 400);
        end;
      end;
    mbddCODES:
      begin
        miou := GetResourceString(rsTBS_CODES);
        FNbItems := FDocumentToporobot.GetNbCodes;
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_CODES_ID, LC_ID_NUMERIQUES, LC_ID_NUMERIQUES);
          AjouterTitreColonneRes(rsSELECT_LISTE_CODES_AZIMUTS, 100, 220);
          AjouterTitreColonneRes(rsSELECT_LISTE_CODES_CORR_AZIMUTS, 80, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_CODES_PENTES, 100, 260);
          AjouterTitreColonneRes(rsSELECT_LISTE_CODES_CORR_PENTES, 80, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_CODES_OBS, 150, 300);
        end;
      end;
    mbddEXPES:
      begin
        miou := GetResourceString(rsTBS_TRIPS);
        FNbItems := FDocumentToporobot.GetNbExpes;
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_EXPES_ID, LC_ID_NUMERIQUES, LC_ID_NUMERIQUES);
          AjouterTitreColonneRes(rsSELECT_LISTE_EXPES_COULEUR, 80, 80);
          AjouterTitreColonneRes(rsSELECT_LISTE_EXPES_DATE, 90, 90);
          AjouterTitreColonneRes(rsSELECT_LISTE_EXPES_OPERATEUR_TOPO, 100, 250);
          AjouterTitreColonneRes(rsSELECT_LISTE_EXPES_CLUB_SPELEO, 100, 250);
          AjouterTitreColonneRes(rsSELECT_LISTE_EXPES_DECLINAISON, 100, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_EXPES_OBS, 150, 300);
        end;
      end;
    mbddANNOTATIONS:
      begin
        miou := GetResourceString(rsTBS_ANNOTATIONS);
        FNbItems := FDocumentToporobot.GetNbAnnotations();
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_IDX, 80, 80);
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_SERIE_PT, 120, 120);
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_OFFSET_X, 100, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_OFFSET_Y, 100, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_OFFSET_Z, 100, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_IDX_STYLE, 40, 40);
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_ALIGNMENT, 40, 40);
          AjouterTitreColonneRes(rsSELECT_LISTE_ANNOTATIONS_TEXT, 150, 250);
        end;
      end;
    {$IFDEF SUPPORT_NOTES_VERSION}
    mbddRELEASE_NOTES:
      begin
        miou := GetResourceString(rsTBS_ANNOTATIONS);
        FNbItems := FDocumentToporobot.GetNbNotesVersion();
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_RELEASE_NOTE_IDX , 80, 80);
          AjouterTitreColonneRes(rsSELECT_LISTE_RELEASE_NOTE_DATE, 160, 160);
          AjouterTitreColonneRes(rsSELECT_LISTE_RELEASE_NOTE_AUTHOR, 250, 250);
          AjouterTitreColonneRes(rsSELECT_LISTE_RELEASE_NOTE_DESCRIPTION, 250, 600);
        end;
      end;
    {$endif SUPPORT_NOTES_VERSION}
    mbddPOI:
      begin
        miou := GetResourceString(rsTBS_POI);
        FNbItems := FDocumentToporobot.GetNbPointsOfInterests();
        lbNbreElements.Caption := Format('%s (%d items)', [miou, FNbItems]);
        with hcColsTitres do begin
          AjouterTitreColonneRes(rsSELECT_LISTE_POI_IDX, 80, 80);
          AjouterTitreColonneRes(rsSELECT_LISTE_POI_SERIE_POINT, 120, 120);
          AjouterTitreColonneRes(rsSELECT_LISTE_POI_COULEUR, 50, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_POI_LBLTERRAIN, 150, 100);
          AjouterTitreColonneRes(rsSELECT_LISTE_POI_DESCRIPTION, 666, 100);
        end;
      end;
  else
    pass;
  end;
end;

procedure TCdrListesSimples.lsbListeDrawItem(Control: TWinControl;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
const
    Q4  = 4; // compensation du décalage entre le header et la liste
    mg  = 1;
var
    C, WU: TColor;
    m: integer;

    rs: TReseau;
    es: TEntrance;
    cs: TCode;
    ss: TExpe;
    miou: string;
    sc: TSecteur;
    aa: TAnnotation;
    ns: TReleaseNotes;
    pp: TPointOfInterest;
    procedure DessineFiletColonne(const TB: integer); inline;
    begin
      lsbListe.Canvas.Line(TB, ARect.Top, TB, ARect.Bottom);
    end;
    procedure DessineRectangleColore(const QBG, PC, BC: TColor; const L, R, T, B: integer);
    var
      QR: TRect;
    begin
      lsbListe.canvas.Pen.Color   := PC;
      lsbListe.canvas.Brush.Color := BC;
      QR.Left     := L;
      QR.Right    := R;
      QR.Top      := T;
      QR.Bottom   := B;
      lsbListe.canvas.Rectangle(QR);
      // et on restaure l'ancienne couleur
      lsbListe.Canvas.Brush.Color := QBG;
      lsbListe.canvas.Pen.Color:=clSilver;
    end;
    // bg = couleur de fond; tc= couleur du texte
    procedure DessineItem(const bg,tc: TColor);
    VAR
      HS: THeaderSection;
      QR: TRect;
    begin
      case FModeBDD of
        mbddENTRANCES:
          begin
            with lsbListe do
            begin
              Canvas.FillRect(ARect);
              Canvas.Brush.Color:=bg;
              Canvas.Font.Color :=tc;
              Canvas.Pen.Color  :=clSilver; // pour les filets
              HS := hcColsTitres.Sections.Items[0];  // ID entrée
              canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d',[Index + 1]));

              HS := hcColsTitres.Sections.Items[1];  // Nom entrée
              QR := Rect(HS.Left, ARect.Top + mg, HS.Right - 8, ARect.Bottom - mg);
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextRect(QR, HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(es.eNomEntree));

              HS := hcColsTitres.Sections.Items[2];
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, Format('%d.%d',[es.eRefSer, es.eRefSt]));

              HS := hcColsTitres.Sections.Items[3];
              QR := Rect(HS.Left, ARect.Top + mg, HS.Right - 8, ARect.Bottom - mg);
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextRect(QR, HS.Left + 4, ARect.Top+1, es.eIDTerrain);

              HS := hcColsTitres.Sections.Items[4];
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, FormatterNombreAvecSepMilliers(es.eXEntree));

              HS := hcColsTitres.Sections.Items[5];
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, FormatterNombreAvecSepMilliers(es.eYEntree));

              HS := hcColsTitres.Sections.Items[6];
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, FormatterNombreAvecSepMilliers(es.eZEntree));

              HS := hcColsTitres.Sections.Items[7];
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, es.eObserv);
              DessineFiletColonne(HS.Right);

            end;
          end;
        mbddRESEAUX:
          begin
            with lsbListe do
            begin
              Canvas.FillRect(ARect);
              canvas.Pen.Color:=clSilver;
              Canvas.Font.Color :=tc;
              HS := hcColsTitres.Sections.Items[0];  // ID réseau
              canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d',[Index]));
              HS := hcColsTitres.Sections.Items[1];  // Couleur réseau
              DessineFiletColonne(HS.Left - Q4);
              DessineRectangleColore(bg, clBlack, rs.ColorReseau, HS.Left, HS.Right - 8, ARect.Top + mg, ARect.Bottom - mg);
              HS := hcColsTitres.Sections.Items[2];  // Nom réseau
              QR := Rect(HS.Left, ARect.Top + mg, HS.Right - 8, ARect.Bottom - mg);
              DessineFiletColonne(HS.Left - Q4);
              Canvas.Font.Color :=tc;
              canvas.TextRect(QR, HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(rs.NomReseau));
              HS := hcColsTitres.Sections.Items[3];  // Obs réseau
              DessineFiletColonne(HS.Left - Q4);
              Canvas.Font.Color :=tc;
              canvas.TextOut(HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(rs.ObsReseau));

            end;
          end;
         mbddSECTEURS:
          begin
            with lsbListe do
            begin
              Canvas.FillRect(ARect);
              canvas.Pen.Color:=clSilver;
              Canvas.Font.Color :=tc;
              HS := hcColsTitres.Sections.Items[0];  // ID réseau
              canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d',[Index]));
              HS := hcColsTitres.Sections.Items[1];  // Couleur secteur
              DessineFiletColonne(HS.Left - Q4);
              DessineRectangleColore(bg, clBlack, sc.CouleurSecteur, HS.Left, HS.Right - 8, ARect.Top + mg, ARect.Bottom - mg);
              HS := hcColsTitres.Sections.Items[2];  // Nom secteur
              QR := Rect(HS.Left, ARect.Top + mg, HS.Right - 8, ARect.Bottom - mg);
              DessineFiletColonne(HS.Left - Q4);
              Canvas.Font.Color  := tc;
              canvas.TextRect(QR, HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(sc.NomSecteur));
            end;
          end;
        mbddCODES:
          with lsbListe do begin
            begin
              Canvas.FillRect(ARect);
              HS := hcColsTitres.Sections.Items[0];  // Nom réseau
              Canvas.Brush.Color:=bg;
              Canvas.Font.Color :=tc;
              canvas.Pen.Color:=clSilver;

              canvas.TextOut(HS.Left + 4  , ARect.Top+1,  Format('%d', [cs.IDCode]));
              HS := hcColsTitres.Sections.Items[1];  // az
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, ExplainCodeAzimut(cs)); //Format('%.0f', [cs.GradAz]));
              HS := hcColsTitres.Sections.Items[2];  // p
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, Format('%.3f', [cs.ParamsFuncCorrAz.Co]));
              HS := hcColsTitres.Sections.Items[3];  // p
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, ExplainCodePente(cs)); //Format('%.0f', [cs.Gradinc]));
              HS := hcColsTitres.Sections.Items[4];  // p
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, Format('%.3f', [cs.ParamsFuncCorrInc.Co]));
              HS := hcColsTitres.Sections.Items[5];  // Commentaires
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(cs.Commentaire));
            end;
          end;
        mbddEXPES:
          with lsbListe do begin
            begin
              try
                miou := DateToStr(GetSecuredDate(ss.AnneeExpe,ss.MoisExpe,ss.JourExpe));
              except
                miou := '01/01/2000';
              end;
              Canvas.FillRect(ARect);
              canvas.Pen.Color  :=clSilver;
              Canvas.Font.Color :=tc;

              HS := hcColsTitres.Sections.Items[0];  // ID expé
              canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d',[ss.IDExpe]));
              HS := hcColsTitres.Sections.Items[1];  // Couleur expé
              DessineFiletColonne(HS.Left - Q4);
              // couleur de l'expé
              DessineRectangleColore(bg, clBlack, FPalette256.GetColorByIndex(ss.Couleur), HS.Left, HS.Left + 32, ARect.Top + mg, ARect.Bottom - mg);
              Canvas.TextOut(HS.Left + 32 + 4, ARect.Top+1, Format('%d',[ss.Couleur]));

              HS := hcColsTitres.Sections.Items[2];  // date
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, miou);

              HS := hcColsTitres.Sections.Items[3];  // opérateur (ancien Speleometre)
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(ss.Operateur));

              HS := hcColsTitres.Sections.Items[4];  // club (ancien spéléographe)
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(ss.ClubSpeleo));

              HS := hcColsTitres.Sections.Items[5];  // déclinaison
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, Format('%.3f',[ss.Declinaison]));

              HS := hcColsTitres.Sections.Items[6];  // commentaires
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(ss.Commentaire));
            end;
          end;
        mbddANNOTATIONS:
          begin
            with lsbListe do begin
              Canvas.FillRect(ARect);
              HS := hcColsTitres.Sections.Items[0];  // idx
              Canvas.Brush.Color:=bg;
              Canvas.Font.Color :=tc;
              canvas.Pen.Color:=clSilver;
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, Format('%d', [Index]));
              HS := hcColsTitres.Sections.Items[1];  // basepoint
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, Format('%d.%d', [aa.Basepoint.eSerie, aa.Basepoint.ePoint]));
              HS := hcColsTitres.Sections.Items[2];  // offset
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, Format('%.3f', [aa.Offset.X]));
              HS := hcColsTitres.Sections.Items[3];  // offset
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, Format('%.3f', [aa.Offset.Y]));
              HS := hcColsTitres.Sections.Items[4];  // offset
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, Format('%.3f', [aa.Offset.Z]));
              HS := hcColsTitres.Sections.Items[5];  // style
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, Format('%d', [aa.IdxStyle]));
              HS := hcColsTitres.Sections.Items[6];  // ancrage texte
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, Format('%d', [aa.PosPtDeBase]));
              HS := hcColsTitres.Sections.Items[7];  // texte
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, aa.Texte);
            end;
          end;
        mbddRELEASE_NOTES:
          begin
            with lsbListe do begin
              Canvas.FillRect(ARect);
              HS := hcColsTitres.Sections.Items[0];  // idx
              Canvas.Brush.Color:=bg;
              Canvas.Font.Color :=tc;
              canvas.Pen.Color:=clSilver;
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, Format('%d', [Index]));
              HS := hcColsTitres.Sections.Items[1];  // date
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, DatePascalToDateSQL(ns.Date));
              HS := hcColsTitres.Sections.Items[2];  // auteur
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, ns.Author);
              HS := hcColsTitres.Sections.Items[3];  // descro
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, ns.Description);
            end;
          end;
         mbddPOI:
          begin
            with lsbListe do begin
              Canvas.FillRect(ARect);
              HS := hcColsTitres.Sections.Items[0];  // idx
              Canvas.Brush.Color := bg;
              Canvas.Font.Color  := tc;
              canvas.Pen.Color:=clSilver;
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, Format('%d', [Index]));
              HS := hcColsTitres.Sections.Items[1];  // série/point
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4  , ARect.Top+1, Format('%d.%d', [PP.Serie, PP.Station]));
              HS := hcColsTitres.Sections.Items[2];  // couleur
              DessineFiletColonne(HS.Left - Q4);
              DessineRectangleColore(bg, clBlack, PP.Couleur, HS.Left, HS.Right - 8, ARect.Top + mg, ARect.Bottom - mg);
              HS := hcColsTitres.Sections.Items[3];  // IDTerrain
              Canvas.Brush.Color:=bg;
              canvas.Pen.Color:=clSilver;
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, PP.LabelTerrain);
              HS := hcColsTitres.Sections.Items[4];  // IDTerrain
              DessineFiletColonne(HS.Left - Q4);
              canvas.TextOut(HS.Left + 4, ARect.Top+1, PP.Description);
            end;
          end;
        else
          pass;
        end; //case FModeSelection of
    end;
begin
  try
    case FModeBDD of
      mbddENTRANCES: es := FDocumentToporobot.GetEntree(Index);
      mbddSECTEURS : sc := FDocumentToporobot.GetSecteur(Index);
      mbddRESEAUX  : rs := FDocumentToporobot.GetReseau(Index);
      mbddCODES    : cs := FDocumentToporobot.GetCode(Index);
      mbddEXPES    : ss := FDocumentToporobot.getExpe(Index);
      mbddANNOTATIONS    : aa := FDocumentToporobot.GetAnnotation(Index);
      mbddPOI            : pp := FDocumentToporobot.GetPointOfInterest(Index);
      {$IFDEF SUPPORT_NOTES_VERSION}
      mbddRELEASE_NOTES  : ns := FDocumentToporobot.GetNoteVersion(Index);
      {$endif SUPPORT_NOTES_VERSION}
    end; //case FModeSelection of
    with lsbListe do
    begin
      WU := IIF((FModeBDD in [mbddCODES, mbddEXPES]) and (Index = 0), clGray, clWhite);
      canvas.brush.color := WU;
      DessineItem(WU, clBlack);
      //affichage lorsque la ligne est sélectionnée
      if (odSelected in state) then
      begin
        canvas.brush.color:=clBlue;
        DessineItem(clBlue, WU);
      end;
    end;
  except
  end;
end;

procedure TCdrListesSimples.rgbxTypesListesSelectionChanged(Sender: TObject);
begin
  {$IFDEF GROS_MINET}
  case rgbxTypesListes.ItemIndex of
    0: ListerListesSimples(mbddENTRANCES);
    //1: ListerListesSimples(mbddRESEAUX);
    //2: ListerListesSimples(mbddSECTEURS);
    1: ListerListesSimples(mbddCODES);
    2: ListerListesSimples(mbddEXPES);
  else
    ;
  end;
  {$ELSE}
  case rgbxTypesListes.ItemIndex of
    0: ListerListesSimples(mbddENTRANCES);
    1: ListerListesSimples(mbddRESEAUX);
    2: ListerListesSimples(mbddSECTEURS);
    3: ListerListesSimples(mbddCODES);
    4: ListerListesSimples(mbddEXPES);
    5: ListerListesSimples(mbddANNOTATIONS);
    6: ListerListesSimples(mbddPOI)
    {$IFDEF SUPPORT_NOTES_VERSION}
    6: ListerListesSimples(mbddRELEASE_NOTES);
    {$endif SUPPORT_NOTES_VERSION}
  else
    ;
  end;
  {$ENDIF}
end;
end.

