unit CdrListeGroupes;
// 29/07/2015: Mise en surbrillance du groupe courant
// 17/10/2015: Refonte des boutons + ajout pop up pour la liste

{$INCLUDE CompilationParameters.inc}

interface

uses
  GHCD_Types,
  {$IFDEF LANGUAGE_FRENCH}
    UnitMessages_fr,
  {$ENDIF}
   Graphics, UnitDocDessin, GeneralFunctions,
   CallDialogs, cdrdessincanvasBGRA, LCLType,
   Classes, SysUtils, FileUtil, Forms, Controls,
   StdCtrls, ExtCtrls,
   ComCtrls,
   ActnList, Menus, types;


type

  { TCadreListeGroupes }

  TCadreListeGroupes = class(TFrame)
    acNewGroupe: TAction;
    acDefCurrentGroupe: TAction;
    acGroupeVisible: TAction;
    acGroupeVerrouille: TAction;
    acGroupeDecale: TAction;
    acMasquerTousGroupes: TAction;
    acBasculerVisibiliteGroupes: TAction;
    acSupprimerObjetsGroupe: TAction;
    acRendreVisiblesGroupesSelected: TAction;
    acSetCurrentGroupe: TAction;
    ActionList1: TActionList;
    btnAddGroupe: TButton;
    btnInvertChkGroupes: TButton;
    btnUnvisibleAllGroupes: TButton;
    Button2: TButton;
    chkDecalageActif: TCheckBox;
    chkLocked: TCheckBox;
    chkVisible: TCheckBox;
    editFindingGroupe: TEdit;
    hcColonnes: THeaderControl;
    Label1: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    lbColorGroupe: TStaticText;
    lbIDGroupe: TStaticText;
    lbNbGroupes: TLabel;
    lbNomGroupe: TStaticText;
    lbZOrder: TStaticText;
    lbNbObjets: TStaticText;
    lsbGroupes: TListBox;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    Panel2: TPanel;
    popupListeGroupes: TPopupMenu;
    procedure acBasculerVisibiliteGroupesExecute(Sender: TObject);
    procedure acDefCurrentGroupeExecute(Sender: TObject);
    procedure acGroupeDecaleExecute(Sender: TObject);
    procedure acGroupeVerrouilleExecute(Sender: TObject);
    procedure acGroupeVisibleExecute(Sender: TObject);
    procedure acMasquerTousGroupesExecute(Sender: TObject);
    procedure acNewGroupeExecute(Sender: TObject);
    procedure acRendreVisiblesGroupesSelectedExecute(Sender: TObject);
    procedure btnDeleteObjetsGroupeClick(Sender: TObject);
    procedure btnRendreVisiblesGrpSelectClick(Sender: TObject);
    procedure chkDecalageActifChange(Sender: TObject);
    procedure chkDecalageActifClick(Sender: TObject);
    procedure chkLockedChange(Sender: TObject);
    procedure chkLockedClick(Sender: TObject);
    procedure chkVisibleChange(Sender: TObject);
    procedure chkVisibleClick(Sender: TObject);
    procedure editFindingGroupeChange(Sender: TObject);
    procedure lsbGroupesClick(Sender: TObject);
    procedure lsbGroupesDblClick(Sender: TObject);
    procedure lsbGroupesDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
  private
    { private declarations }
    FGroupesModifiables: boolean;
    FActiveGroupeIdx: integer;
    FDocDessin: TDocumentDessin;
    FCdrDessin: TCadreDessinBGRA;
    procedure CreerNouveauGroupe();
    function FindIdxGroupeFoundByText(const S: string): integer;
    procedure InvertFlagGroupe(const QIdxGroupe: integer;
                               const QFlag: TFlagGroupe);
    procedure InvertVisibiliteGroupes();
    procedure ListerLesGroupes(const IdxGr: integer);
    procedure MasquerTousGroupes();
    procedure PutGroupeInForm(const Idx: integer);
    procedure RendreVisiblesGroupesSelected();
    procedure SetCurrentGroupe();
  public
    { public declarations }
    procedure Initialiser(const B: boolean);
    procedure SetGroupesModifiables(const B: boolean);
    function  Rafraichir(const CdrDessin: TCadreDessinBGRA): boolean;
    procedure SetActiveGroupeIdx(const I: integer);
  end;

implementation

{$R *.lfm}

{ TCadreListeGroupes }


procedure TCadreListeGroupes.SetCurrentGroupe();
begin
  if (lsbGroupes.Items.Count > 0) then
  begin
    FActiveGroupeIdx := lsbGroupes.ItemIndex;
    FCdrDessin.SetCurrentGroupeByIdx(FActiveGroupeIdx);
    FCdrDessin.RedessinEcran(false);//Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
    lsbGroupes.Invalidate;
  end;
end;

procedure TCadreListeGroupes.SetGroupesModifiables(const B: boolean);
begin
  FGroupesModifiables := B;
end;

procedure TCadreListeGroupes.acDefCurrentGroupeExecute(Sender: TObject);
begin
  SetCurrentGroupe();
end;



procedure TCadreListeGroupes.acGroupeDecaleExecute(Sender: TObject);
begin
  InvertFlagGroupe(lsbGroupes.ItemIndex, fgDO_OFFSET);
end;

procedure TCadreListeGroupes.acGroupeVerrouilleExecute(Sender: TObject);
begin
  InvertFlagGroupe(lsbGroupes.ItemIndex, fgLOCKED);
end;

procedure TCadreListeGroupes.acGroupeVisibleExecute(Sender: TObject);
begin
  InvertFlagGroupe(lsbGroupes.ItemIndex, fgVISIBLE);
end;

procedure TCadreListeGroupes.acBasculerVisibiliteGroupesExecute(Sender: TObject);
begin
  InvertVisibiliteGroupes();
end;

procedure TCadreListeGroupes.acMasquerTousGroupesExecute(Sender: TObject);
begin
  MasquerTousGroupes();
end;

procedure TCadreListeGroupes.acNewGroupeExecute(Sender: TObject);
begin
  CreerNouveauGroupe();
end;

procedure TCadreListeGroupes.acRendreVisiblesGroupesSelectedExecute(
  Sender: TObject);
begin
  RendreVisiblesGroupesSelected;
end;
procedure TCadreListeGroupes.CreerNouveauGroupe();
var
  GP: TGroupeEntites;
  QDoSetThisGroupeAsCurrent: boolean;
begin
  // le groupe sera initialisé dans EditerGroupe
  // nouveau groupe
  if (EditerGroupe(GP, medCREATION, '', QDoSetThisGroupeAsCurrent)) then
  begin
    GP.IDGroupeEntites := FDocDessin.GetMaxIdxGroupe(True);
    GP.ZOrder          := -5000; // remonte le nouveau groupe en tête de liste
    GP.Displayed       := True;
    FDocDessin.AddGroupe(GP, True);
    FDocDessin.TrierGroupesByZOrder();
    ListerLesGroupes(-1);
    if (QDoSetThisGroupeAsCurrent) then SetCurrentGroupe();
    FCdrDessin.ActualiserListeDesGroupes();
  end;
end;

procedure TCadreListeGroupes.MasquerTousGroupes();
var
  i: Integer;
  GP: TGroupeEntites;
begin
  for i := 0 to lsbGroupes.Count - 1 do
  begin
    GP := FDocDessin.GetGroupeByIdx(i);
    GP.Displayed  := false;
    FDocDessin.PutGroupe(i, GP);
  end;
  ListerLesGroupes(lsbGroupes.ItemIndex);
  FCdrDessin.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
end;




procedure TCadreListeGroupes.InvertVisibiliteGroupes();
var
  i: Integer;
  GP: TGroupeEntites;
begin
  for i := 0 to lsbGroupes.Count - 1 do
  begin
    GP := FDocDessin.GetGroupeByIdx(i);
    GP.Displayed  := not GP.Displayed;
    FDocDessin.PutGroupe(i, GP);
  end;
  ListerLesGroupes(lsbGroupes.ItemIndex);
  FCdrDessin.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
end;

// active l'affichage des groupes sélectionnés
procedure TCadreListeGroupes.RendreVisiblesGroupesSelected();
var
  EWE: TGHStringArray;
  LS: TStringList;
  i, Nb: Integer;
  WU: Integer;
  Grp: TGroupeEntites;
  QIdx: Integer;
begin
  EWE := split(editFindingGroupe.Text, ';');
  LS := TStringList.Create;
  try
    LS.Clear;
    Nb := MAX_SIZE_PARAM_ARRAY;
    for i := 0 to Nb - 1 do
    begin
      WU := StrToIntDef(Trim(EWE[i]), -1);
      if (WU >= 0) then LS.Add(format('%d', [WU]));
    end;
    nb := LS.Count;
    if (Nb > 0) then
    begin
      for i := 0 to Nb - 1 do
      begin
        try
          WU := StrToInt(LS.Strings[i]);
          QIdx := FDocDessin.GetInternalIdxGroupe(WU);
          Grp := FDocDessin.GetGroupeByIdx(QIdx);
          Grp.Displayed := True;
          FDocDessin.PutGroupe(QIdx, Grp);
        except
          ;
        end;
      end;
      ListerLesGroupes(0);
      FCdrDessin.Vue.Invalidate;
    end;
  finally
    LS.Free;
  end;
end;

procedure TCadreListeGroupes.btnRendreVisiblesGrpSelectClick(Sender: TObject);

begin
  RendreVisiblesGroupesSelected;
end;

procedure TCadreListeGroupes.chkDecalageActifChange(Sender: TObject);
begin

end;
procedure TCadreListeGroupes.InvertFlagGroupe(const QIdxGroupe: integer;
                                              const QFlag: TFlagGroupe);
var
  Grp: TGroupeEntites;
begin
  Grp := FDocDessin.GetGroupeByIdx(QIdxGroupe);
  case QFlag of
    fgVISIBLE   : Grp.Displayed     := Not Grp.Displayed;
    fgLOCKED    : Grp.Locked        := Not Grp.Locked;
    fgDO_OFFSET : Grp.DecalageActif := Not grp.DecalageActif;
  end;
  FDocDessin.PutGroupe(QIdxGroupe, Grp);
  ListerLesGroupes(lsbGroupes.ItemIndex);
  FCdrDessin.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
end;

procedure TCadreListeGroupes.btnDeleteObjetsGroupeClick(Sender: TObject);
var
  IdxGr: Integer;
  MyGroupe: TGroupeEntites;
  WU: String;
begin
  IdxGr := lsbGroupes.ItemIndex;
  if (IdxGr >= 0)then
  begin
    MyGroupe := FDocDessin.GetGroupeByIdx(IdxGr);
    WU := Format('Supprimer les objets du groupe %d - %s', [MyGroupe.IDGroupeEntites, MyGroupe.NomGroupe]);
    if (QuestionOuiNon(WU)) then
    begin
      FDocDessin.SupprimerObjetsGroupe(MyGroupe);
      FCdrDessin.RedessinEcran(false);
    end;
  end;
end;



procedure TCadreListeGroupes.chkDecalageActifClick(Sender: TObject);
var
  n: Integer;
  EWE: TGroupeEntites;
begin
  n := lsbGroupes.ItemIndex;
  if (n < 0) then Exit;
  EWE := FDocDessin.GetGroupeByIdx(n);
  EWE.DecalageActif := chkDecalageActif.Checked;
  FDocDessin.PutGroupe(n, EWE);
  ListerLesGroupes(n);
end;

procedure TCadreListeGroupes.chkLockedChange(Sender: TObject);
begin

end;




procedure TCadreListeGroupes.chkLockedClick(Sender: TObject);
var
  n: Integer;
  EWE: TGroupeEntites;
begin
  n := lsbGroupes.ItemIndex;
  if (n < 0) then Exit;
  EWE := FDocDessin.GetGroupeByIdx(n);
  EWE.Locked := chkLocked.Checked;
  FDocDessin.PutGroupe(n, EWE);
  ListerLesGroupes(n);
end;

procedure TCadreListeGroupes.chkVisibleChange(Sender: TObject);
begin

end;

procedure TCadreListeGroupes.chkVisibleClick(Sender: TObject);
var
  n: Integer;
  EWE: TGroupeEntites;
begin
  n := lsbGroupes.ItemIndex;
  if (n < 0) then Exit;
  EWE := FDocDessin.GetGroupeByIdx(n);
  EWE.Displayed := chkVisible.Checked;
  FDocDessin.PutGroupe(n, EWE);
  ListerLesGroupes(n);
end;

procedure TCadreListeGroupes.editFindingGroupeChange(Sender: TObject);
var
  WU, P, n: Integer;
  EWE: String;
begin
  editFindingGroupe.Color := clWhite;
  // un signe égal en tête > on recherche d'après le numéro de groupe
  EWE := trim(editFindingGroupe.Text);
  P := pos('=', EWE);
  if (P = 1) then // pour une recherche sur no de groupe, le signe = doit être placé en tête.
  begin
    System.Delete(EWE, 1, 1); // on vire le égal
    n := StrToIntDef(EWE, -1);
    WU := FDocDessin.GetInternalIdxGroupe(n);
    if (WU > 0) then lsbGroupes.ItemIndex := WU
                else  editFindingGroupe.Color := clRed;
  end
  else // recherche sur la descro du groupe
  begin
    WU := FindIdxGroupeFoundByText(EWE);
    if (WU > 0) then lsbGroupes.ItemIndex := WU
                else editFindingGroupe.Color := clRed;
  end;
end;

function TCadreListeGroupes.Rafraichir(const CdrDessin: TCadreDessinBGRA): boolean;
begin
  Result := false;
  FCdrDessin := CdrDessin;
  FDocDessin := FCdrDessin.GetDocDessin;
  ListerLesGroupes(0);
  PutGroupeInForm(0);
end;

procedure TCadreListeGroupes.SetActiveGroupeIdx(const I: integer);
begin
  FActiveGroupeIdx := I;
end;

procedure TCadreListeGroupes.ListerLesGroupes(const IdxGr: integer);
var
  i, n: Integer;
  EWE: TGroupeEntites;
  WU: Integer;
begin
  acBasculerVisibiliteGroupes.Caption     := GetResourceString(rsCDR_LST_GRP_BASC_VISI_GROUPES);
  acDefCurrentGroupe.Caption              := GetResourceString(rsCDR_LST_GRP_DEF_GROUPE_COURANT);
  acNewGroupe.Caption                     := GetResourceString(rsCDR_LST_GRP_NOUVEAU_GROUPE);
  acGroupeDecale.Caption                  := GetResourceString(rsCDR_LST_GRP_DECALAGE_GROUPE);
  acGroupeVerrouille.Caption              := GetResourceString(rsCDR_LST_GRP_LOCK_GROUPE);
  acGroupeVisible.Caption                 := GetResourceString(rsCDR_LST_GRP_VISIBILITE_GROUPE);
  acMasquerTousGroupes.Caption            := GetResourceString(rsCDR_LST_GRP_MASQUER_TOUS_GROUPES);
  acRendreVisiblesGroupesSelected.Caption := GetResourceString(rsCDR_LST_GRP_SELECT_GRP_VISIBLE);
  acSupprimerObjetsGroupe.Caption         := GetResourceString(rsCDR_LST_GRP_DELETE_OBJ_GROUPE);
  lsbGroupes.Visible := false;
  lsbGroupes.Clear;
  n := FDocDessin.GetNbGroupes();
  WU := IIF(IdxGr < 0, n-1, IdxGr);
  for i := 0 to n-1 do
  begin
    EWE := FDocDessin.GetGroupeByIdx(i);
    lsbGroupes.Items.Add(Format('%.3d (%.0f) - %s', [EWE.IDGroupeEntites, EWE.ZOrder, EWE.NomGroupe]));
  end;
  lsbGroupes.ItemIndex := WU;
  lsbGroupes.Visible := true;
  lbNbGroupes.Caption := Format('%d groupes', [WU]);
  acNewGroupe.Visible := FGroupesModifiables;
  acDefCurrentGroupe.Visible := FGroupesModifiables;
  FCdrDessin.Vue.Invalidate;
end;

procedure TCadreListeGroupes.lsbGroupesClick(Sender: TObject);
begin
  PutGroupeInForm(lsbGroupes.ItemIndex);
end;

procedure TCadreListeGroupes.lsbGroupesDblClick(Sender: TObject);
var
  GP: TGroupeEntites;
  QIdx: Integer;
  QDoSetThisGroupeAsCurrent: boolean;
begin
  if (not FGroupesModifiables) then Exit;
  QIdx := lsbGroupes.ItemIndex;
  if (QIdx >=0) then
  begin
    GP := FDocDessin.GetGroupeByIdx(QIdx);
    if (EditerGroupe(GP, medMODIF, '', QDoSetThisGroupeAsCurrent)) then
    begin
      FDocDessin.PutGroupe(QIdx, GP);
      FDocDessin.TrierGroupesByZOrder();
      FCdrDessin.ActualiserListeDesGroupes();
      if (QDoSetThisGroupeAsCurrent) then SetCurrentGroupe();
    end;
  end;
  ListerLesGroupes(QIdx);
end;

// La factorisation de ce code, utilisé en deux endroits du projet, est très difficile.
procedure TCadreListeGroupes.lsbGroupesDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
const
  Q4  = 4; // compensation du décalage entre le header et la liste
  mg  = 1;
var
  MyGRP: TGroupeEntites;
  WU: TColor;
  procedure DessineCoche(const TB: integer; const IsChecked: boolean; const bg: TColor);
  var
    QR: TRect;
    H: Integer;
  begin
    lsbGroupes.Canvas.Pen.Style   := psSolid;
    lsbGroupes.Canvas.Brush.Style := bsSolid;
    lsbGroupes.Canvas.Pen.Color   := clBlack;

    QR.Left   := ARect.Left   + TB + 2;
    QR.Top    := ARect.Top    + 1;
    QR.Bottom := ARect.Bottom - 1;
    H := QR.Bottom - QR.Top;
    QR.Right  := QR.Left + H;
    lsbGroupes.Canvas.Brush.Color := clWhite;
    if (IsChecked) then lsbGroupes.Canvas.Brush.Color := clRed;
    lsbGroupes.Canvas.Rectangle(QR);
    lsbGroupes.Canvas.Brush.Color := bg;
  end;
  procedure DessineRectCouleur(const TB: integer; const W: integer;const Coul: TColor; const bg: TColor);
  var
    QR: TRect;
  begin
    lsbGroupes.Canvas.Pen.Style   := psSolid;
    lsbGroupes.Canvas.Brush.Style := bsSolid;
    lsbGroupes.Canvas.Brush.Color := Coul;
    lsbGroupes.Canvas.Pen.Color   := clBlack;
    QR.Left   := ARect.Left   + TB + 3;
    QR.Top    := ARect.Top    + 1;
    QR.Bottom := ARect.Bottom - 1;
    QR.Right  := QR.Left + W - 4;
    lsbGroupes.Canvas.Rectangle(QR);
    lsbGroupes.Canvas.Brush.Color := bg;
  end;
  procedure DessineFiletColonne(const TB: integer);
  begin
    lsbGroupes.Canvas.Pen.Color   := clSilver; // pour les filets
    lsbGroupes.Canvas.MoveTo(TB, ARect.Top);
    lsbGroupes.Canvas.LineTo(TB, ARect.Bottom);
  end;
  procedure DessineItem(const bg,tc: TColor);
  VAR
    HS: THeaderSection;
    QR: TRect;
  begin
    lsbGroupes.Canvas.Brush.Color := bg;
    lsbGroupes.Canvas.Font.Color  := tc;

    lsbGroupes.Canvas.FillRect(ARect);
    HS := hcColonnes.Sections.Items[0];  // affiché
    // mettre en évidence les groupes vides
    if (MyGRP.NombreObjets = 0) then DessineRectCouleur(HS.Left - Q4, HS.Width, clFuchsia, bg);
    //lsbGroupes.Canvas.TextOut(HS.Left + 4, ARect.Top,  Format('%d',[MyGRP.NombreObjets]));
    HS := hcColonnes.Sections.Items[1];  // affiché
    DessineCoche(HS.Left, MyGRP.Displayed, bg);
    HS := hcColonnes.Sections.Items[2];  // verrouillé
    DessineCoche(HS.Left, MyGRP.Locked, bg);
    DessineFiletColonne(HS.Left - Q4);
    HS := hcColonnes.Sections.Items[3];  // couleur
    lsbGroupes.Canvas.Brush.Color := MyGRP.CouleurGroupe;
    DessineRectCouleur(HS.Left - Q4, HS.Width, MyGRP.CouleurGroupe, bg);
    DessineFiletColonne(HS.Left - Q4);
    HS := hcColonnes.Sections.Items[4];  // num  groupe
    lsbGroupes.Canvas.TextOut(HS.Left + 4, ARect.Top,  Format('%d',[MyGRP.IDGroupeEntites]));
    DessineFiletColonne(HS.Left - Q4);
    HS := hcColonnes.Sections.Items[5];  // ZOrder
    lsbGroupes.Canvas.TextOut(HS.Left + 4, ARect.Top,  Format('%.0f',[MyGRP.ZOrder]));
    DessineFiletColonne(HS.Left - Q4);
    HS := hcColonnes.Sections.Items[6];  // Nom entrée
    DessineFiletColonne(HS.Left - Q4);
    lsbGroupes.Canvas.TextOut(HS.Left + 4, ARect.Top, MyGRP.NomGroupe);
  end;
begin
  try
    MyGRP := FDocDessin.GetGroupeByIdx(Index);
    if (FActiveGroupeIdx = Index) then WU := clYellow else WU := clWhite;
    DessineItem(WU, clBlack);
    if (odSelected in state) then
    begin
      lsbGroupes.Canvas.brush.color := clBlue;
      DessineItem(clBlue, clWhite);
    end;
  except
    AfficherMessageErreur('Warn: Liste groupes vide');
  end;
end;

procedure TCadreListeGroupes.PutGroupeInForm(const Idx: integer);
var
  EWE : TGroupeEntites;
begin
  if (Idx <= 0) then Exit;
  EWE  := FDocDessin.GetGroupeByIdx(Idx);
  lbIDGroupe.Caption       := Format('%d', [EWE.IDGroupeEntites]);
  lbNomGroupe.Caption      := EWE.NomGroupe;
  lbColorGroupe.Color      := EWE.CouleurGroupe;
  chkVisible.Checked       := EWE.Displayed;
  chkLocked.Checked        := EWE.Locked;
  chkDecalageActif.Checked := EWE.DecalageActif;
  lbZOrder.Caption         := Format('%.2f', [EWE.ZOrder]);
  lbNbObjets.Caption       := Format('%d', [EWE.NombreObjets]);
end;
// recherche idx groupe d'après texte à rechercher
function TCadreListeGroupes.FindIdxGroupeFoundByText(const S: string): integer;
var
  i, Nb: Integer;
  EWE: String;
  SP: String;
begin
  Result := -1;
  if (not FCdrDessin.DoDraw) then Exit;
  SP := LowerCase(Trim(S));
  Nb := lsbGroupes.Count;
  if (Nb = 0) then Exit;
  for i := 0 to Nb -1 do
  begin
    EWE := LowerCase(Trim(lsbGroupes.Items[i]));
    if (Pos(SP, EWE) > 0) then
    begin
      Result := i;
      Exit;
    end;
  end;
end;

procedure TCadreListeGroupes.Initialiser(const B: boolean);
  procedure S777(const WU: TAction; const CaptionHint: string);
   begin
     WU.Caption  := GetResourceString(CaptionHint);
     WU.Hint     := GetResourceString(CaptionHint);
   end;
begin
  FGroupesModifiables := B;
  // captions des actions
  S777(acNewGroupe                , rsCDR_LST_GRP_NOUVEAU_GROUPE);
  S777(acBasculerVisibiliteGroupes, rsCDR_LST_GRP_BASC_VISI_GROUPES);
  S777(acDefCurrentGroupe         , rsCDR_LST_GRP_DEF_GROUPE_COURANT);
  S777(acMasquerTousGroupes       , rsCDR_LST_GRP_MASQUER_TOUS_GROUPES);
  label1.Caption := '';
end;

end.

