unit dlgAssistantCavite;
// Date: 19/04/2012
// Statut: Remplacé par un PageControl
//         Prêt à recevoir les cadres Expé, Code, Entrées
//         Cadre "Série" brêlé
// 07/09/2012: Opérationnel.
// 12/11/2014: Deprecated (la création d'un nouveau document se fait par génération puis chargement d'un document ébauche)

{$INCLUDE CompilationParameters.inc}
interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  Classes,
  StructuresDonnees,
  Common,
  ToporobotClasses2012,
  ConvertisseurJPC, // API JPC
  ObjetSerie,
  CadreSerieIndependant,
  CallDialogsStdVersion,
  CadreCode,
  CadreExpe,
  unitUtilsComposants,
  SysUtils, FileUtil,
  Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, ComCtrls,
  curredit;

type

  { TdlgAssistantNouveau }

  TdlgAssistantNouveau = class(TForm)
    btnCancel: TButton;
    btnSaveAs: TButton;
    btnConvertisseur: TButton;
    CdrCode1: TCdrCode;
    CdrExpe1: TCdrExpe;
    CdrSerieIndependant1: TCdrSerieIndependant;
    cmbSystemesGeographiques: TComboBox;
    Edit1: TEdit;
    editCommentaireEntree: TEdit;
    editCommentaireEtude: TEdit;
    editCoordX: TCurrencyEdit;
    editCoordY: TCurrencyEdit;
    editCoordZ: TCurrencyEdit;
    editNomEntreePrincipale: TEdit;
    editNomEtude: TEdit;
    editRefSerie: TCurrencyEdit;
    editRefStation: TCurrencyEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    grbxCoordonnees: TGroupBox;
    grbxStationInitiale: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lbCommentaireEntree: TLabel;
    lbCommentaireEtude: TLabel;
    lbNomEtude: TLabel;
    lbPoint: TLabel;
    lbSerie: TLabel;
    lbNomEntreePrincipale: TLabel;
    lbSystemeDeCoordonnees: TLabel;
    PageControl1: TPageControl;
    TabShtGeneral: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    TabShtSerie: TTabSheet;
    TabShtCode: TTabSheet;
    TabShtExpe: TTabSheet;
    procedure btnCancelClick(Sender: TObject);
    procedure btnSaveAsClick(Sender: TObject);
    procedure btnConvertisseurClick(Sender: TObject);
    procedure cmbSystemesGeographiquesChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FFichierTAB: string;
    FNewDoc: TToporobotStructure2012;
    FDocCreated: boolean;
    FConvertisseurEPSG: TConversionSysteme;
    FConvertisseurReady: boolean;

    function  CheckModifs: boolean;
    procedure ValidateModifs;
    { private declarations }
  public
    { public declarations }
    function InitNewDocument: boolean;
    function InitConversionEPSG: boolean;
    function DocCreated: Boolean;
    function GetXTBFileName: string;
  end;
var
  dlgAssistantNouveau: TdlgAssistantNouveau;

implementation

{$R *.lfm}

procedure TdlgAssistantNouveau.FormShow(Sender: TObject);
var
  QS: TObjSerie;
  ii: integer;
  EWE: TLabelSystemesCoordsEPSG;
begin
  FDocCreated := False;
  // captions des controles
  self.Caption             := GetResourceString(rsASSIST_TITLE);
  TabShtGeneral.Caption    := GetResourceString(rsTBS_GENERAL);
    lbNomEtude.Caption                := GetResourceString(rsASSIST_LBNOMETUDE);
    lbCommentaireEtude.Caption        := GetResourceString(rsASSIST_LBOBSETUDE);
    lbSystemeDeCoordonnees.Caption    := GetResourceString(rsASSIST_LBSYSTGEO);
  TabShtSerie.Caption      := GetResourceString(rsASSIST_BNSERIE);
  TabShtCode.Caption       := GetResourceString(rsASSIST_BNCODES);
  TabShtExpe.Caption       := GetResourceString(rsASSIST_BNEXPES);
  btnConvertisseur.Caption := GetResourceString(rsASSIST_LBCONVERTISSEUR);
  // entrées
  lbNomEntreePrincipale.Caption     := GetResourceString(rsASSIST_LBNOMENTREE);
  grbxCoordonnees.Caption           := GetResourceString(rsASSIST_LBOBSENTREE);
  grbxStationInitiale.Caption       := GetResourceString(rsASSIST_LBREFSTATION);
  lbCommentaireEntree.Caption       := GetResourceString(rsASSIST_LBCOMMENTAIRE);
  lbSerie.Caption                   := GetResourceString(rsASSIST_LBREFSERIE);
  lbPoint.Caption                   := GetResourceString(rsASSIST_LBREFPOINT);
  // boutons
  btnSaveAs.Caption    := GetResourceString(rsASSIST_BNSAVE);
  btnCancel.Caption    := GetResourceString(rsASSIST_BNCANCEL);
  // général
  editNomEtude.Text             := _AnsiToLCLStr(FNewDoc.GetNomEtude);
  editCommentaireEtude.Text     := _AnsiToLCLStr(FNewDoc.GetCommentairesEtude);
  // série
  QS := FNewDoc.GetSerie(1);
  CdrSerieIndependant1.Initialise(FNewDoc, QS);
  // entrée
  editNomEntreePrincipale.Text := 'Entree principale';
  editCoordX.Value             := 0.00;
  editCoordY.Value             := 0.00;
  editCoordZ.Value             := 0.00;
  editRefSerie.AsInteger       := 1;
  editRefStation.AsInteger     := 0;
  // code
  CdrCode1.SetCode(FNewDoc.GetCode(1), True);
  // expé
  CdrExpe1.SetExpe(FNewDoc.GetExpe(1), True);
  // convertisseur
  RemplirCombosSystemesCoordonnees(FConvertisseurEPSG, cmbSystemesGeographiques, True, DEFAULT_SYSTEME_COORDONNEES_CODE_EPSG);
end;

function TdlgAssistantNouveau.CheckModifs: boolean;
begin
  Result := False;
  try
    Result := True;
  except
  end;
end;


procedure TdlgAssistantNouveau.ValidateModifs;
var
  E    : TEntrance;
  Serie: TObjSerie;
  EPSG: TLabelSystemesCoordsEPSG;
begin
  with FNewDoc do
  begin
    // général
    SetNomEtude(_LCLStrToAnsi(Trim(editNomEtude.Text)));
    SetCommentairesEtude(_LCLStrToAnsi(Trim(editCommentaireEtude.Text)));
    EPSG := FConvertisseurEPSG.GetCodeEPSGNomSysteme(cmbSystemesGeographiques.ItemIndex);
    SetCodeEPSGSystemeCoordonnees(EPSG);

    // entrée principale
    E.eNomEntree := _LCLStrToAnsi(Trim(editNomEntreePrincipale.Text));
    E.eObserv    := _LCLStrToAnsi(Trim(editCommentaireEntree.Text));
    E.eXEntree   := editCoordX.Value;
    E.eYEntree   := editCoordY.Value;
    E.eZEntree   := editCoordZ.Value;

    E.eRefSer    := editRefSerie.AsInteger;
    E.eRefSt     := editRefStation.AsInteger;

    SetDefaultCoords(E.eXEntree, E.eYEntree, E.eZEntree);
    SetRefSeriePoint(E.eRefSer, E.eRefSt);

    // ajouter l'entrée dans la liste
    AddEntree(E);
    //===============================
    PutExpe(1, CdrExpe1.GetExpeFromForm);
    PutCode(1, CdrCode1.GetCodeFromForm);
    if (CdrSerieIndependant1.ImplementerModifs) then
    begin
      Serie := CdrSerieIndependant1.GetCurrentSerie;
      FNewDoc.PutSerie(1, Serie);
    end;
  end;
end;

procedure TdlgAssistantNouveau.FormCreate(Sender: TObject);
begin
  Inherited;
  FConvertisseurEPSG := TConversionSysteme.Create;
  try
    FConvertisseurReady := FConvertisseurEPSG.Initialiser;
  finally
  end;
end;

procedure TdlgAssistantNouveau.btnSaveAsClick(Sender: TObject);
var
  WU: String;
begin

  WU := EnsureMakeFilename(_LCLStrToAnsi(editNomEtude.Text));
  if (DoDialogSaveFile('GHTopo XTB (*.xtb)|*.xtb|' +
                       'Toporobot TAB (*.Tab)|*.Tab|' +
                       'GHTopo XML (*.gtx)|*.gtx',
                       '.xtb', WU)) then
  begin
    if (not CheckModifs) then Exit;
    try
      ValidateModifs;
      FNewDoc.SaveToFile(WU, mtabEXTENDEDTAB, tfWINDOWS);
      FDocCreated := True;
    except
      ShowMessage('Erreur de création du document ébauche');
    end;

    self.Close;
  end;
end;

procedure TdlgAssistantNouveau.btnConvertisseurClick(Sender: TObject);
var
  Pt: TPoint2Df;
  ResultatCalcul: double;
  Declimag: double;
begin
  ResultatCalcul  := 0.00;
  Declimag        := 0.00;
  PT := MakeTPoint2Df(editCoordX.Value, editCoordY.Value);
  if (CallCalculette('', PT, ResultatCalcul, Declimag)) then
  begin
    editCoordX.Value := PT.X;
    editCoordY.Value := PT.Y;
  end;
end;

procedure TdlgAssistantNouveau.btnCancelClick(Sender: TObject);
begin
  self.Close;
end;

procedure TdlgAssistantNouveau.cmbSystemesGeographiquesChange(Sender: TObject);
begin

end;

procedure TdlgAssistantNouveau.FormDestroy(Sender: TObject);
begin
  try
    FConvertisseurEPSG.Finaliser;
  finally
    FConvertisseurEPSG.Free;
  end;
  //Inherited;
end;



function TdlgAssistantNouveau.InitNewDocument: boolean;
var
  EPSGDefault: TLabelSystemesCoordsEPSG;
  Expe: TExpe;
  Code : TCode;
  Serie: TObjSerie;
  //Visee: TUneVisee;
  J, M, A: word;
begin
  Result := False;
  try
    FNewDoc:=TToporobotStructure2012.Create;
    with FNewDoc do
    begin
      ReInitialiser(True);
      SetDatabaseName('Topographie1.xtb');
      SetNomEtude('');
      SetCommentairesEtude('');

      EPSGDefault.CodeEPSG := DEFAULT_SYSTEME_COORDONNEES_CODE_EPSG;
      EPSGDefault.Nom      := DEFAULT_SYSTEME_COORDONNEES_NOM;

      SetCodeEPSGSystemeCoordonnees(EPSGDefault);
      AfficherMessage(' -- 1');
      // Première Expé:
      with Expe do
      begin
        IDExpe := 1;
        SafeDecodeDate(Now, A,M,J);
        //if A > 1900+ANNEE_PIVOT then A:=A-1900 else A:=A-2000;
        JourExpe:=J;
        MoisExpe:=M;
        AnneeExpe:=A;

        Speleometre :='';
        Speleographe:='';
        ModeDecl    :=0;
        Declinaison :=0.00;
        Inclinaison :=0.00;
        Couleur     :=1;
        Commentaire :='';
      end;
      AddExpe(Expe);
      AfficherMessage(' -- 2');
      // Premier Code
      with Code do
      begin
        IDCode      :=1;
        GradAz      :=360.00;
        GradInc     :=360.00;
        PsiL        :=0.01;
        PsiAz       :=1.00;
        PsiP        :=1.00;
        FactLong    :=1.00;
        AngLimite   :=0.00;
        Commentaire :='';
      end;
      AddCode(Code);
      // Première Série
      AfficherMessage(' -- 3');
      Serie := TObjSerie.Create;
      with Serie do
      begin
        SetNoReseau(0);
        SetIndexSerie(1);  // Numéro réel de la série
        SetNomSerie('Serie principale');
        SetSeriePtExtremites(1, 0, 1, 1);
        SetChanceObstacle(0, 0);
        AddVisee(EmptyVisee('Station 1/0'));
      end;
      AddSerie(Serie);
      AfficherMessage(' -- 4');
    end; //with FNewDoc do begin
    Result:=True;
  except
    ShowMessage('Erreur d''initialisation');
    FNewDoc.Free;
  end;
end;

function TdlgAssistantNouveau.InitConversionEPSG: boolean;
begin
  Result := False;
end;

function TdlgAssistantNouveau.DocCreated: Boolean;
begin
  Result := FDocCreated;
end;
function TdlgAssistantNouveau.GetXTBFileName: string;
begin
  Result := FFichierTAB;
end;


end.

