unit dlgCoupeDeveloppee;

{$INCLUDE CompilationParameters.inc}

interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  Common,
  StructuresDonnees,
  ToporobotClasses2012,
  unitCoupeDeveloppee,
  UnitObjetSerie,
  CadreCoupeDeveloppee,
  CallDialogsStdVersion,
  UnitListesSimplesWithGeneriques,
  Classes, SysUtils, FileUtil,
  Forms, Controls, Graphics, Dialogs, ExtCtrls, PairSplitter, StdCtrls,
  ComCtrls, Buttons, types, LCLType, ActnList;

type

  { TfrmCoupeDeveloppee }

  TfrmCoupeDeveloppee = class(TForm)
    acReverseSensBrancheFromMap: TAction;
    acOpenCoupe: TAction;
    acSaveCoupe: TAction;
    acRegen: TAction;
    acRemoveSerie: TAction;
    acReverseSensBrancheFromList: TAction;
    acExportCoupeDevSVG: TAction;
    acMakeCoupe: TAction;
    acExportGCP: TAction;
    Action2: TAction;
    acAddSerie: TAction;
    acParametreVue: TAction;
    Action3: TAction;
    acZoomPlus: TAction;
    acZoomMoins: TAction;
    acZoomFenetre: TAction;
    acPanVue: TAction;
    acZoomtout: TAction;
    ActionList1: TActionList;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    btnRegenCoupe: TButton;
    Button1: TButton;
    Button2: TButton;
    CdrCoupeDeveloppee1: TCdrCoupeDeveloppee;
    chkRecalculerAChaqueAjout: TCheckBox;
    hcColsTitres: THeaderControl;
    ImageList1: TImageList;
    imgLstTreeView: TImageList;
    Label2: TLabel;
    lsbSeriesCoupe: TListBox;
    lsbSeriesLieesAtCurrent: TListBox;
    lsbListeDesSeries: TListBox;
    PageControl1: TPageControl;
    PairSplitter1: TPairSplitter;
    PairSplitter2: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    PairSplitterSide3: TPairSplitterSide;
    PairSplitterSide4: TPairSplitterSide;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    pnlListeSeries: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TreeView1: TTreeView;
    procedure acAddSerieExecute(Sender: TObject);
    procedure acExportCoupeDevSVGExecute(Sender: TObject);
    procedure acExportGCPExecute(Sender: TObject);
    procedure acMakeCoupeExecute(Sender: TObject);
    procedure acOpenCoupeExecute(Sender: TObject);
    procedure acPanVueExecute(Sender: TObject);
    procedure acParametreVueExecute(Sender: TObject);
    procedure acRegenExecute(Sender: TObject);
    procedure acRemoveSerieExecute(Sender: TObject);
    procedure acReverseSensBrancheFromMapExecute(Sender: TObject);
    procedure acSaveCoupeExecute(Sender: TObject);
    procedure acReverseSensBrancheFromListExecute(Sender: TObject);
    procedure acZoomFenetreExecute(Sender: TObject);
    procedure acZoomMoinsExecute(Sender: TObject);
    procedure acZoomPlusExecute(Sender: TObject);
    procedure acZoomtoutExecute(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure btnAddSerieClick(Sender: TObject);
    procedure btnRegenCoupeClick(Sender: TObject);
    procedure btnRecenserBranchesClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure hcColsTitresSectionResize(HeaderControl: TCustomHeaderControl;
      Section: THeaderSection);
    procedure lsbBrancheClick(Sender: TObject);
    procedure lsbListeDesSeriesClick(Sender: TObject);
    procedure lsbListeDesSeriesDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
    procedure lsbListeDesSeriesSelectionChange(Sender: TObject; User: boolean);
    procedure lsbSeriesCoupeDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
    procedure lsbSeriesLieesAtCurrentDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
    procedure TreeView1SelectionChanged(Sender: TObject);
    procedure VueClick(Sender: TObject);
  private
    { private declarations }
    FDocToporobot: TToporobotStructure2012;
    FCoupeDeveloppee: TCoupeDeveloppee;
    FNumeroSerie : integer;
    procedure BasculerBrancheByIdx(const Idx: integer);
    procedure DessinerItemDeListe(const LSB: TListBox; const DoUseInternalIdxSerie: boolean; Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
    procedure InitCaptions;
    procedure InitHeaderListe;
    procedure ListerLesSeries(const QIdx: integer);
    procedure RecalculerGrapheEtRegenererVue(const DoRecenserBranches: boolean);
    procedure ZoomerPM(const CoefZoom: double; const Grooth: boolean);
  public
    { public declarations }
    function Initialiser(const T: TToporobotStructure2012): boolean;
  end;

var
  frmCoupeDeveloppee: TfrmCoupeDeveloppee;

implementation

{$R *.lfm}

{ TfrmCoupeDeveloppee }
// lister les séries
procedure TfrmCoupeDeveloppee.ListerLesSeries(const QIdx: integer);
var
  i: Integer;
  S: TObjSerie;
  EWE: Integer;
begin
  EWE := QIdx;
  lsbListeDesSeries.Enabled:=False;
  lsbListeDesSeries.Clear;
  for i:= 0 to FDocToporobot.GetNbSeries - 1 do
  begin
    S := FDocToporobot.GetSerie(i);
    lsbListeDesSeries.Items.Add(Format('%d: %s', [S.GetNumeroDeSerie(), S.GetNomSerie()]));
  end;
  if (QIdx = -1) then
  begin
    EWE := FDocToporobot.GetNbSeries() - 1;
    FNumeroSerie := EWE;
  end;
  lsbListeDesSeries.ItemIndex := EWE;
  lsbListeDesSeries.Enabled:=True;
end;

procedure TfrmCoupeDeveloppee.lsbBrancheClick(Sender: TObject);
begin

end;

procedure TfrmCoupeDeveloppee.lsbListeDesSeriesClick(Sender: TObject);
begin

end;

// factorisation de code pour les listes
procedure TfrmCoupeDeveloppee.DessinerItemDeListe(const LSB: TListBox;
                                                  const DoUseInternalIdxSerie: boolean;
                                                  Control: TWinControl;
                                                  Index: Integer;
                                                  ARect: TRect;
                                                  State: TOwnerDrawState);
const
  Q4  = 4; // compensation du décalage entre le header et la liste
  mg  = 1;
var
  sr: TObjSerie;
  rs: TReseau;
  miou: string;
  n: LongInt;
  QIdx: integer;
  procedure DessineFiletColonne(const TB: integer); inline;
  begin
    LSB.Canvas.Line(TB, ARect.Top, TB, ARect.Bottom);
  end;
  // bg = couleur de fond; tc= couleur du texte
  procedure DessineItem(const bg,tc: TColor);
  VAR
    //TB: integer;
    HS: THeaderSection;
    r: TRect;
  begin
    LSB.Canvas.FillRect(ARect);
    LSB.canvas.Pen.Color:=clSilver;
    LSB.Canvas.Font.Color :=tc;

    HS := hcColsTitres.Sections.Items[0];  // ID série
    LSB.canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d',[sr.GetNumeroDeSerie()]));
    HS := hcColsTitres.Sections.Items[1];  // Départ
    DessineFiletColonne(HS.Left - Q4);
    LSB.canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d.%d',[sr.GetNoSerieDep, sr.GetNoPointDep]));
    HS := hcColsTitres.Sections.Items[2];  // Arrivée
    DessineFiletColonne(HS.Left - Q4);
    LSB.canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d.%d',[sr.GetNoSerieArr, sr.GetNoPointArr]));
    HS := hcColsTitres.Sections.Items[3];  // nom
    DessineFiletColonne(HS.Left - Q4);
    LSB.canvas.TextOut(HS.Left + 4, ARect.Top+1, _AnsiToLCLStr(sr.GetNomSerie));
    // réseau
    HS := hcColsTitres.Sections.Items[4];  // nom
    DessineFiletColonne(HS.Left - Q4);
    rs := FDocToporobot.GetReseau(sr.GetNumeroReseau());

    LSB.canvas.Pen.Color:=clBlack;
    LSB.canvas.Brush.Color:=rs.ColorReseau;
    r.Left :=HS.Left;
    r.Right:=HS.Left + 32;
    r.Top  :=ARect.Top + mg;
    r.Bottom:=ARect.Bottom - mg;
    LSB.canvas.Rectangle(R);
    LSB.Canvas.Brush.Color:= bg;
    LSB.Canvas.TextOut(HS.Left + 32 + 4, ARect.Top+1, _AnsiToLCLStr(rs.NomReseau));
    LSB.Canvas.Brush.Color:=bg;
    LSB.canvas.Pen.Color:=clSilver;
    HS := hcColsTitres.Sections.Items[5];  // Nb points
    DessineFiletColonne(HS.Left - Q4);
    LSB.canvas.TextOut(HS.Left + 4, ARect.Top+1,  Format('%d',[sr.GetNbVisees]));
  end;
begin
  try
    if (DoUseInternalIdxSerie) then
    begin
      sr := FDocToporobot.GetSerie(Index);
    end
    else
    begin
      n  := StrToIntDef(LSB.Items[Index], 0);
      if (not FDocToporobot.GetSerieByNumeroSerie(n, SR, QIdx)) then Exit;
    end;
    LSB.canvas.brush.color:=clwhite;
    DessineItem(clwhite, clBlack);
    //affichage lorsque la ligne est sélectionnée
    if (odSelected in state) then
    begin
      LSB.canvas.brush.color:=clBlue;
      DessineItem(clBlue, clWhite);
    end;
  except
  end;
end;

procedure TfrmCoupeDeveloppee.lsbListeDesSeriesDrawItem(Control: TWinControl;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
begin
  DessinerItemDeListe(lsbListeDesSeries, True, Control, Index, ARect, State);
end;

procedure TfrmCoupeDeveloppee.lsbListeDesSeriesSelectionChange(Sender: TObject; User: boolean);
var
  LS: TListOfIntegers;
  i: Integer;
begin
  if (lsbListeDesSeries.Count = 0) then Exit;
  LS := TListOfIntegers.Create;
  try
    lsbSeriesLieesAtCurrent.Clear;
    if (FDocToporobot.FindIndexesSeriesRattachedAtSerie(lsbListeDesSeries.ItemIndex, LS)) then
    begin
      for i := 0 to LS.Count - 1 do lsbSeriesLieesAtCurrent.Items.Add(Format('%d', [LS.GetElement(i)]));
      lsbSeriesLieesAtCurrent.ItemIndex := 0;
    end;
  finally
    LS.Free;
  end;
end;

procedure TfrmCoupeDeveloppee.lsbSeriesCoupeDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
begin
  DessinerItemDeListe(lsbSeriesCoupe, false, Control, Index, ARect, State);
end;

procedure TfrmCoupeDeveloppee.lsbSeriesLieesAtCurrentDrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
begin
  DessinerItemDeListe(lsbSeriesLieesAtCurrent, false, Control, Index, ARect, State);
end;





// initialisation header
procedure TfrmCoupeDeveloppee.InitHeaderListe;
var
 ht: THeaderSection;
 FNbItems: Integer;
 miou: String;
 procedure AjouterTitreColonne(const Titre: string; const LGMin, LG: integer);
 begin
   ht := hcColsTitres.Sections.Add;
   ht.Text := Titre;
   ht.MinWidth := LGMin;
   ht.Width    := LG;
 end;
 procedure AjouterTitreColonneRes(const RS: string; const LGMin, LG: integer);
 begin
   AjouterTitreColonne(GetResourceString(RS), LGMin, LG);
 end;
begin
  // purge des titres des headers
  hcColsTitres.Sections.Clear;
  miou := GetResourceString(rsTBS_SERIES);
  FNbItems := FDocToporobot.GetNbSeries;
  //pnlListes.Caption := Format('%s (%d items)', [miou, FNbItems]);
  with hcColsTitres do
  begin
    AjouterTitreColonneRes(rsSELECT_LISTE_SERIES_ID, 40, 40);
    AjouterTitreColonneRes(rsSELECT_LISTE_SERIES_DEPART, 70, 70);
    AjouterTitreColonneRes(rsSELECT_LISTE_SERIES_ARRIVEE, 70, 70);
    AjouterTitreColonneRes(rsSELECT_LISTE_SERIES_NOM, 100, 300);
    AjouterTitreColonneRes(rsSELECT_LISTE_SERIES_RESEAU, 100, 300);
    AjouterTitreColonneRes(rsSELECT_LISTE_SERIES_NBPOINTS, 60, 60);
  end;
end;

procedure TfrmCoupeDeveloppee.FormShow(Sender: TObject);
begin
  InitHeaderListe;
  ListerLesSeries(0);
  CdrCoupeDeveloppee1.Initialise(FCoupeDeveloppee);
end;

procedure TfrmCoupeDeveloppee.btnAddSerieClick(Sender: TObject);
var
  EWE: TObjSerie;
begin

end;

procedure TfrmCoupeDeveloppee.acZoomtoutExecute(Sender: TObject);
begin
  CdrCoupeDeveloppee1.ResetVue;
end;

procedure TfrmCoupeDeveloppee.acZoomFenetreExecute(Sender: TObject);
begin
  CdrCoupeDeveloppee1.SetModeTravail(mtZOOM_PREMIER_COIN);
end;

procedure TfrmCoupeDeveloppee.acZoomMoinsExecute(Sender: TObject);
begin
  ZoomerPM(1.10, false);
end;

procedure TfrmCoupeDeveloppee.acZoomPlusExecute(Sender: TObject);
begin
  ZoomerPM(1.10, true);
end;

procedure TfrmCoupeDeveloppee.acPanVueExecute(Sender: TObject);
begin
  CdrCoupeDeveloppee1.SetModeTravail(mtPAN_PREMIER_POINT);
end;

procedure TfrmCoupeDeveloppee.acParametreVueExecute(Sender: TObject);
var
  WU: TCoupeDeveloppeeParams;
begin
  WU := CdrCoupeDeveloppee1.GetParamsVueCoupe();
  if (ParametrerOngletCoupeDeveloppee(WU)) then CdrCoupeDeveloppee1.SetParamsVueCoupe(WU);
end;


procedure TfrmCoupeDeveloppee.acExportCoupeDevSVGExecute(Sender: TObject);
var
  QFilename: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  if (DoDialogSaveFile('Scalable Vector Graphics (*.svg)|*.svg|', '.svg', QFilename, QFilterIndex)) then
    FCoupeDeveloppee.ExportSVG(QFilename);
end;

procedure TfrmCoupeDeveloppee.acExportGCPExecute(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QIdxFilter: integer;
begin
  if (DoDialogSaveFile('Polygonale GHCaveDraw (*.gcp)|*.gcp', '.gcp', QFileName, QIdxFilter)) then
  begin
    FCoupeDeveloppee.ExporterCoupeGCP(QFileName);
  end;
end;

procedure TfrmCoupeDeveloppee.acAddSerieExecute(Sender: TObject);
var
  EWE: TObjSerie;
  n: LongInt;
  QIdx: integer;
begin
  if (lsbSeriesLieesAtCurrent.ItemIndex >= 0) then
  begin
    n := StrToIntDef(lsbSeriesLieesAtCurrent.Items[lsbSeriesLieesAtCurrent.ItemIndex], 0);
    if (FDocToporobot.GetSerieByNumeroSerie(n, EWE, QIdx)) then
    begin
      if (FCoupeDeveloppee.AddSerie(EWE, True)) then
      begin;
        if (chkRecalculerAChaqueAjout.Checked) then RecalculerGrapheEtRegenererVue(True);
        FCoupeDeveloppee.ListerSeriesRetenues(lsbSeriesCoupe, -1);
      end
      else
      begin
        ShowMessage('Série non raccordée au réseau');
      end;
    end;
  end;
end;

procedure TfrmCoupeDeveloppee.acMakeCoupeExecute(Sender: TObject);
begin
  if (lsbListeDesSeries.ItemIndex > 0) then
  begin
    RecalculerGrapheEtRegenererVue(True);
    FCoupeDeveloppee.ListerSeriesRetenues(lsbSeriesCoupe, -1);
  end;
end;

procedure TfrmCoupeDeveloppee.acOpenCoupeExecute(Sender: TObject);
var
  QFilename: TStringDirectoryFilename;
begin
  if (DoDialogOpenFile('Coupes développées|coupe_dev*.txt|Tous|*.*', '.txt', QFilename)) then
  begin
     if (FCoupeDeveloppee.LoadCoupe(QFilename)) then
     begin
       RecalculerGrapheEtRegenererVue(True);
       FCoupeDeveloppee.ListerSeriesRetenues(lsbSeriesCoupe, -1);
     end;
  end;
end;

procedure TfrmCoupeDeveloppee.acRegenExecute(Sender: TObject);
begin
  //FCoupeDeveloppee.RecalculerLaCoupe;
  FCoupeDeveloppee.ListerSeriesRetenues(lsbSeriesCoupe, -1);
  CdrCoupeDeveloppee1.ResetVue;
end;

procedure TfrmCoupeDeveloppee.acRemoveSerieExecute(Sender: TObject);
var
  WU: Integer;
begin
  if (not GHTopoQuestionOuiNon(rsCOUPE_DEVEL_AC_DO_REMOVE_SERIE)) then Exit;
  try
    WU := lsbSeriesCoupe.ItemIndex;
    FCoupeDeveloppee.RemoveSerie(WU);
    ListerLesSeries(0);
    RecalculerGrapheEtRegenererVue(True);
    FCoupeDeveloppee.ListerSeriesRetenues(lsbSeriesCoupe, -1);
    CdrCoupeDeveloppee1.ResetVue;
  except
  end;
end;

procedure TfrmCoupeDeveloppee.acReverseSensBrancheFromMapExecute(Sender: TObject);
var
  Idx: Integer;
begin
  Idx := CdrCoupeDeveloppee1.GetCurrentIdxBranche;
  BasculerBrancheByIdx(Idx);
end;

procedure TfrmCoupeDeveloppee.acSaveCoupeExecute(Sender: TObject);
var
  QFilename: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
   if (DoDialogSaveFile('Coupe developpee (*.txt)|*.txt|', '.txt', QFilename, QFilterIndex)) then
   begin
     FCoupeDeveloppee.SaveCoupe(QFilename);

   end;
end;

procedure TfrmCoupeDeveloppee.acReverseSensBrancheFromListExecute(Sender: TObject);
var
  WU: TTreeNode;
  EWE: TGHStringArray;
  NoBr: LongInt;
begin
  WU := TreeView1.Selected;
  if (WU.Level = 2) then
  begin
    //ShowMessageFmt('%d - %s', [WU.Level, WU.Text]);
    EWE := Split(WU.Text, ':');
    NoBr := StrToIntDef(EWE[0], -1);
    if (NoBr >= 0) then
    begin
      //ShowMessageFmt('Branche %d sélectionnée', [NoBr]);
      BasculerBrancheByIdx(NoBr);
    end;
  end;
end;


procedure TfrmCoupeDeveloppee.BasculerBrancheByIdx(const Idx: integer);
begin
  if (Idx >= 0) then
  begin
    FCoupeDeveloppee.BasculerSensDessinBrancheByIdx(Idx);
    RecalculerGrapheEtRegenererVue(False);
  end;
end;

procedure TfrmCoupeDeveloppee.BitBtn4Click(Sender: TObject);
begin
  self.Close;
end;

procedure TfrmCoupeDeveloppee.InitCaptions;
  procedure WU(const AC: TAction; const QCaption: string);
  begin
    AC.Caption := GetResourceString(QCaption);
    AC.Hint    := AC.Caption;
  end;
begin
  WU(acOpenCoupe,           rsCOUPE_DEVEL_AC_OPEN_COUPE);
  WU(acSaveCoupe,           rsCOUPE_DEVEL_AC_SAVE_COUPE);
  WU(acExportCoupeDevSVG,   rsCOUPE_DEVEL_AC_EXPORT_SVG);
  WU(acMakeCoupe,           rsCOUPE_DEVEL_AC_MAKE_COUPE);
  WU(acAddSerie,            rsCOUPE_DEVEL_AC_ADD_SERIE);
  WU(acRemoveSerie,         rsCOUPE_DEVEL_AC_REMOVE_SERIE);
end;





procedure TfrmCoupeDeveloppee.btnRegenCoupeClick(Sender: TObject);
begin
  //FCoupeDeveloppee.RecalculerLaCoupe;
  FCoupeDeveloppee.ListerSeriesRetenues(lsbSeriesCoupe, -1);
  CdrCoupeDeveloppee1.ResetVue;
end;

procedure TfrmCoupeDeveloppee.Button1Click(Sender: TObject);
begin
  FCoupeDeveloppee.ListerArbreDeLaCoupe(TreeView1);
end;




procedure TfrmCoupeDeveloppee.btnRecenserBranchesClick(Sender: TObject);
begin
  FCoupeDeveloppee.RecenserLesBranches;
end;


procedure TfrmCoupeDeveloppee.RecalculerGrapheEtRegenererVue(const DoRecenserBranches: boolean);
var
  Discriminant: Integer;
  EWE: String;
begin
  if (FCoupeDeveloppee.ConstruireLaCoupeDeveloppee(DoRecenserBranches)) then
  begin
    AfficherMessage('-- Graphe aux sommets OK');
    FCoupeDeveloppee.SetMiniMaxi;
    CdrCoupeDeveloppee1.ResetVue;
    FCoupeDeveloppee.ListerArbreDeLaCoupe(TreeView1);
  end
  else
  begin
    ShowMessage('Le réseau n''est pas entièrement connecté');
  end;
end;

procedure TfrmCoupeDeveloppee.TreeView1SelectionChanged(Sender: TObject);
begin

end;

procedure TfrmCoupeDeveloppee.VueClick(Sender: TObject);
begin

end;

procedure TfrmCoupeDeveloppee.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  try
    FCoupeDeveloppee.Finalise;
  finally
    FCoupeDeveloppee.Free;
  end;
end;

procedure TfrmCoupeDeveloppee.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose := false;
  if (GHTopoQuestionOuiNon('Quitter')) then
  begin
    CanClose := True;
  end;
end;

procedure TfrmCoupeDeveloppee.FormCreate(Sender: TObject);
begin

end;


procedure TfrmCoupeDeveloppee.hcColsTitresSectionResize(
  HeaderControl: TCustomHeaderControl; Section: THeaderSection);
begin
  lsbListeDesSeries.Invalidate;
end;


function TfrmCoupeDeveloppee.Initialiser(const T: TToporobotStructure2012): boolean;
begin
  Result := false;
  try
    FDocToporobot := T;
    FCoupeDeveloppee := TCoupeDeveloppee.Create;
    FCoupeDeveloppee.Initialise(T);
    InitCaptions;
    Result := True;
  except
  end;
end;

procedure TfrmCoupeDeveloppee.ZoomerPM(const CoefZoom : double; const Grooth : boolean);
var
  OO       : TVue2DParams;
  Q1, Q2   : TPointCoupeDeveloppee;
  QC1, QC2 : TPointCoupeDeveloppee;
  Diag     : Double;
  Sens     : double;
begin
  if (Not CdrCoupeDeveloppee1.getDoDrawCoupe) then Exit;
  try
    Q1     := CdrCoupeDeveloppee1.GetCoinBasGauche;
    Q2     := CdrCoupeDeveloppee1.GetCoinHautDroit;
    Sens   := IIF(Grooth, 1, -1);
    Diag   := Sens * CoefZoom * 0.01 * Hypot2D(Q2.P - Q1.P, Q2.Z - Q1.Z);
    QC1    := MakeTPointCoupeDeveloppee(Q1.P + Diag, Q1.Z + Diag);
    QC2    := MakeTPointCoupeDeveloppee(Q2.P - Diag, Q2.Z - Diag);
    CdrCoupeDeveloppee1.SetViewLimits(QC1.P, QC1.Z, QC2.P, QC2.Z);
    CdrCoupeDeveloppee1.RedessinEcran;
  except
  end;
end;
end.

