unit dlgListeNearViseesTo;

{$INCLUDE CompilationParameters.inc}
interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  //ToporobotClasses2012,
  StructuresDonnees,
  UnitEntitesExtended,
  Common, CadreListeNearStations, Classes, SysUtils, FileUtil,
  curredit, Forms, Controls, Graphics, Dialogs, Buttons, StdCtrls, ComCtrls,
  types, LCLType, ExtCtrls;

type

  { TfrmListeNearViseesTo }

  TfrmListeNearViseesTo = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button1: TButton;
    CdrListeNearestStations1: TCdrListeNearestStations;
    chkDoMatchExact: TCheckBox;
    editIDTerrain: TEdit;
    editRayonCapture: TCurrencyEdit;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure BitBtn1Click(Sender: TObject);

  private
    { private declarations }
    //FDocuTopo: TToporobotStructure2012;
    FBDDEntites    : TBDDEntites;
    FCurrEntite    : TEntiteEtendue;
    FRayonDeCapture: double;
  public
    { public declarations }
    function  Initialiser(const BDD: TBDDEntites; const QS, QP: integer; const R: double): boolean;
    procedure Finaliser();
    function GetResultEntite(): TEntiteEtendue;
  end;

var
  frmListeNearViseesTo: TfrmListeNearViseesTo;

implementation

{$R *.lfm}

{ TfrmListeNearViseesTo }

procedure TfrmListeNearViseesTo.BitBtn1Click(Sender: TObject);
begin
  try
    if (CdrListeNearestStations1.GetNbStationsFound() > 0) then
      FCurrEntite := CdrListeNearestStations1.GetNearEntiteSelected();
  except
    FCurrEntite.Entite_Serie   := -1;
    FCurrEntite.Entite_Station := -1;
  end;//*)
end;



function TfrmListeNearViseesTo.Initialiser(const BDD: TBDDEntites; const QS, QP: integer; const R: double): boolean;
var
  QPositionPtZero: TPoint3Df;
begin
  self.Caption := 'Recherche de stations proches';
  AfficherMessage(Format('%s.Initialiser()', [ClassName]));
  FBDDEntites := BDD;
  FRayonDeCapture := R; // distance d'accrochage
  editIDTerrain.Text := Format('%d.%d', [QS, QP]);
  editRayonCapture.Value := FRayonDeCapture;
  // on recherche la station de base
  // Station introuvable = ce qui suit n'a pas de sens et on quitte direct
  if (Not FBDDEntites.GetEntiteViseeFromSerSt(QS, QP, FCurrEntite)) then Exit(false);
  CdrListeNearestStations1.Initialiser(FBDDEntites, FCurrEntite,
                                       chkDoMatchExact.Checked,
                                       editRayonCapture.Value);

  // Passage ici ? OK
  Result := True;
end;

procedure TfrmListeNearViseesTo.Finaliser();
begin
  pass;
end;



function TfrmListeNearViseesTo.GetResultEntite(): TEntiteEtendue;
begin
  Result := FCurrEntite;
end;

end.


