unit dlgSplashScreen;

{$INCLUDE CompilationParameters.inc}

interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees, dateutils, Common,
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type

  { TfrmSplashScreen }

  TfrmSplashScreen = class(TForm)
    lbVersionGHTopo: TLabel;
    lbUtilisateur: TLabel;
    lbGHTopoName: TStaticText;
    lbProcessing: TStaticText;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FT: TDateTime;
    { private declarations }
  public
    { public declarations }

  end;

var
  frmSplashScreen: TfrmSplashScreen;

implementation

{$R *.lfm}


{ TfrmSplashScreen }

procedure TfrmSplashScreen.FormShow(Sender: TObject);
var
  DateCompilation: TDateTime;
  YYYY, MM, DD, HH, MN, SS, MS: Word;
begin
  FT := now();
  Timer1.Interval := 1000;
  Timer1.Enabled  := true;
  DateCompilation      := FileDateToDateTime(FileAge(ParamStr(0)));
  DecodeDateTime(DateCompilation, YYYY, MM, DD, HH, MN, SS, MS);

  OnShow := nil;
  lbGHTopoName.Caption := GetResourceString(rsGHTOPOEXENAME);
  lbVersionGHTopo.Caption  := Format(GetResourceString(rsGHTOPOVERSION), [DD, MM, YYYY]);
  lbProcessing.Caption     := 'Chargement en cours ...';
  lbUtilisateur.Caption    := Format('Utilisateur: %s (%s)', [DFT_OPERATEUR, DFT_CLUB_SPELEO]);
end;

procedure TfrmSplashScreen.Timer1Timer(Sender: TObject);
var
  dt: TDateTime;
  HH, MM, SS, MS: word;
begin
  dt := Now() - FT;
  DecodeTime(dt, HH, MM, SS, MS);
  lbProcessing.Caption :=  Format('Chargement en cours. Elapsed: %.2d:%.02d:%.02d.%.03d',
                                 [HH, MM, SS, MS]);
end;

end.

