unit frmJournal;
// Date: 19/04/2012
// Statut: Fonctionnel
{$INCLUDE CompilationParameters.inc}
interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees,
  Classes,
  Common,
  {$IFDEF MSWINDOWS}
  Windows,
  {$ENDIF}
  SysUtils, FileUtil, SynEdit, Forms, Controls, Graphics, Dialogs, StdCtrls, Buttons, ExtCtrls, PairSplitter;

type

  { TdlgProcessing }

  TdlgProcessing = class(TForm)
    btnCopyLigne: TSpeedButton;
    btnCopyMemoErreurs: TSpeedButton;
    btnSaveJournal: TSpeedButton;
    btnSaveJournal1: TSpeedButton;
    editLigneSelectionnee: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    lsbJournal: TListBox;
    PairSplitter1: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    pnlJournal: TPanel;
    pnlErreursWarnings: TPanel;
    memoErreurs: TSynEdit;
    lbMemoryUsage: TStaticText;
    procedure btnCopyMemoErreursClick(Sender: TObject);
    procedure btnCopyLigneErrClick(Sender: TObject);
    procedure btnSaveJournal1Click(Sender: TObject);
    procedure btnSaveJournalClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure lsbJournalClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure CopierJournalErreurs();
  end; 

var
  dlgProcessing: TdlgProcessing;

implementation

{$R *.lfm}
uses
  CallDialogsStdVersion; // ne pas le mettre ds la zone 'interface' (bugs en cascade sinon)

{ TdlgProcessing }

procedure TdlgProcessing.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose:=False;
  ShowMessage(_AnsiToLCLStr(rsNOCANCLOSEWND));
end;



procedure TdlgProcessing.btnCopyMemoErreursClick(Sender: TObject);
begin
  CopierJournalErreurs();
end;

procedure TdlgProcessing.btnCopyLigneErrClick(Sender: TObject);
begin

end;

procedure TdlgProcessing.btnSaveJournal1Click(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  QFileName := Format('Errors_%s.txt', [DatePascalToDateHeureCondensee(Now)]);
  if (DoDialogSaveFile('Fichier texte|*.txt', '.txt',  QFileName, QFilterIndex)) then
  begin
    memoErreurs.Lines.SaveToFile(QFileName);
  end;
end;

procedure TdlgProcessing.btnSaveJournalClick(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  QFileName := Format('Journal_%s.txt', [DatePascalToDateHeureCondensee(Now)]);
  if (DoDialogSaveFile('Fichier texte|*.txt', '.txt',  QFileName, QFilterIndex)) then
  begin
    lsbJournal.Items.SaveToFile(QFileName);
  end;
  //*)
end;

procedure TdlgProcessing.CopierJournalErreurs;
begin
  memoErreurs.SelectAll;
  memoErreurs.CopyToClipboard;
end;

procedure TdlgProcessing.lsbJournalClick(Sender: TObject);
begin
  editLigneSelectionnee.Text := lsbJournal.Items[lsbJournal.ItemIndex];
end;

end.

