unit frmClavierVirtuel;
// Clavier virtuel pour l'écran tactile d'une tablette ou d'un Raspberry
// Justification: Les claviers des OS sont inadaptés
{$INCLUDE CompilationParameters.inc}
interface
uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees,
  Common,
  Classes, SysUtils, FileUtil, curredit, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, Buttons;

type

  { TdlgClavierVirtuel }

  TdlgClavierVirtuel = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    btn_1: TButton;
    btn_0: TButton;
    btn_Aa: TButton;
    btn_gt: TButton;
    btn_lt: TButton;
    btn_Shebang: TButton;
    btn_SimpleQuote: TButton;
    btn_Hashtag: TButton;
    btn_Comma: TButton;
    btn_Period: TButton;
    btn_Semicolon: TButton;
    btn_DbleQuote: TButton;
    btn_openParenth: TButton;
    btn_CloseParenth: TButton;
    btn_Dollar: TButton;
    btn_Xx: TButton;
    btn_Cc: TButton;
    btn_Vv: TButton;
    btn_Bb: TButton;
    btn_Nn: TButton;
    btn_Kk1: TButton;
    btn_Ll1: TButton;
    btn_Arobase: TButton;
    btn_Underscore: TButton;
    btn_Rr: TButton;
    btn_Ww: TButton;
    btn_Tt: TButton;
    btn_Yy: TButton;
    btn_Uu: TButton;
    btn_Ii: TButton;
    btn_Oo: TButton;
    btn_Pp: TButton;
    btn_Ss: TButton;
    btn_Gg: TButton;
    btn_Hh: TButton;
    btn_Jj: TButton;
    btn_Kk: TButton;
    btn_Qq: TButton;
    btn_Dd: TButton;
    btn_Ff: TButton;
    btn_Ll: TButton;
    btn_Mm: TButton;
    btn_Zz: TButton;
    btn_Egal: TButton;
    btn_Product: TButton;
    btn_Divide: TButton;
    btn_Plus: TButton;
    btn_Dot: TButton;
    btn_Minus: TButton;
    btn_2: TButton;
    btn_3: TButton;
    btn_4: TButton;
    btn_5: TButton;
    btn_6: TButton;
    btn_7: TButton;
    btn_8: TButton;
    btn_9: TButton;
    btn_Ee: TButton;
    btn_Space: TButton;
    Button1: TButton;
    btnRAZTextBox: TButton;
    chkMajuscule: TCheckBox;
    editTexte: TEdit;
    pnlCommandes: TPanel;
    pnlPartieAlpha: TPanel;
    pnlPonctuation: TPanel;
    pnlClavierNumerique: TPanel;
    Shape1: TShape;
    procedure btnRAZTextBoxClick(Sender: TObject);
    procedure btn_0Click(Sender: TObject);
    procedure btn_1Click(Sender: TObject);
    procedure btn_2Click(Sender: TObject);
    procedure btn_3Click(Sender: TObject);
    procedure btn_4Click(Sender: TObject);
    procedure btn_5Click(Sender: TObject);
    procedure btn_6Click(Sender: TObject);
    procedure btn_7Click(Sender: TObject);
    procedure btn_8Click(Sender: TObject);
    procedure btn_9Click(Sender: TObject);
    procedure btn_AaClick(Sender: TObject);
    procedure btn_BbClick(Sender: TObject);
    procedure btn_CcClick(Sender: TObject);
    procedure btn_ArobaseClick(Sender: TObject);
    procedure btn_CloseParenthClick(Sender: TObject);
    procedure btn_CommaClick(Sender: TObject);
    procedure btn_DbleQuoteClick(Sender: TObject);
    procedure btn_gtClick(Sender: TObject);
    procedure btn_HashtagClick(Sender: TObject);
    procedure btn_ltClick(Sender: TObject);
    procedure btn_NnClick(Sender: TObject);
    procedure btn_openParenthClick(Sender: TObject);
    procedure btn_PeriodClick(Sender: TObject);
    procedure btn_SemicolonClick(Sender: TObject);
    procedure btn_ShebangClick(Sender: TObject);
    procedure btn_SimpleQuoteClick(Sender: TObject);
    procedure btn_SpaceClick(Sender: TObject);
    procedure btn_UnderscoreClick(Sender: TObject);
    procedure btn_VvClick(Sender: TObject);
    procedure btn_DollarClick(Sender: TObject);
    procedure btn_XxClick(Sender: TObject);
    procedure btn_DdClick(Sender: TObject);
    procedure btn_DivideClick(Sender: TObject);
    procedure btn_DotClick(Sender: TObject);
    procedure btn_EeClick(Sender: TObject);
    procedure btn_EgalClick(Sender: TObject);
    procedure btn_FfClick(Sender: TObject);
    procedure btn_HhClick(Sender: TObject);
    procedure btn_IiClick(Sender: TObject);
    procedure btn_JjClick(Sender: TObject);
    procedure btn_KkClick(Sender: TObject);
    procedure btn_LlClick(Sender: TObject);
    procedure btn_MinusClick(Sender: TObject);
    procedure btn_OoClick(Sender: TObject);
    procedure btn_PlusClick(Sender: TObject);
    procedure btn_PpClick(Sender: TObject);
    procedure btn_ProductClick(Sender: TObject);
    procedure btn_QqClick(Sender: TObject);
    procedure btn_RrClick(Sender: TObject);
    procedure btn_SsClick(Sender: TObject);
    procedure btn_TtClick(Sender: TObject);
    procedure btn_UuClick(Sender: TObject);
    procedure btn_GgClick(Sender: TObject);
    procedure btn_MmClick(Sender: TObject);
    procedure btn_WwClick(Sender: TObject);
    procedure btn_YyClick(Sender: TObject);
    procedure btn_ZzClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
    procedure DisplayClavier();

    procedure AddCharacter(const C: char);
  public
    { public declarations }
    procedure Initialiser(const V: string; const ModeClavier: TModeClavierVirtuel);
    function  GetValue(): string;
  end;

var
  dlgClavierVirtuel: TdlgClavierVirtuel;

implementation

{$R *.lfm}

{ TdlgClavierVirtuel }
procedure TdlgClavierVirtuel.Initialiser(const V: string; const ModeClavier: TModeClavierVirtuel);
begin
  editTexte.Text := V;
end;




procedure TdlgClavierVirtuel.AddCharacter(const C: char);
var
  S: Char;
begin
  editTexte.Text := editTexte.Text + C;
end;

procedure TdlgClavierVirtuel.btnRAZTextBoxClick(Sender: TObject);
begin
  editTexte.Text := '';
end;




procedure TdlgClavierVirtuel.btn_0Click(Sender: TObject);
begin
  AddCharacter('0');
end;

procedure TdlgClavierVirtuel.btn_1Click(Sender: TObject);
begin
  AddCharacter('1');
end;

procedure TdlgClavierVirtuel.btn_2Click(Sender: TObject);
begin
  AddCharacter('2');
end;

procedure TdlgClavierVirtuel.btn_3Click(Sender: TObject);
begin
  AddCharacter('3');
end;

procedure TdlgClavierVirtuel.btn_4Click(Sender: TObject);
begin
  AddCharacter('4');
end;

procedure TdlgClavierVirtuel.btn_5Click(Sender: TObject);
begin
  AddCharacter('5');
end;

procedure TdlgClavierVirtuel.btn_6Click(Sender: TObject);
begin
  AddCharacter('6');
end;

procedure TdlgClavierVirtuel.btn_7Click(Sender: TObject);
begin
  AddCharacter('7');
end;

procedure TdlgClavierVirtuel.btn_8Click(Sender: TObject);
begin
  AddCharacter('8');
end;

procedure TdlgClavierVirtuel.btn_9Click(Sender: TObject);
begin
  AddCharacter('9');
end;

procedure TdlgClavierVirtuel.btn_AaClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'A', 'a'));
end;

procedure TdlgClavierVirtuel.btn_BbClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'B', 'b'));
end;

procedure TdlgClavierVirtuel.btn_CcClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'C', 'c'));
end;

procedure TdlgClavierVirtuel.btn_CloseParenthClick(Sender: TObject);
begin
  AddCharacter(')');
end;

procedure TdlgClavierVirtuel.btn_CommaClick(Sender: TObject);
begin
  AddCharacter(',');
end;

procedure TdlgClavierVirtuel.btn_DbleQuoteClick(Sender: TObject);
begin
 AddCharacter('"');
end;

procedure TdlgClavierVirtuel.btn_XxClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'X', 'x'));
end;

procedure TdlgClavierVirtuel.btn_DdClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'D', 'd'));
end;

procedure TdlgClavierVirtuel.btn_DivideClick(Sender: TObject);
begin
  AddCharacter('/');
end;

procedure TdlgClavierVirtuel.btn_DotClick(Sender: TObject);
begin
  AddCharacter('.');
end;

procedure TdlgClavierVirtuel.btn_EeClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'E', 'e'));
end;

procedure TdlgClavierVirtuel.btn_EgalClick(Sender: TObject);
begin
  AddCharacter('=');
end;

procedure TdlgClavierVirtuel.btn_FfClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'F', 'f'));
end;

procedure TdlgClavierVirtuel.btn_IiClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'I', 'i'));
end;

procedure TdlgClavierVirtuel.btn_JjClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'J', 'j'));
end;

procedure TdlgClavierVirtuel.btn_KkClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'K', 'k'));
end;

procedure TdlgClavierVirtuel.btn_LlClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'L', 'l'));
end;

procedure TdlgClavierVirtuel.btn_ltClick(Sender: TObject);
begin
  AddCharacter('<');
end;

procedure TdlgClavierVirtuel.btn_MinusClick(Sender: TObject);
begin
  AddCharacter('-');
end;

procedure TdlgClavierVirtuel.btn_ArobaseClick(Sender: TObject);
begin
  AddCharacter('@');
end;

procedure TdlgClavierVirtuel.btn_OoClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'O', 'o'));
end;

procedure TdlgClavierVirtuel.btn_openParenthClick(Sender: TObject);
begin
  AddCharacter('(');
end;

procedure TdlgClavierVirtuel.btn_PeriodClick(Sender: TObject);
begin
  AddCharacter(';');
end;

procedure TdlgClavierVirtuel.btn_PlusClick(Sender: TObject);
begin
  AddCharacter('+');
end;

procedure TdlgClavierVirtuel.btn_PpClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'P', 'p'));
end;

procedure TdlgClavierVirtuel.btn_ProductClick(Sender: TObject);
begin
  AddCharacter('*');
end;

procedure TdlgClavierVirtuel.btn_QqClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'Q', 'q'));
end;

procedure TdlgClavierVirtuel.btn_RrClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'R', 'r'));
end;

procedure TdlgClavierVirtuel.btn_SemicolonClick(Sender: TObject);
begin
  AddCharacter(':');
end;

procedure TdlgClavierVirtuel.btn_ShebangClick(Sender: TObject);
begin
  AddCharacter('!');
end;

procedure TdlgClavierVirtuel.btn_SimpleQuoteClick(Sender: TObject);
begin
  AddCharacter('''');
end;

procedure TdlgClavierVirtuel.btn_SpaceClick(Sender: TObject);
begin
  AddCharacter(' ');
end;

procedure TdlgClavierVirtuel.btn_SsClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'S', 's'));
end;

procedure TdlgClavierVirtuel.btn_TtClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'T', 't'));
end;

procedure TdlgClavierVirtuel.btn_UnderscoreClick(Sender: TObject);
begin
  AddCharacter('_');
end;

procedure TdlgClavierVirtuel.btn_UuClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'U', 'u'));
end;

procedure TdlgClavierVirtuel.btn_VvClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'V', 'v'));
end;

procedure TdlgClavierVirtuel.btn_DollarClick(Sender: TObject);
begin
  AddCharacter('$');
end;

procedure TdlgClavierVirtuel.btn_WwClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'W', 'w'));
end;

procedure TdlgClavierVirtuel.btn_MmClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'M', 'm'));
end;

procedure TdlgClavierVirtuel.btn_NnClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'N', 'n'));
end;

procedure TdlgClavierVirtuel.btn_GgClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'G', 'g'));
end;

procedure TdlgClavierVirtuel.btn_gtClick(Sender: TObject);
begin
  AddCharacter('>');
end;

procedure TdlgClavierVirtuel.btn_HashtagClick(Sender: TObject);
begin
  AddCharacter('#');
end;

procedure TdlgClavierVirtuel.btn_HhClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'H', 'h'));
end;

procedure TdlgClavierVirtuel.btn_YyClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'Y', 'y'));
end;

procedure TdlgClavierVirtuel.btn_ZzClick(Sender: TObject);
begin
  AddCharacter(IIF(chkMajuscule.Checked, 'Z', 'z'));
end;

procedure TdlgClavierVirtuel.Button1Click(Sender: TObject);
var
  WU: TCaption;
  n: Integer;
begin
  WU := editTexte.Text;
  n := length(WU);
  system.Delete(WU, n, 1);
  editTexte.Text := WU;
end;



procedure TdlgClavierVirtuel.DisplayClavier;
begin

end;

procedure TdlgClavierVirtuel.FormCreate(Sender: TObject);
begin

end;

procedure TdlgClavierVirtuel.FormShow(Sender: TObject);
begin
  self.left := 8;
  self.top  := 8;
end;

function TdlgClavierVirtuel.GetValue: string;
begin
  Result := editTexte.Text;
end;




end.

