unit frmEditAnnotation;

{$INCLUDE CompilationParameters.inc}
interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees,
  ToporobotClasses2012,
  Classes, SysUtils, FileUtil, curredit, Forms, Controls, Graphics, Dialogs, Buttons, StdCtrls, ExtCtrls;

type

  { TdlgEditAnnotation }

  TdlgEditAnnotation = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    btnFindStation: TButton;
    cmbAnnotationStyle: TComboBox;
    editOffsetX: TCurrencyEdit;
    editOffsetY: TCurrencyEdit;
    editOffsetZ: TCurrencyEdit;
    editSer: TCurrencyEdit;
    editPt: TCurrencyEdit;
    editTexte: TEdit;
    grbxAlignement: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    rbxAlign1: TRadioButton;
    rbxAlign2: TRadioButton;
    rbxAlign3: TRadioButton;
    rbxAlign4: TRadioButton;
    rbxAlign5: TRadioButton;
    rbxAlign6: TRadioButton;
    rbxAlign7: TRadioButton;
    rbxAlign8: TRadioButton;
    rbxAlign9: TRadioButton;
  private
    function GetAnnAlignmentFromForm(): byte;
    procedure setAnnAlignmentInForm(const A: byte);
    { private declarations }
  public
    { public declarations }
    function PrepareDialog(const FD: TToporobotStructure2012;
                           const QIdx: integer; const QAnnotation: TAnnotation;
                           const QCaption: string): boolean;
    function GetAnnotation(): TAnnotation;
  end;

var
  dlgEditAnnotation: TdlgEditAnnotation;

implementation

{$R *.lfm}

{ TdlgEditAnnotation }
procedure TdlgEditAnnotation.setAnnAlignmentInForm(const A: byte);
begin
  case A of
    0: rbxAlign1.Checked := True;
    1: rbxAlign1.Checked := True;
    2: rbxAlign2.Checked := True;
    3: rbxAlign3.Checked := True;
    4: rbxAlign4.Checked := True;
    5: rbxAlign5.Checked := True;
    6: rbxAlign6.Checked := True;
    7: rbxAlign7.Checked := True;
    8: rbxAlign8.Checked := True;
    9: rbxAlign9.Checked := True;
  end;
end;
function TdlgEditAnnotation.GetAnnAlignmentFromForm(): byte;
begin
  Result := 0;
  if (rbxAlign1.Checked) then Exit(1);
  if (rbxAlign2.Checked) then Exit(2);
  if (rbxAlign3.Checked) then Exit(3);
  if (rbxAlign4.Checked) then Exit(4);
  if (rbxAlign5.Checked) then Exit(5);
  if (rbxAlign6.Checked) then Exit(6);
  if (rbxAlign7.Checked) then Exit(7);
  if (rbxAlign8.Checked) then Exit(8);
  if (rbxAlign9.Checked) then Exit(9);
end;

function TdlgEditAnnotation.GetAnnotation: TAnnotation;
begin
  Result.Basepoint.eSerie   := editSer.AsInteger;
  Result.Basepoint.ePoint   := editPt.AsInteger;

  Result.IdxStyle           := cmbAnnotationStyle.ItemIndex;

  Result.PosPtDeBase := GetAnnAlignmentFromForm();
  Result.Offset.X    := editOffsetX.Value;
  Result.Offset.Y    := editOffsetY.Value;
  Result.Offset.Z    := editOffsetZ.Value;
  Result.Texte       := Trim(editTexte.Text);
end;

function TdlgEditAnnotation.PrepareDialog(const FD: TToporobotStructure2012; const QIdx: integer; const QAnnotation: TAnnotation; const QCaption: string): boolean;
var
  i, n: Integer;
  WU: TTexteAttributs;
begin
  cmbAnnotationStyle.Clear;
  n := FD.GetNbStylesAnnotations();
  for i := 0 to n - 1 do
  begin
    WU := FD.GetStyleAnnotation(i);
    cmbAnnotationStyle.Items.Add(WU.StyleName);
  end;
  cmbAnnotationStyle.ItemIndex := QAnnotation.IdxStyle;

  editSer.AsInteger    := QAnnotation.Basepoint.eSerie;
  editPt.AsInteger     := QAnnotation.Basepoint.ePoint;
  cmbAnnotationStyle.ItemIndex := QAnnotation.IdxStyle;
  setAnnAlignmentInForm(QAnnotation.PosPtDeBase);
  editOffsetX.Value    := QAnnotation.Offset.X;
  editOffsetY.Value    := QAnnotation.Offset.Y;
  editOffsetZ.Value    := QAnnotation.Offset.Z;
  editTexte.Text       := QAnnotation.Texte;
end;

end.

