unit frmEditScraps;

{$mode delphi}

interface

uses
  GHCD_Types,
  GeneralFunctions,
  UnitDocDessin,
  Classes, SysUtils, FileUtil, curredit, Forms, Controls, Graphics, Dialogs,
  Buttons, StdCtrls;

type

  { TdlgEditScrap }

  TdlgEditScrap = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    btnColorScrap: TColorButton;
    editOpacite: TCurrencyEdit;
    editNomScrap: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    lbColorScrap: TLabel;
    lbColorScrap1: TLabel;
    lsbGroupes: TListBox;
    sclOpacite: TScrollBar;
    lbNumGroupe: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure lsbGroupesClick(Sender: TObject);
    procedure sclOpaciteChange(Sender: TObject);
  private
    { private declarations }
    FMyDocDessin : TDocumentDessin;
    FScrap       : TScrap;
  public
    { public declarations }
    function Initialise(const FD:TDocumentDessin; const SC: TScrap): boolean;
    function GetScrap(): TScrap;
  end;

var
  dlgEditScrap: TdlgEditScrap;

implementation

{$R *.lfm}

{ TdlgEditScrap }

procedure TdlgEditScrap.BitBtn1Click(Sender: TObject);
begin

end;


function TdlgEditScrap.GetScrap(): TScrap;
begin
  FScrap.Nom         := Trim(editNomScrap.Text);
  FScrap.Couleur     := btnColorScrap.ButtonColor;
  FScrap.Opacite     := editOpacite.AsInteger; //sclOpacite.Position;
  FScrap.IDGroupe    := FMyDocDessin.GetIndexGroupeByInternalIdx(lsbGroupes.ItemIndex);
  Result             := FScrap;
end;

procedure TdlgEditScrap.lsbGroupesClick(Sender: TObject);
var
  EWE: TIDGroupeEntites;
begin
  EWE := FMyDocDessin.GetIndexGroupeByInternalIdx(lsbGroupes.ItemIndex);
  lbNumGroupe.Caption        := Format('%d', [EWE]);
end;

procedure TdlgEditScrap.sclOpaciteChange(Sender: TObject);
begin
  editOpacite.AsInteger := sclOpacite.Position;
end;

function TdlgEditScrap.Initialise(const FD:TDocumentDessin; const SC: TScrap): boolean;
var
  i, Nb: Integer;
  GRP: TGroupeEntites;
  WU: String;
begin
  FMyDocDessin := FD;
  FScrap := SC;
  lsbGroupes.Clear;
  Nb := FMyDocDessin.GetNbGroupes();
  for i := 0 to Nb - 1 do
  begin
    GRP := FMyDocDessin.GetGroupeByIdx(i);
    WU := Format('%d - [%.2f] - %s', [GRP.IDGroupeEntites, GRP.ZOrder, GRP.NomGroupe]);
    lsbGroupes.Items.Add(WU);
  end;
  lsbGroupes.ItemIndex       := FMyDocDessin.GetInternalIdxGroupe(FScrap.IDGroupe);
  btnColorScrap.ButtonColor  := FScrap.Couleur;
  editNomScrap.Text          := FScrap.Nom;
  sclOpacite.Position        := FScrap.Opacite;
  editOpacite.AsInteger      := sclOpacite.Position;
  lbNumGroupe.Caption        := Format('%d', [FScrap.IDGroupe]);
end;


end.

