unit frmGHTopoMainWindow;

// 06/10/2016: Nouveau frontal (demandé par Gros Minet)
// 26/12/2016: Refonte complète des listes d'actions et de la barre d'outils
// 04/06/2018: Nouvelle refonte: Interface simplifée pour Raspberry

{$INCLUDE CompilationParameters.inc}

interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  Common,
  StructuresDonnees,
  ToporobotClasses2012,
  UnitObjetSerie,
  UnitEntitesExtended,
  UnitClasseMaillage,
  CodeCalculTopo,
  UnitClassPalette,
  unitUtilsComposants,
  ConvertisseurJPC,
  CallDialogsStdVersion,
  CadreListesSimples,
  CadreViseesAntenne,
  CadreListeSeries,
  CadreSerieIndependant,
  CadreGHTopoContext2D,

  cadreDistoX, unitdistox,
  Classes, SysUtils, FileUtil,
  Forms, Controls, Graphics, Dialogs, Menus, ActnList, ComCtrls, StdCtrls, ExtCtrls, Buttons, Types, LCLType, PairSplitter;



type

  { TGHTopoMainWindow }

  TGHTopoMainWindow = class(TForm)
    ac3DView: TAction;
    acExportSeriesTableauCroise: TAction;
    acFenetreDeDonnees: TAction;
    acFenetreVueEnPlan: TAction;
    acAnalyseGrapheReseau: TAction;
    acExportTopodroid: TAction;
    acUtilsDistoX: TAction;
    acCapturePlan: TAction;
    acChargerMaillage: TAction;
    acCheckBase: TAction;
    acCompileExt: TAction;
    acCoupeDeveloppee: TAction;
    acDisplayDiagrammes: TAction;
    acDisplayErrorsXTB: TAction;
    acDisplayListeSeries: TAction;
    acDisplayParametresVue: TAction;
    acDistance: TAction;
    acEditeur: TAction;
    acEditeurCoupeDeveloppee: TAction;
    acExport2DODG: TAction;
    acExport2DSVG: TAction;
    acExportDXF1: TAction;
    acExporterTEXT: TAction;
    acExportGHCaveDraw: TAction;
    acExportGIS: TAction;
    acExportPocketTopo: TAction;
    acExportVTopo: TAction;
    acFenetreConsole: TAction;
    acFindstation: TAction;
    acHelpSystem: TAction;
    acInfosCavite: TAction;
    aclstVisu2D: TActionList;
    acMaillagesUtils: TAction;
    acMetaFiltre: TAction;
    acNew: TAction;
    acNil1: TAction;
    acOuvrirTopoExt: TAction;
    acPanVue: TAction;
    acPrint: TAction;
    acPrint1: TAction;
    acQuit: TAction;
    acRecents: TAction;
    acRefreshVue: TAction;
    acReload: TAction;
    acRendu3D: TAction;
    acSaveAs: TAction;
    acStats: TAction;
    acFermer: TAction;
    ActionList1: TActionList;
    acToolCalculette: TAction;
    acVue3DFiltree: TAction;
    acVue3DOpenGLFiltree: TAction;
    acZoomAll: TAction;
    acZoomMoins: TAction;
    acZoomPlus: TAction;
    acZoomWindow: TAction;
    Button3: TButton;
    CdrAntennes1: TCdrAntennes;
    CdrDistoX1: TCdrDistoX;
    CdrListeSeries1: TCdrListeSeries;
    CdrListesSimples1: TCdrListesSimples;
    CdrSerieIndependant1: TCdrSerieIndependant;
    cmbSystemesCoordonnees: TComboBox;
    editCommentaireEtude: TEdit;
    editNomEtude: TEdit;
    GHTopoContext2DA1: TGHTopoContext2DA;
    ImageList1: TImageList;
    imglstVue2D: TImageList;
    lbOperationEnCours: TLabel;
    lbCommentaireEtude: TLabel;
    lbNomEtude: TLabel;
    lbSystemeDeCoordonnees: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem26: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    MenuItem29: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem30: TMenuItem;
    MenuItem31: TMenuItem;
    MenuItem32: TMenuItem;
    MenuItem33: TMenuItem;
    MenuItem34: TMenuItem;
    MenuItem35: TMenuItem;
    MenuItem36: TMenuItem;
    MenuItem37: TMenuItem;
    MenuItem38: TMenuItem;
    MenuItem39: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem40: TMenuItem;
    MenuItem41: TMenuItem;
    MenuItem42: TMenuItem;
    MenuItem43: TMenuItem;
    MenuItem44: TMenuItem;
    MenuItem45: TMenuItem;
    MenuItem46: TMenuItem;
    MenuItem47: TMenuItem;
    MenuItem48: TMenuItem;
    MenuItem49: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem50: TMenuItem;
    MenuItem51: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    mnuFenetre: TMenuItem;
    mnuFichier: TMenuItem;
    mnuHelp: TMenuItem;
    mnuTopographie: TMenuItem;
    PageControl1: TPageControl;
    PairSplitter1: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    Panel1: TPanel;
    pnlTollBarFichier: TPanel;
    pnlTollBarOutils: TPanel;
    pnlTollBarCtrlVue2D: TPanel;
    pnlTollBarFichierUtils: TPanel;
    pnlToolBarCompile: TPanel;
    pnlToolBar: TPanel;
    pnlPogression: TPanel;
    Panel2: TPanel;
    ProgressBar1: TProgressBar;
    Shape1: TShape;
    SpeedButton11: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton24: TSpeedButton;
    SpeedButton25: TSpeedButton;
    SpeedButton26: TSpeedButton;
    SpeedButton27: TSpeedButton;
    SpeedButton28: TSpeedButton;
    SpeedButton29: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton31: TSpeedButton;
    SpeedButton32: TSpeedButton;
    SpeedButton33: TSpeedButton;
    SpeedButton34: TSpeedButton;
    SpeedButton35: TSpeedButton;
    SpeedButton36: TSpeedButton;
    SpeedButton37: TSpeedButton;
    SpeedButton38: TSpeedButton;
    SpeedButton39: TSpeedButton;
    SpeedButton40: TSpeedButton;
    SpeedButton41: TSpeedButton;
    SpeedButton42: TSpeedButton;
    SpeedButton43: TSpeedButton;
    SpeedButton44: TSpeedButton;
    lbCurrentStation: TStaticText;
    SpeedButton45: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    tabShtDistoX: TTabSheet;
    tabShtVueEnPlan: TTabSheet;
    tabShtAntennes: TTabSheet;
    tabShtLesSeries: TTabSheet;
    tabshtGeneral: TTabSheet;
    tabShtListesSimples: TTabSheet;
    procedure ac3DViewExecute(Sender: TObject);
    procedure acAnalyseGrapheReseauExecute(Sender: TObject);
    procedure acCdrSerAddItemExecute(Sender: TObject);
    procedure acDisplayParametresVueExecute(Sender: TObject);
    procedure acEditItemExecute(Sender: TObject);
    procedure acExport2DODGExecute(Sender: TObject);
    procedure acFenetreDeDonneesExecute(Sender: TObject);
    procedure acFenetreVueEnPlanExecute(Sender: TObject);
    procedure acHelpNewsExecute(Sender: TObject);
    procedure acNew3DViewerbyFileExecute(Sender: TObject);
    procedure acNodesCoordinatesExecute(Sender: TObject);
    procedure acReloadExecute(Sender: TObject);
    procedure acSandBoxExecute(Sender: TObject);
    procedure acSnapShotExecute(Sender: TObject);
    procedure acUtilsDistoXExecute(Sender: TObject);
    procedure acCapturePlanExecute(Sender: TObject);
    procedure acChargerMaillageExecute(Sender: TObject);
    procedure acCheckBaseExecute(Sender: TObject);
    procedure acCloseDocumentExecute(Sender: TObject);
    procedure acCompileExtExecute(Sender: TObject);
    procedure acCoupeDeveloppeeExecute(Sender: TObject);
    procedure acDistanceExecute(Sender: TObject);
    procedure acEditeurExecute(Sender: TObject);
    procedure acExport2DSVGExecute(Sender: TObject);
    procedure acExporterTEXTExecute(Sender: TObject);
    procedure acExportGHCaveDrawExecute(Sender: TObject);
    procedure acExportGISExecute(Sender: TObject);
    procedure acExportPocketTopoExecute(Sender: TObject);
    procedure acExportPostScriptExecute(Sender: TObject);
    procedure acFenetreConsoleExecute(Sender: TObject);
    procedure acFermerExecute(Sender: TObject);
    procedure acFindstationExecute(Sender: TObject);
    procedure acGenererDossierTherionExecute(Sender: TObject);
    procedure acHelpSystemExecute(Sender: TObject);
    procedure acInfosCaviteExecute(Sender: TObject);
    procedure acMaillagesUtilsExecute(Sender: TObject);
    procedure acNewExecute(Sender: TObject);
    procedure acOuvrirTopoExtExecute(Sender: TObject);
    procedure acPanVueExecute(Sender: TObject);
    procedure acQuitExecute(Sender: TObject);
    procedure acRendu3DExecute(Sender: TObject);
    procedure acSaveAsExecute(Sender: TObject);
    procedure acStatsExecute(Sender: TObject);
    procedure acVue3DFiltreeExecute(Sender: TObject);
    procedure acZoomAllExecute(Sender: TObject);
    procedure acZoomMoinsExecute(Sender: TObject);
    procedure acZoomPlusExecute(Sender: TObject);
    procedure acZoomWindowExecute(Sender: TObject);
    procedure btnApplyParamsClick(Sender: TObject);
    procedure btnCloseDistoXClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CdrListesSimples1Click(Sender: TObject);
    procedure chkJonctionsChange(Sender: TObject);
    procedure editSearchChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lsbListeClick(Sender: TObject);
    procedure MenuItem36Click(Sender: TObject);
    procedure OngletsVuesChange(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Shape1ChangeBounds(Sender: TObject);
    procedure RecalculerEtActualiser();
    procedure tabshtGeneralContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure VueClick(Sender: TObject);
  private
    // série/station courants
    FCurrentStation   : TToporobotStation;
    FCurrentNomFichierXTB : TStringDirectoryFileName;
    FDocumentToporobot: TToporobotStructure2012;
    FBDDEntites       : TBDDEntites;
    FMonMaillage      : TMaillage;
    //FCurrParams2D     : TVue2DParams;
    //FC1, FC2          : TPoint2Df;
    FPalette256               : TPalette256;
    FConvertisseurCoordonnees : TConversionSysteme;
    FDocTopoOpenedAndReady    : boolean; // doit être visible de partout
    FPtrDistoX                : TPilotageDistoX;
    // fichiers récents
    FListeFichiersRecents     : TStringList;
    procedure ActiverMenus(const R90Mode: boolean);
    procedure AfficherProgression(const Etape: string; const Done, Starting, Ending: integer);
    procedure AfficherUneSerie;
    procedure ApplyModificationSerie;
    function  CalculerLeReseauExt(): boolean;
    function  ChargerLaTopoExt(const FC: TStringDirectoryFileName; const DoCalc: boolean): boolean;
    procedure CloseAllDocuments();
    procedure DisplayOldDlgDistoX(); deprecated;
    function  GetCurrentStation(): TToporobotStation;
    procedure InitLesCaptions();
    procedure InitNewDocument();
    procedure PreparerFrontal();
    procedure PreparerVue2D();


    procedure SetCurrentStation(const S: TToporobotStation); overload;
    procedure SetCurrentStation(const S, P: integer); overload;
    { private declarations }

  public
    { public declarations }
  end;

var
  GHTopoMainWindow: TGHTopoMainWindow;

implementation

{$R *.lfm}
uses
  unitAnalyseReseau2,
{$IFDEF MSWINDOWS}
    frmJournal,          // console de suivi
{$ENDIF}
    frmDistoXUtils
    //, frmUtilsDistoX   // DistoX
    , frmUtilsDistoX // deprecated
    , dlgMaillages     // maillages
    ;
{ TGHTopoMainWindow }

const
  INDEX_ONGLET_GENERAL      = 0;
  INDEX_ONGLET_LISTES       = 1;
  INDEX_ONGLET_SERIES       = 2;
  INDEX_ONGLET_VUE_EN_PLAN  = 3;
  INDEX_ONGLET_ANTENNES     = 4;
{ TThreadSurveillance }

//******************************************************************************

procedure TGHTopoMainWindow.SetCurrentStation(const S: TToporobotStation);
begin
  SetCurrentStation(S.eSerie, S.ePoint);
end;

procedure TGHTopoMainWindow.SetCurrentStation(const S, P: integer);
begin
  FCurrentStation.eSerie := S;
  FCurrentStation.ePoint := P;
  lbCurrentStation.Caption := Format('%d.%d', [FCurrentStation.eSerie, FCurrentStation.ePoint]);

end;

function TGHTopoMainWindow.GetCurrentStation(): TToporobotStation;
begin
  Result := FCurrentStation;
end;


procedure TGHTopoMainWindow.AfficherProgression(const Etape: string; const Done, Starting, Ending: integer);
begin
  lbOperationEnCours.Caption := Etape;
  try
    ProgressBar1.Min := Starting;
    ProgressBar1.Max := Ending;
    ProgressBar1.Position := Done;
    Application.ProcessMessages;
  except
    ;
  end;
end;





procedure TGHTopoMainWindow.FormCreate(Sender: TObject);
var
  EWE: Boolean;
begin



  FCurrentStation.eSerie := 1;
  FCurrentStation.ePoint := 0;

  // prêt à dessiner le plan
  FDocTopoOpenedAndReady := false;
  // point décimal
  DefaultFormatSettings.DecimalSeparator := '.';
  // création du conteneur ToporobotStructure
  FCurrentNomFichierXTB     := '';
  FDocumentToporobot := TToporobotStructure2012.Create; //(Application);
  FDocumentToporobot.ReInitialiser(True);
  FBDDEntites        := TBDDEntites.Create;
  FBDDEntites.Initialiser(MakeTPoint3Df(0,0,0));
  FMonMaillage       := TMaillage.Create(Application);
  FMonMaillage.Initialiser();
  FPalette256 := TPalette256.Create;
  FPalette256.GenerateTOPOROBOTPalette();
  FConvertisseurCoordonnees := TConversionSysteme.Create;
  FConvertisseurCoordonnees.Initialiser;
  //FMonMaillage.Initialiser();
  //FListeQRStations   := TEnsembleFichesPointsTopo.Create;
  // création des fenêtres permanentes
  {$IFDEF MSWINDOWS}
     dlgProcessing      := TdlgProcessing.Create(Application);
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
  dlgProcessing      := TdlgProcessing.Create(Application);
  {$ENDIF}
  // fichiers récents
  FListeFichiersRecents := TStringList.Create;
  FListeFichiersRecents.Clear;
  AfficherMessage(GetResourceString(rsCHOOSELANGUAGE));
  // init captions
  afficherMessage(GetResourceString(rsMSGASSIGNCAPTIONS));
  InitLesCaptions();
  ActiverMenus(False);
  // OngletsVues
  tabshtGeneral.Caption        := GetResourceString(rsTBS_GENERAL);
  tabShtListesSimples.Caption  := GetResourceString(rsTBS_LISTES_SIMPLES);
    lbNomEtude.Caption             := GetResourceString(rsTBS_GENERAL_NOM);
    lbCommentaireEtude.Caption     := GetResourceString(rsTBS_GENERAL_OBS);
    lbSystemeDeCoordonnees.Caption := GetResourceString(rsTBS_GENERAL_SYST);



  tabShtLesSeries.Caption   := GetResourceString(rsTBS_SERIES);
  tabShtAntennes.Caption    := GetResourceString(rsTBS_ANTENNES);
  //tabShtSeriesFlat.Caption  := GetResourceString(rsTBS_SERIES_FLAT_TABLE);
  tabShtVueEnPlan.Caption   := GetResourceString(rsTBS_SERIES_VUE_EN_PLAN);
  //tabshtMaintenance.Caption := GetResourceString(rsTBS_MAINTENANCE);


   // passer le pointeur de la BDD Entités au gestionnaire des listes simples
  CdrListesSimples1.SetPtrBDDEntites(FBDDEntites);
  // démarrage du DistoX
  FPtrDistoX := nil;
  EWE := CdrDistoX1.InitialiserCadreDistoX();
  acUtilsDistoX.Enabled := EWE;
  if (EWE) then
  begin
    ShowMessage('CdrDistoX1 OK');
    FPtrDistoX := CdrDistoX1.getPtrDistoX();
    GHTopoContext2DA1.setPtrDistoX(FPtrDistoX);
  end;

end;


procedure TGHTopoMainWindow.FormShow(Sender: TObject);
begin

  {$IFDEF MSWINDOWS}
  dlgProcessing.Show;
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
  EnvoyerFenetreVersMoniteur(dlgProcessing, 1, 50, 100, 666, 600);
  dlgProcessing.Show;
  {$ENDIF}
  // démarrage du thread de surveillance de fichier modifié
  SetCurrentStation(1,0);
  self.Top:=0;
  self.left:=0;
  self.Width   := Screen.Width - 8;
  self.Height  := Screen.Height - 76;
  self.Caption := Format(rsMAINMENUCAPTION,['Untitled']);
  self.mnuTopographie.Visible:=False;

  //PreparerFrontal();
  InitNewDocument(); ///https://fr.wikipedia.org/wiki/Satanisme_LaVeyen
end;

procedure TGHTopoMainWindow.ac3DViewExecute(Sender: TObject);
begin
  ShowMessage('Vue 3D');
  if (FDocTopoOpenedAndReady) then
  begin
    DisplayVue3DGDIExt(FBDDEntites, ''); //MyFiltre);
  end;
end;

procedure TGHTopoMainWindow.acAnalyseGrapheReseauExecute(Sender: TObject);
var
  GrapheReseau: TGrapheDuReseau;
  BP: TSommetGraphe;
  QIdxInternal: integer;
begin
  if (not FDocTopoOpenedAndReady) then Exit;
  GrapheReseau := TGrapheDuReseau.Create;
  try
    if (GrapheReseau.Initialiser(FDocumentToporobot, FPalette256) and
       (GrapheReseau.PostInitialisation())) then
    begin
      GrapheReseau.SetProcDisplayProgression(nil);
      GrapheReseau.Traiter();
      ShowMessage('Quelques tests');
      // quelques tests
      AfficherMessageErreur('********************************');
      BP := GrapheReseau.getSommet(5);
      GrapheReseau.PrintSommet(BP.IDSommet);

      GrapheReseau.AddSuccesseurAtSommetByID(BP.IDSommet, 666);
      GrapheReseau.AddSuccesseurAtSommetByID(BP.IDSommet, 121);
      GrapheReseau.AddSuccesseurAtSommetByID(BP.IDSommet, 133);

      GrapheReseau.AddPredecesseurAtSommetByID(BP.IDSommet, 322);
      GrapheReseau.AddPredecesseurAtSommetByID(BP.IDSommet, 1);
      GrapheReseau.AddPredecesseurAtSommetByID(BP.IDSommet, 115);
      GrapheReseau.AddPredecesseurAtSommetByID(BP.IDSommet, 365);
      GrapheReseau.AddPredecesseurAtSommetByID(BP.IDSommet, 398);
      GrapheReseau.AddPredecesseurAtSommetByID(BP.IDSommet, 1024);

      GrapheReseau.PrintSommet(BP.IDSommet);
      AfficherMessageErreur('**** Un autre sommet:');
      GrapheReseau.FindSommetBySerPt(1, 21, BP, QIdxInternal);
      GrapheReseau.SetMarkedSommetByID(BP.IDSommet, True);
      GrapheReseau.PrintSommet(BP.IDSommet);

    end;
  finally
      GrapheReseau.PreFinalisation();
    GrapheReseau.Finaliser();
    GrapheReseau.Free;
  end;
//*)
end;

procedure TGHTopoMainWindow.acUtilsDistoXExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acCapturePlanExecute(Sender: TObject);
var
  WU: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  WU := 'Capture001.png';
  if (DoDialogSaveFile('PNG image (*.png)|*.png', '.png', WU, QFilterIndex)) then
    CapturerVueVersPNG(GHTopoContext2DA1.Panel1.Handle, WU);
end;

procedure TGHTopoMainWindow.acCdrSerAddItemExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acDisplayParametresVueExecute(Sender: TObject);
var
  O: TVue2DParams;
begin
  O := GHTopoContext2DA1.GetCurrentOnglet();
  if (ParametrerOngletVue2D(O)) then
  begin
    GHTopoContext2DA1.PutOngletByIndex(0, O, True);
  end;

end;

procedure TGHTopoMainWindow.acChargerMaillageExecute(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
begin
  QFileName := '';
  if (DoDialogOpenFile('Fichiers maillages (*.mai)|*.mai|Tous|*.*', '.mai', QFileName)) then
  begin
    if (not GHTopoContext2DA1.ChargerMaillage(QFileName)) then ShowMessage('Erreur en chargement du maillage');
  end;
end;

procedure TGHTopoMainWindow.acCheckBaseExecute(Sender: TObject);
begin
  {$IFDEF MSWINDOWS}
     dlgProcessing.memoErreurs.Lines.Clear;
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
     dlgProcessing.memoErreurs.Lines.Clear;
  {$ENDIF}
  FDocumentToporobot.CheckerLesDonneesTopo;
end;

procedure TGHTopoMainWindow.acCloseDocumentExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.RecalculerEtActualiser();
begin
  //if (P) then
  FDocTopoOpenedAndReady := CalculerLeReseauExt();
  // préparer le frontal
  PreparerFrontal();
  //rendre visibles toutes les options des menus
  ActiverMenus(True);

  // préparer la vue 2D
  PreparerVue2D();
  // et on se positionne sur la vue en plan
  PageControl1.ActivePageIndex := INDEX_ONGLET_VUE_EN_PLAN; //tabShtVueEnPlan.TabIndex;
end;

procedure TGHTopoMainWindow.acCompileExtExecute(Sender: TObject);
var
  WU: Boolean;
  QC1, QC2: TPoint2Df;
begin
  // on récupère les limites de dessin courantes
  if (FDocTopoOpenedAndReady) then  WU := GHTopoContext2DA1.GetViewlimits(0, QC1, QC2);
  {$IFDEF MSWINDOWS}                     dlgProcessing.FormStyle := fsStayOnTop; {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED} dlgProcessing.FormStyle := fsStayOnTop; {$ENDIF}
  RecalculerEtActualiser();
  {$IFDEF MSWINDOWS}                     dlgProcessing.FormStyle := fsNormal;    {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED} dlgProcessing.FormStyle := fsNormal;    {$ENDIF}

  //PreparerVue2D();
  FDocTopoOpenedAndReady := GHTopoContext2DA1.Initialiser(FDocumentToporobot,
                                                          FBDDEntites,
                                                          CdrDistoX1.getPtrDistoX(),
                                                          FMonMaillage,
                                                          nil,
                                                          nil,
                                                          RecalculerEtActualiser); //, FListeQRStations);
  if (FDocTopoOpenedAndReady and  WU)then
  begin
    GHTopoContext2DA1.SetViewLimits(QC1, QC2, '');
  end;
end;

procedure TGHTopoMainWindow.acCoupeDeveloppeeExecute(Sender: TObject);
begin
  if (FDocTopoOpenedAndReady) then AfficherEditeurCoupeDeveloppee(FDocumentToporobot);
end;

procedure TGHTopoMainWindow.acDistanceExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.SetModeTravail(mtDISTANCE_PREMIER_POINT);
end;

procedure TGHTopoMainWindow.acEditeurExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acEditItemExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acExport2DODGExecute(Sender: TObject);
begin
  ;
end;

procedure TGHTopoMainWindow.acExport2DSVGExecute(Sender: TObject);
var
  QAT: TStringDirectoryFilename;
  QFilterIndex: integer;
  EWE: TVue2DParams;
begin
  (*QAT := 'SVG_2D_001.svg';
  if (DoDialogSaveFile('Scalable Vector Graphics (*.svg)|*.svg', '.svg', QAT, QFilterIndex)) then
  begin
    EWE := GHTopoContext2DA1.GetOngletByIndex(GHTopoContext2DA1.GetCurrentOngletIdx);
    FBDDEntites.ExportVue2DSVG(QAT, False, EWE.ongModeRepresentation, EWE.ongElementsDrawn);
    ShowMessage('Done');
  end;
  //*)
end;



procedure TGHTopoMainWindow.acExporterTEXTExecute(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QIdxFilter: integer;
begin
  if (not FDocTopoOpenedAndReady) then Exit;
  QFileName := ChangeFileExt(FCurrentNomFichierXTB, '.Text');
  if (DoDialogSaveFile('Toporobot TEXT (*.Text)|*.Text', '.Text', QFileName, QIdxFilter)) then
  begin
    FDocumentToporobot.ExporterVersToporobotTEXT(QFileName, 160.00, false);
    // actualisation du nouveau nom de fichier
    FCurrentNomFichierXTB := QFileName;
    self.Caption:=Format(rsMAINMENUCAPTION,[FCurrentNomFichierXTB]);
  end;
end;

procedure TGHTopoMainWindow.acExportGHCaveDrawExecute(Sender: TObject);
var
  WU: TStringDirectoryFilename;
  QFilterIndex: integer;
  procedure MiouMiou(const QBDD: TBDDEntites; const FicGCP: string);
  begin
    QBDD.SetProcDisplayProgression(nil);
    QBDD.ExportForGHCaveDraw(FicGCP, '');
  end;
begin
  if (not FDocTopoOpenedAndReady) then Exit;
  WU := ChangeFileExt(FCurrentNomFichierXTB, '.gcp');
  if (DoDialogSaveFile('GHCaveDraw Polygonal (*.gcp)|*.gcp', '.gcp', WU, QFilterIndex)) then MiouMiou(FBDDEntites, WU);
end;

procedure TGHTopoMainWindow.acExportGISExecute(Sender: TObject);
begin
  if (FDocTopoOpenedAndReady) then DisplayExportSIG(FBDDEntites);
end;

procedure TGHTopoMainWindow.acExportPocketTopoExecute(Sender: TObject);
var

  QFilterIndex: integer;
  WU: TStringDirectoryFilename;
begin
  if (not FDocTopoOpenedAndReady) then Exit;
  WU := ExtractFileName(FDocumentToporobot.GetDatabaseName);
  if (GHTopoQuestionOuiNon('PocketTopo ne supporte pas les entrées multiples ni certains codes intruments' +#13+#10 + 'Continuer ?')) then
  begin
    if (DoDialogSaveFile('PochetTopo text file (*.Text)|*.Text', '.Text', WU, QFilterIndex)) then
    begin
      FDocumentToporobot.IsGHTopoCodesInstrumentsExtended;
      FDocumentToporobot.ExporterVersToporobotTEXT(WU, 40, True);
    end;
  end;
end;

procedure TGHTopoMainWindow.acExportPostScriptExecute(Sender: TObject);
begin
  ;
end;

procedure TGHTopoMainWindow.acFenetreConsoleExecute(Sender: TObject);
begin
  {$IFDEF MSWINDOWS}                     dlgProcessing.SetFocus; {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED} dlgProcessing.SetFocus; {$ENDIF}
end;

procedure TGHTopoMainWindow.acFenetreDeDonneesExecute(Sender: TObject);
begin
  PageControl1.ActivePageIndex := INDEX_ONGLET_SERIES;
end;

procedure TGHTopoMainWindow.acFenetreVueEnPlanExecute(Sender: TObject);
begin
  PageControl1.ActivePageIndex := INDEX_ONGLET_VUE_EN_PLAN;
end;

procedure TGHTopoMainWindow.acFermerExecute(Sender: TObject);
begin
  InitNewDocument();
end;

procedure TGHTopoMainWindow.acFindstationExecute(Sender: TObject);
var
  QDoMatchExact: Boolean;
  QIdxSerie, QIdxPt, QIdxIDTerrainFound: Integer;
  QFindWhat: string;
  EWE: TEntiteEtendue;
begin
  QDoMatchExact := false;
  QIdxSerie := -1;
  QIdxPt    := -1;
  QIdxIDTerrainFound := -1;
  if (DispDlgFindIDTerrain(FDocumentToporobot, QDoMatchExact, QFindWhat)) then
  begin
    if (FBDDEntites.FindStationByCle(QDoMatchExact, QFindWhat, EWE)) then
    begin
      GHTopoContext2DA1.SetCurrentEntite(EWE);
      GHTopoContext2DA1.CentrerVueSurPointXY(EWE.Une_Station_2_X, EWE.Une_Station_2_Y, True, EWE.oIDLitteral);
    end
    else ShowMessage(GetResourceString(rsMATCHNOTFOUND));
  end
  else
  begin
    ShowMessage(GetResourceString(rsMATCHNOTFOUND));
  end;
end;

procedure TGHTopoMainWindow.acGenererDossierTherionExecute(Sender: TObject);
begin
  if (not FDocTopoOpenedAndReady) then Exit;
  with TSelectDirectoryDialog.Create(Application) do
  begin
    InitialDir := GetGHTopoDirectory();
    Options := Options + [ofOverwritePrompt];
    if (Execute) then
    begin
      FDocumentToporobot.GenererDossierTherion(FileName);
    end;
  end;
end;

procedure TGHTopoMainWindow.acHelpNewsExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acHelpSystemExecute(Sender: TObject);
begin
  DisplayHelpSystem('');
end;

procedure TGHTopoMainWindow.acInfosCaviteExecute(Sender: TObject);
var
  LS: TStringList;
  WU: String;
begin
  if (not FDocTopoOpenedAndReady) then Exit;
  LS := TStringList.Create;
  try
    FDocumentToporobot.GetInfosCavite(LS);
    if (LS.Count > 0) then
    begin
      WU := GetGHTopoDirectory() + '_miaou.txt';
      LS.SaveToFile(WU);
      DisplayTextEditor(WU, False);
    end;
  finally
    LS.Free;
  end;

end;

procedure TGHTopoMainWindow.acMaillagesUtilsExecute(Sender: TObject);
var
  frmMNT: TfrmMaillagesMNT;
begin
  frmMNT := TfrmMaillagesMNT.Create(Application);
  try
    frmMNT.InitialiserDlgMaillage;
    frmMNT.ShowModal;
    frmMNT.FinaliserDlgMaillage;
  finally
    frmMNT.Release;
  end;
end;

procedure TGHTopoMainWindow.acNew3DViewerbyFileExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acNewExecute(Sender: TObject);
begin
  InitNewDocument();
end;

procedure TGHTopoMainWindow.acNodesCoordinatesExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.InitNewDocument();
var
  QFileName: String;
begin
  if (FDocTopoOpenedAndReady) then begin
    if (not GHTopoQuestionOuiNon('Un document est déjà ouvert - Continuer')) then Exit;
  end;
  CloseAllDocuments;
  // L'assistant provoque une erreur inexplicable (Invalid handle file) lors du chargement
  // --> contournement via un fichier ébauche
  QFileName   := GetGHTopoDirectory() + 'QCaveStub.xtb';
  if (not FileExists(QFileName)) then RegenererEbaucheXTB(QFileName, 27573);
  ChargerLaTopoExt(QFilename, True);
  ActiverMenus(True);
end;

procedure TGHTopoMainWindow.lsbListeClick(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acOuvrirTopoExtExecute(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
begin
  if (FDocTopoOpenedAndReady AND (not GHTopoQuestionOuiNon(rsWARN_FILEALREADYOPEN))) then Exit;
  QFileName := GetGHTopoDirectory() + 'Topographie1.xtb';

  if (DoDialogOpenFileGHTopo(FListeFichiersRecents, QFileName)) then
  //if (DoDialogOpenFile(GetResourceString(rsGHTOPO_FILE_FILTER_W_TEXT), '.xtb', QFileName)) then
  begin
    CloseAllDocuments();
    ChargerLaTopoExt(QFilename, true);
    AfficherMessage('PRET');
    ActiverMenus(True);
  end;
end;

procedure TGHTopoMainWindow.acPanVueExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.SetModeTravail(mtPAN_PREMIER_POINT);
end;



procedure TGHTopoMainWindow.acQuitExecute(Sender: TObject);
begin
  self.Close;
end;

procedure TGHTopoMainWindow.acReloadExecute(Sender: TObject);
begin
  if (FDocTopoOpenedAndReady AND (not GHTopoQuestionOuiNon(GetResourceString(rsDO_RELOAD_DOCUMENT)))) then Exit;
  CloseAllDocuments();
  ChargerLaTopoExt(FCurrentNomFichierXTB, true);
  AfficherMessage('PRET');
  ActiverMenus(True);
end;

procedure TGHTopoMainWindow.acRendu3DExecute(Sender: TObject);
begin
  {$IFDEF USE_VIEWER_OPENGL}
    if (FDocTopoOpenedAndReady) then DisplayVue3DOpenGLExt(FBDDEntites, FMonMaillage, '');
  {$ELSE}
    ShowMessage('Viewer OpenGL disabled');
  {$ENDIF}
end;

procedure TGHTopoMainWindow.acSandBoxExecute(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.acSaveAsExecute(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  if (not FDocTopoOpenedAndReady) then Exit;
  QFileName := FCurrentNomFichierXTB;
  if (DoDialogSaveFile(GetResourceString(rsGHTOPO_FILE_FILTER_WO_TEXT), '.xtb', QFileName, QFilterIndex)) then
  begin
    case QFilterIndex of
      1: FDocumentToporobot.SaveToFile(QFileName,mtabEXTENDEDTAB, tfWINDOWS);
      2: FDocumentToporobot.SaveToXML(QFileName); // futur format standard de GHTopo
      3: FDocumentToporobot.SaveToFile(QFileName,mtabTOPOROBOT, tfMAC);
    end; // case FilterIndex
    // actualisation du nouveau nom de fichier
    FCurrentNomFichierXTB := QFileName;
    self.Caption:=Format(rsMAINMENUCAPTION,[FCurrentNomFichierXTB]);
  end;
end;

procedure TGHTopoMainWindow.acSnapShotExecute(Sender: TObject);
begin

end;


procedure TGHTopoMainWindow.acStatsExecute(Sender: TObject);
begin
  if (FDocTopoOpenedAndReady) then DisplayStatistiquesExt(FDocumentToporobot, FBDDEntites);
end;



procedure TGHTopoMainWindow.acVue3DFiltreeExecute(Sender: TObject);
var
  EWE: TVue2DParams;
begin
  EWE := GHTopoContext2DA1.GetOngletByIndex(0);
  if (FBDDEntites.GetNbEntitesMetafiltrees() < 3) then
  begin
    ShowMessage(GetResourceString(rsMSG_METAFILTRE_ALL_REJECTED));
    Exit;
  end;
  DisplayVue3DGDIExt(FBDDEntites, EWE.ongVueFiltres);
end;

//******************************************************************************
procedure TGHTopoMainWindow.InitLesCaptions;
  procedure SetAcHint(const A: TAction; const H: string);
  begin
    A.Hint    := GetResourceString(H);
    A.Caption := A.Hint;
  end;
var
  WU: String;
begin
   mnuFichier.Caption := GetResourceString(rsMNU_FILE);
    SetAcHint(acNew              , GetResourceString(rsNEW));
    SetAcHint(acOuvrirTopoExt    , GetResourceString(rsOPEN));
    SetAcHint(acSaveAs           , GetResourceString(rsSAVEAS));
    SetAcHint(acPrint            , GetResourceString(rsPRINT));
    SetAcHint(acEditeur          , GetResourceString(rsEDITTAB));
    SetAcHint(acExportVTopo      , GetResourceString(rsVTOPO));
    //SetAcHint(acExportTherion    , GetResourceString(rsEXPORT_THERION));
    //SetAcHint(acGenererDossierTherion, GetResourceString(rsGENERER_DOSSIER_THERION));

    SetAcHint(acExporterTEXT     , GetResourceString(rsEXPORT_TOPOROBOT));
    SetAcHint(acExportPocketTopo , GetResourceString(rsEXPORT_POCKETTOPO));
    //SetAcHint(acExportTopodroid  , GetResourceString(rsEXPORT_TOPODROID));
    //SetAcHint(acExportGIS        , GetResourceString(rsEXPORT_GIS));
    SetAcHint(acExportGHCaveDraw , GetResourceString(rsGHCAVEDRAW));
    SetAcHint(acRecents          , GetResourceString(rsRECENT_DOCS));
    SetAcHint(acReload           , GetResourceString(rsRELOAD));
    SetAcHint(acDisplayErrorsXTB , GetResourceString(rsERRINFOXTB));
    SetAcHint(acFermer           , GetResourceString(rsCLOSE));
    SetAcHint(acExportSeriesTableauCroise, GetResourceString(rsEXPORT_SERIES_TAB_CROISE));

    SetAcHint(acQuit             , GetResourceString(rsGHTOPO_QUIT));

  mnuTopographie.Caption:= GetResourceString(rsMNU_TOPOGRAPHIE);
    SetAcHint(acCheckBase        , GetResourceString(rsCHECKBASE));
    SetAcHint(acCompileExt       , GetResourceString(rsCOMPILE));
    SetAcHint(ac3DView           , GetResourceString(rsVUE3D));
    SetAcHint(acRendu3D          , GetResourceString(rsRENDU3D));
    SetAcHint(acStats            , GetResourceString(rsSTATISTIQUES));
    //SetAcHint(acNodesCoordinates , GetResourceString(rsNODESCOORDINATES));
    SetAcHint(acToolCalculette    , GetResourceString(rsDLG_CALC_TITLE));
    SetAcHint(acMaillagesUtils   , GetResourceString(rsMAILLAGES_UTILS));
  mnuFenetre.Caption    := GetResourceString(rsMNU_WINDOW);
    SetAcHint(acFenetreConsole      , GetResourceString(rsWND_CONSOLE));
    SetAcHint(acFenetreDeDonnees    , GetResourceString(rsWND_DATABASE));
    SetAcHint(acFenetreVueEnPlan    , GetResourceString(rsWND_PLAN));

  mnuHelp.Caption    := GetResourceString(rsMNU_HELP);
    SetAcHint(acHelpSystem       , GetResourceString(rsABOUT));
//    SetAcHint(acHelpNews         , GetResourceString(rsHLPNEWS));
end;


// Ancien dialogue DistoX
procedure TGHTopoMainWindow.MenuItem36Click(Sender: TObject);
begin
  DisplayOldDlgDistoX();
end;
procedure TGHTopoMainWindow.DisplayOldDlgDistoX();
begin
  with TdlgUtilsDistoX.Create(Application) do
  begin
    try
      InitialiserDialogDistoX();
      ShowModal;
    finally
      Release;
    end;
  end;
end;

procedure TGHTopoMainWindow.OngletsVuesChange(Sender: TObject);
var
  EWE: TVue2DParams;
begin
  GHTopoContext2DA1.SetCurrentIdxOnglet(0);
  EWE := GHTopoContext2DA1.GetOngletByIndex(0);
end;

procedure TGHTopoMainWindow.PageControl1Change(Sender: TObject);
begin
  pnlTollBarCtrlVue2D.Enabled := (PageControl1.ActivePageIndex = INDEX_ONGLET_VUE_EN_PLAN);
end;

// activer/désactiver options de menus
procedure TGHTopoMainWindow.ActiverMenus(const R90Mode: boolean);
begin
  acSaveAs.Visible           := R90Mode;
  acPrint.Visible            := R90Mode;
  acEditeur.Visible          := R90Mode;
  acExportVTopo.Visible      := R90Mode;
  acExportGIS.Visible        := R90Mode;
  acExporterTEXT.Visible     := R90Mode;
  acExportGHCaveDraw.Visible := R90Mode;
  acReload.Visible           := R90Mode;
  acCheckBase.Visible        := R90Mode;
  acDisplayErrorsXTB.Visible := R90Mode;
  mnuTopographie.Visible     := R90Mode;
  ac3DView.Visible           := R90Mode;
  acCompileExt.Visible       := R90Mode;
  acRendu3D.Visible          := R90Mode;
  acStats.Visible            := R90Mode;
  acInfosCavite.Visible      := R90Mode;
  mnuFenetre.Visible         := True;
  acUtilsDistoX.Visible      := True;    // Plus aucun lien avec un doc topo
  {$IFDEF GROS_MINET}
    acUtilsDistoX.Visible      := false;
    acExportDXF.Visible        := false;
    acExportABRIS.Visible      := false;
    acExportPLT.Visible        := false;
    acExportGHCaveDraw.Visible := false;
    acReload.Visible           := false;
    acCoupeDeveloppee.Visible  := false;
    acUtilsDistoX.Visible      := False;    // Plus aucun lien avec un doc topo

  {$ENDIF}
  acFenetreConsole.Visible   := True;
  acFenetreVueEnPlan.Visible := R90Mode;
  acFenetreDeDonnees.Visible := R90Mode;

  acExportPocketTopo.Visible := R90Mode;
  {$IFDEF GROS_MINET}
    tabShtAntennes.TabVisible    := false;
    //tabShtSeriesFlat.TabVisible  := false;
  {$ELSE}
    tabShtAntennes.TabVisible    := True;
    //tabShtSeriesFlat.TabVisible  := false;
  {$ENDIF}

  PageControl1.ActivePageIndex := INDEX_ONGLET_SERIES;
end;

procedure TGHTopoMainWindow.acZoomAllExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.ResetVue();
end;

procedure TGHTopoMainWindow.acZoomMoinsExecute(Sender: TObject);
begin
  GHTopoContext2DA1.ZoomFact(1 - 0.05);
end;

procedure TGHTopoMainWindow.acZoomPlusExecute(Sender: TObject);
begin
  GHTopoContext2DA1.ZoomFact(1 + 0.05);
end;

procedure TGHTopoMainWindow.acZoomWindowExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.SetModeTravail(mtZOOM_PREMIER_COIN);
end;

procedure TGHTopoMainWindow.Button3Click(Sender: TObject);
var
  EWE: TLabelSystemesCoordsEPSG;
begin
  FDocumentToporobot.SetNomEtude(_LCLStrToAnsi(Trim(editNomEtude.Text)));
  FDocumentToporobot.SetCommentairesEtude(_LCLStrToAnsi(Trim(editCommentaireEtude.Text)));
  EWE := FConvertisseurCoordonnees.GetCodeEPSGNomSysteme(cmbSystemesCoordonnees.ItemIndex);
  FDocumentToporobot.SetCodeEPSGSystemeCoordonnees(EWE);
end;

procedure TGHTopoMainWindow.Button4Click(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.CdrListesSimples1Click(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.chkJonctionsChange(Sender: TObject);
begin

end;


//******************************************************************************
function TGHTopoMainWindow.CalculerLeReseauExt: boolean;
var
  QCodeCalcul: TCodeDeCalcul;
  EWE: String;
begin
  Result := False;
  Application.ProcessMessages;
  AfficherMessage('-- Calcul du reseau (nouvelle version)');
  ProgressBar1.Visible := true;
  QCodeCalcul := TCodeDeCalcul.Create;
  try
    QCodeCalcul.Initialiser(FDocumentToporobot, FPalette256);
    QCodeCalcul.SetProcDisplayProgression(self.AfficherProgression);
    Result    := QCodeCalcul.CalculComplet(FBDDEntites, False);
    QCodeCalcul.SetProcDisplayProgression(nil);
    Result := True;
  finally
    QCodeCalcul.Finaliser();
    lbOperationEnCours.Caption := GetResourceString(rsCALCUL_TERMINE);
    ProgressBar1.Visible := false;
    QCodeCalcul.Free;
  end;
end;
// fermer tous les documents
procedure TGHTopoMainWindow.CloseAllDocuments;
begin
  if Not(FDocTopoOpenedAndReady) then Exit;
  AfficherMessage('CloseAllDocuments');
  FDocTopoOpenedAndReady := False;
  FDocumentToporobot.ClearListeSeries();          // vidage des séries
  FDocumentToporobot.ViderTablesSimples();        // vidage autres tables
  //CloseVues;
  ActiverMenus(False);
  self.Caption := Format(rsMAINMENUCAPTION,['Untitled']);
end;

procedure TGHTopoMainWindow.editSearchChange(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin

end;



//******************************************************************************
// charger la topo
// Chargement de la topo
function TGHTopoMainWindow.ChargerLaTopoExt(const FC: TStringDirectoryFileName; const DoCalc: boolean): boolean;
var
  QSR: TObjSerie;
  QInternalSerie: integer;
begin
  Result := false;
  AfficherMessage(Format('%s.ChargerLaTopoExt: %s', [ClassName, FC]));
  {$IFDEF MSWINDOWS}
     dlgProcessing.lsbJournal.Clear;
     dlgProcessing.memoErreurs.Lines.Clear;
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
  dlgProcessing.FormStyle := fsStayOnTop; // mettre la console en avant-plan
  dlgProcessing.lsbJournal.Clear;
  dlgProcessing.memoErreurs.Lines.Clear;
  {$ENDIF}
  // activer le menu de sauvegarde
  acSaveAs.Visible := True;
  FDocumentToporobot.SetDatabaseName(FCurrentNomFichierXTB);
  // vérifier si c'est un fichier Text
  if (Pos('.text', LowerCase(FC))>0) then
  begin
    if (FDocumentToporobot.LoadFichierText(FC) < 0) then
    begin
      AfficherMessageErreur('Le fichier comporte des erreurs - Voir les consoles');
      FDocumentToporobot.Finaliser;   // Echec = on détruit l'objet
      Exit;
    end;
  end
  else if (Pos('.gtx', FC) > 0) then // fichier GHTopo XML ?
  begin
    if (FDocumentToporobot.LoadFromXML(FC) < 0) then
    begin
      AfficherMessageErreur('Le fichier comporte des erreurs. Il doit être audité dans un éditeur XML');
      FDocumentToporobot.Finaliser;
      Exit;
    end;
  end

  else
  begin // sinon, c'est un fichier supposé Tab ou XTB
    if (FDocumentToporobot.LoadFichierTab(FC)<0) then
    begin
      AfficherMessageErreur('Le fichier comporte des erreurs - Voir le rapport');
      DisplayTextEditor(GetGHTopoDirectory() + ChangeFileExt(ExtractFileName(FDocumentToporobot.GetDatabaseName), '.err'), True);
      // Echec = on détruit l'objet
      FDocumentToporobot.Finaliser;
      Exit;
    end;
  end;
  //ShowMessage(DatabaseName);
  self.Caption:=Format(rsMAINMENUCAPTION, [ExtractFileName(FC)]);

  RecalculerEtActualiser();

  self.Top  := 0;
  self.Left := 0;
  {$IFDEF MSWINDOWS}                     dlgProcessing.FormStyle:=fsNormal; {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED} dlgProcessing.FormStyle:=fsNormal; {$ENDIF}
  PageControl1.ActivePageIndex := 0; //tabShtVueEnPlan.TabIndex;
  // tout est OK ?
  Result := True;
  FCurrentNomFichierXTB := FC;
  self.Caption := FC;
  Application.ProcessMessages;

end;


//******************************************************************************
// préparation du frontal de la BDD
procedure TGHTopoMainWindow.PreparerFrontal();
begin
  Application.ProcessMessages;
  AfficherMessage('Préparation du frontal de la base de données');
  AfficherMessage(Format('%d entrees; %d reseaux; %d secteurs; %d codes; %d expes; %d series; %d antennes',
                         [FDocumentToporobot.GetNbEntrees,
                          FDocumentToporobot.GetNbReseaux,
                          FDocumentToporobot.GetNbSecteurs,
                          FDocumentToporobot.GetNbCodes,
                          FDocumentToporobot.GetNbExpes,
                          FDocumentToporobot.GetNbSeries,
                          FDocumentToporobot.GetNbAntennes]));
  // onglet General
  editNomEtude.Text         := _AnsiToLCLStr(FDocumentToporobot.GetNomEtude);
  editCommentaireEtude.Text := _AnsiToLCLStr(FDocumentToporobot.GetCommentairesEtude);
  // combo des systèmes de coordonnées
  RemplirCombosSystemesCoordonnees(FConvertisseurCoordonnees,
                                   cmbSystemesCoordonnees, True,
                                   FDocumentToporobot.GetCodeEPSGSystemeCoordonnees().CodeEPSG);
  // cadre des listes simples (codes, expés, ...);
  CdrListesSimples1.Initialiser(FDocumentToporobot, FBDDEntites, FPalette256, mbddENTRANCES);
  // préparation de l'onglet Séries
  CdrListeSeries1.Initialise(FDocumentToporobot, AfficherUneSerie, ApplyModificationSerie, [tbsAPPLY, tbsADD, tbsSORT, tbsCSV, tbsHELP], false);

  // table des antennes
  CdrAntennes1.Initialise(FDocumentToporobot);
  // liste des séries en mode flat
  {$IFDEF GROS_MINET}
    // CdrEditSeriesModeFlat1.Initialiser(FDocumentToporobot);
  {$ELSE}
    //CdrEditSeriesModeFlat1.Initialiser(FDocumentToporobot);
  {$ENDIF}

end;
procedure TGHTopoMainWindow.PreparerVue2D();
var
  o: Integer;
  Ong: TVue2DParams;
begin
  GHTopoContext2DA1.Initialiser(FDocumentToporobot,
                                FBDDEntites,
                                CdrDistoX1.getPtrDistoX(),
                                FMonMaillage,
                                nil,
                                nil,
                                RecalculerEtActualiser);

  //GHTopoContext2DA1.SetProcActualiserAffichagesBDD(nil);
  // préparation des OngletsVues
  Ong := GHTopoContext2DA1.GetOngletByIndex(0);
  GHTopoContext2DA1.SetModeRepresentation(Ong.ongModeRepresentation);
  // les captions
  //InitLesCaptions;
  // les panneaux
  //pnlListeSeries.Visible := false;
  //pnlDiagrammes.Visible := false;
  // liste latérale gauche
end;

procedure TGHTopoMainWindow.Shape1ChangeBounds(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.tabshtGeneralContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TGHTopoMainWindow.VueClick(Sender: TObject);
begin

end;

//******************************************************************************
// callbacks pour le cadre ListeSérie
procedure TGHTopoMainWindow.AfficherUneSerie();
var
  n: Integer;
  EWE: TObjSerie;
begin
  n := CdrListeSeries1.GetSelectedIndex();
  if (n < 0) then Exit;
  EWE := FDocumentToporobot.GetSerie(n);
  CdrSerieIndependant1.Initialise(FDocumentToporobot,
                                  GHTopoContext2DA1.GetPtrBDDEntites(),
                                  EWE, n);
end;
// Appliquer les modifs de la série
procedure TGHTopoMainWindow.ApplyModificationSerie();
var
  n, QOldIdxSerie: Integer;
  EWE: TObjSerie;
begin
  n := CdrListeSeries1.GetSelectedIndex();
  if (n = 0) then // DONE: la série 0 n'est pas modifiable
  begin
    ShowMessage(rsMSG_SERIE_INITIALISATION);
    Exit;
  end;
  EWE := FDocumentToporobot.GetSerie(n);
  QOldIdxSerie := EWE.GetNumeroDeSerie();
  //ShowMessageFmt('Série %d sélectionnée: %d: %s', [n, EWE.GetIndexSerie(), EWE.GetNomSerie()]);
  if (CdrSerieIndependant1.ImplementerModifs()) then
  begin
    CdrSerieIndependant1.RefreshTableaux();
    EWE := FDocumentToporobot.GetSerie(n);
    // ici, on ne reliste pas la table des séries.
    // comme une série est un pointeur,
    // les modifications apparaîtront dans la liste au prochain clic
    //CdrListeSeries1.Relister(0);
    // si le numéro de série a changé, on liste les antennes
    if (QOldIdxSerie <> EWE.GetNumeroDeSerie()) then
    begin
      //CdrAntennes1.RemplirTableau();
    end;
  end;
end;

procedure TGHTopoMainWindow.btnApplyParamsClick(Sender: TObject);
var
  Idx: Integer;
  WU: TVue2DParams;
begin
  Idx := GHTopoContext2DA1.GetCurrentOngletIdx();
  WU  := GHTopoContext2DA1.GetOngletByIndex(Idx);
  //WU  := cdrParamsOngletVue2D1.GetValuesOnglet2D;
  GHTopoContext2DA1.SetModeRepresentation(WU.ongModeRepresentation);
  GHTopoContext2DA1.PutOngletByIndex(Idx, WU, true);
  GHTopoContext2DA1.RedessinEcran(True);
end;

procedure TGHTopoMainWindow.btnCloseDistoXClick(Sender: TObject);
begin

end;

procedure TGHTopoMainWindow.Button1Click(Sender: TObject);
begin

end;

//******************************************************************************

procedure TGHTopoMainWindow.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose:=False;
  if (MessageDlg(EnlevePerluete(GetResourceString(rsGHTOPO_QUIT)), mtConfirmation, [mbYes, mbNo],0)=mrYES) then
  begin
    try
      FDocumentToporobot.Finaliser;
      FBDDEntites.Finaliser();
      FMonMaillage.Finaliser();
      FConvertisseurCoordonnees.Finaliser();

    finally
      //FDocumentToporobot.Free;
      FBDDEntites.Free;
      //FMonMaillage.Free;
      FPalette256.Free;
      FConvertisseurCoordonnees.Free;
      FListeFichiersRecents.Free;
    end;
    AfficherMessage(GetResourceString(rsEND_OF_GHTOPO));
    CanClose:=True;
  end;
end;

end.

