unit frmVuePlan2D;

{$INCLUDE CompilationParameters.inc}

interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  Classes, SysUtils,
  StructuresDonnees,
  Common,
  ToporobotClasses2012,
  UnitEntitesExtended,
  unitclassemaillage,
  CadreGHTopoContext2D,
  CallDialogsStdVersion, unitUtilsComposants,
  CadreListesPourVueGraphique,
  FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls, Buttons, ActnList, PairSplitter, StdCtrls;

type

  { TfrmVueEnPlan }

  TfrmVueEnPlan = class(TForm)
    acF2DZoomAll: TAction;
    acF2DZoomPlus: TAction;
    acF2DZoomMoins: TAction;
    acF2DPanVue: TAction;
    acF2DZoomFenetre: TAction;
    acF2DParamOnglet: TAction;
    acF2DRendu3D: TAction;
    acF2DStatistiques: TAction;
    acF2DDistance: TAction;
    acF2DVue3D: TAction;
    acF2DPrintPlan: TAction;
    acF2DLocaliserStation: TAction;
    acShowFenetreSeries: TAction;
    acShowFenetreListeSimples: TAction;
    acShowFenetreConsole: TAction;
    acCreerTimelapse: TAction;
    acSaveAs: TAction;
    acFermerUnCheminement: TAction;
    acLoadMaillage: TAction;
    acF2DExportDXF: TAction;
    acF2DExportSVG: TAction;
    acF2DCalculerLeReseau: TAction;
    acF2DExtractProfilTerrain: TAction;
    ActionList1: TActionList;
    CdrListesPourVisualisateurs1: TCdrListesPourVisualisateurs;
    GHTopoContext2DA1: TGHTopoContext2DA;
    ImageList1: TImageList;
    PairSplitter1: TPairSplitter;
    PairSplitter2: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    PairSplitterSide3: TPairSplitterSide;
    PairSplitterSide4: TPairSplitterSide;
    Panel1: TPanel;
    OngletsVues: TTabControl;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton24: TSpeedButton;
    SpeedButton25: TSpeedButton;
    SpeedButton26: TSpeedButton;
    SpeedButton27: TSpeedButton;
    SpeedButton28: TSpeedButton;
    SpeedButton29: TSpeedButton;
    SpeedButton30: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure acAddAnnotationHereExecute(Sender: TObject);
    procedure acCreerTimelapseExecute(Sender: TObject);
    procedure acF2DCalculerLeReseauExecute(Sender: TObject);
    procedure acF2DDistanceExecute(Sender: TObject);
    procedure acF2DExportSVGExecute(Sender: TObject);
    procedure acF2DExtractProfilTerrainExecute(Sender: TObject);
    procedure acF2DLocaliserStationExecute(Sender: TObject);
    procedure acF2DPanVueExecute(Sender: TObject);
    procedure acF2DParamOngletExecute(Sender: TObject);
    procedure acF2DPrintPlanExecute(Sender: TObject);
    procedure acF2DZoomAllExecute(Sender: TObject);
    procedure acF2DZoomFenetreExecute(Sender: TObject);
    procedure acF2DZoomMoinsExecute(Sender: TObject);
    procedure acF2DZoomPlusExecute(Sender: TObject);
    procedure acF2DRendu3DExecute(Sender: TObject);
    procedure acF2DStatistiquesExecute(Sender: TObject);
    procedure acF2DVue3DExecute(Sender: TObject);
    procedure acFermerUnCheminementExecute(Sender: TObject);
    procedure acLoadMaillageExecute(Sender: TObject);
    procedure acSaveAsExecute(Sender: TObject);
    procedure acShowFenetreConsoleExecute(Sender: TObject);
    procedure acShowFenetreListeSimplesExecute(Sender: TObject);
    procedure acShowFenetreSeriesExecute(Sender: TObject);

    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure OngletsVuesChange(Sender: TObject);
  private
    { private declarations }
    FBDDEntites: TBDDEntites;
    FDocTopo   : TToporobotStructure2012;
    FMaillageMNT: TMaillage;
    FCurrentNomFichierXTB: TStringDirectoryFilename;
    FProcRecalculerReseau: TProcedureOfObject;
    procedure InitCaptions();
    procedure InitialiserListeLocalisation();
    procedure PreparerVues();

  public
    { public declarations }
    function InitialiserVue2D(const D: TToporobotStructure2012;
                              const P: TBDDEntites;
                              const M: TMaillage;
                              const QFileName: TStringDirectoryFilename;
                              const QProcRecalcul: TProcedureOfObject): boolean;
    procedure Finaliser();

    function  GetParamsOngletCourant(): TVue2DParams;
    procedure PutParamsOngletCourant(const O: TVue2DParams);
    function  GetMaillage(): TMaillage;
  end;

var
  frmVueEnPlan: TfrmVueEnPlan;

implementation
{$R *.lfm}

{ TfrmVueEnPlan }
uses
  frmFrontalSeries
  {$IFDEF DISP_FRM_LISTES_SIMPLES}, frmLesListesSimples {$ENDIF}
  {$IFDEF DISP_FRM_LISTES_SIMPLES}, frmJournal {$ENDIF}
  ;

procedure TfrmVueEnPlan.acF2DDistanceExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.SetModeTravail(mtDISTANCE_PREMIER_POINT);
end;

procedure TfrmVueEnPlan.acF2DExportSVGExecute(Sender: TObject);
var
  QFilename: TStringDirectoryFilename;
  QFilterIndex: integer;
  O: TVue2DParams;
begin
  QFilename := 'Plan2D_SVG.svg';
  if (DoDialogSaveFile('Scalable Vectors Graphics (SVG)|*.svg', '.svg', QFilename, QFilterIndex)) then
  begin
    O := GHTopoContext2DA1.GetCurrentOnglet();
    FBDDEntites.ExportVue2DSVG(QFilename, false, O.ongModeRepresentation, O.ongElementsDrawn, 255);
  end;
end;

procedure TfrmVueEnPlan.acF2DExtractProfilTerrainExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw and GHTopoContext2DA1.IsMaillageReady()) then
     GHTopoContext2DA1.SetModeTravail(mtPROFIL_MNT_PREMIER_POINT)
  else
    ShowMessage('Maillage MNT invalide, non chargé ou non tracé');
end;

procedure TfrmVueEnPlan.acCreerTimelapseExecute(Sender: TObject);
var
  QDirectory: string;
begin
  if (SelectDirectory(GetResourceString(rsCDR_VUE2D_CREATE_TIMELAPSE),
                      GetGHTopoDirectory(),
                      QDirectory)) then
  begin
    GHTopoContext2DA1.CreerTimeLapse(QDirectory);

  end;
end;

procedure TfrmVueEnPlan.acF2DCalculerLeReseauExecute(Sender: TObject);
begin
  if (Assigned(FProcRecalculerReseau)) then FProcRecalculerReseau();
end;

procedure TfrmVueEnPlan.acAddAnnotationHereExecute(Sender: TObject);
begin
  ;
end;

procedure TfrmVueEnPlan.acF2DLocaliserStationExecute(Sender: TObject);
begin
  GHTopoContext2DA1.LocaliserUneStation();
end;

procedure TfrmVueEnPlan.acF2DPanVueExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.SetModeTravail(mtPAN_PREMIER_POINT);
end;

procedure TfrmVueEnPlan.acF2DParamOngletExecute(Sender: TObject);
var
  n: Integer;
  MyOnglet: TVue2DParams;
begin
  if (not GHTopoContext2DA1.CanDraw) then exit;
  n := GHTopoContext2DA1.GetCurrentOngletIdx();
  MyOnglet := GHTopoContext2DA1.GetOngletByIndex(n);
  if (ParametrerOngletVue2D(MyOnglet)) then
    GHTopoContext2DA1.PutOngletByIndex(n, MyOnglet, True);
end;

procedure TfrmVueEnPlan.acF2DPrintPlanExecute(Sender: TObject);
var
  WU: TVue2DParams;
begin
  WU := GetParamsOngletCourant();
  DisplayCentreImpressionExt(FDocTopo, WU, FBDDEntites);
end;

procedure TfrmVueEnPlan.acF2DZoomAllExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.ResetVue();
end;

procedure TfrmVueEnPlan.acF2DZoomFenetreExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.SetModeTravail(mtZOOM_PREMIER_COIN);
end;

procedure TfrmVueEnPlan.acF2DZoomMoinsExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.ZoomFact(1 - 0.05);
end;

procedure TfrmVueEnPlan.acF2DZoomPlusExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.ZoomFact(1 + 0.05);
end;

procedure TfrmVueEnPlan.acShowFenetreConsoleExecute(Sender: TObject);
begin
  PositionnerFenetre(dlgProcessing, 10, 120, 500, Screen.Height - 230);
  {$IFDEF MSWINDOWS}
    {$IFDEF DISP_FRM_JOURNAL}
      {$IFDEF GROS_MINET}
         dlgProcessing.Show;
      {$ELSE}
         dlgProcessing.SetFocus;
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED} dlgProcessing.SetFocus; {$ENDIF}
end;

procedure TfrmVueEnPlan.acShowFenetreListeSimplesExecute(Sender: TObject);
begin
  {$IFDEF DISP_FRM_LISTES_SIMPLES}
     PositionnerFenetre(frmListesSimples, 10, 140, Screen.Width - 500, Screen.Height - 300);
     frmListesSimples.SetFocus;
  {$ENDIF}
end;

procedure TfrmVueEnPlan.acShowFenetreSeriesExecute(Sender: TObject);
begin
  PositionnerFenetre(frmGestionSeries, 20, 120, Screen.Width - 300, Screen.Height - 260);
  frmGestionSeries.SetFocus;
end;

procedure TfrmVueEnPlan.acF2DRendu3DExecute(Sender: TObject);
var
  O: TVue2DParams;
begin
  {$IFDEF USE_VIEWER_OPENGL}
  if (GHTopoContext2DA1.CanDraw) then
  begin
    O := GHTopoContext2DA1.GetCurrentOnglet();
    DisplayVue3DOpenGLExt(FBDDEntites, FMaillageMNT, O.ongVueFiltres);
  end;
  {$ELSE}
    ShowMessage('Viewer OpenGL disabled');
  {$ENDIF}
end;

procedure TfrmVueEnPlan.acF2DStatistiquesExecute(Sender: TObject);
begin
  DisplayStatistiquesExt(FDocTopo, FBDDEntites);
end;

procedure TfrmVueEnPlan.acF2DVue3DExecute(Sender: TObject);
var
  O: TVue2DParams;
  M: TMaillage;
  G: TToporobotStructure2012;
begin
  O := GHTopoContext2DA1.GetCurrentOnglet();
  M := GHTopoContext2DA1.GetMaillage();
  G := GHTopoContext2DA1.GetDocuTopo();
  DisplayVue3DGDIExt(FBDDEntites, G, M, O.ongVueFiltres);
end;

procedure TfrmVueEnPlan.acFermerUnCheminementExecute(Sender: TObject);
begin
  if (GHTopoContext2DA1.CanDraw) then GHTopoContext2DA1.SetModeTravail(mtBOUCLER_PREMIER_POINT);
end;

procedure TfrmVueEnPlan.acLoadMaillageExecute(Sender: TObject);
var
  QFilename: TStringDirectoryFilename;
begin
  if (DoDialogOpenFile('Fichiers maillage (*.mai)|*.mai', '.mai', QFilename)) then
  begin
    GHTopoContext2DA1.ChargerMaillage(QFilename);
  end;
end;

procedure TfrmVueEnPlan.acSaveAsExecute(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  QFileName := FCurrentNomFichierXTB;
  if (DoDialogSaveFile(GetResourceString(rsGHTOPO_FILE_FILTER_WO_TEXT), '.xtb', QFileName, QFilterIndex)) then
  begin
    case QFilterIndex of
      1: FDocTopo.SaveToFile(QFileName,mtabEXTENDEDTAB, tfWINDOWS);
      2: FDocTopo.SaveToXML(QFileName); // futur format standard de GHTopo
      3: FDocTopo.SaveToFile(QFileName,mtabTOPOROBOT, tfMAC);
    end; // case FilterIndex
    // actualisation du nouveau nom de fichier
    FCurrentNomFichierXTB := QFileName;
    self.Caption:=Format(rsMAINMENUCAPTION,[FCurrentNomFichierXTB]);
  end;
end;

procedure TfrmVueEnPlan.Finaliser();
begin
  //ShowMessageFmt('%s.Finaliser()', [classname]);
end;

function TfrmVueEnPlan.GetParamsOngletCourant(): TVue2DParams;
var
  n: Integer;
begin
  n := GHTopoContext2DA1.GetCurrentOngletIdx();
  Result := GHTopoContext2DA1.GetOngletByIndex(n);
end;

procedure TfrmVueEnPlan.PutParamsOngletCourant(const O: TVue2DParams);
var
  n: Integer;
begin
  n := GHTopoContext2DA1.GetCurrentOngletIdx();
  GHTopoContext2DA1.PutOngletByIndex(n, O, True);

end;

function TfrmVueEnPlan.GetMaillage(): TMaillage;
begin
  Result := FMaillageMNT;
end;

procedure TfrmVueEnPlan.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose := false;
end;

procedure TfrmVueEnPlan.FormCreate(Sender: TObject);
begin

end;

procedure TfrmVueEnPlan.FormResize(Sender: TObject);
begin
  PairSplitterSide1.Width := self.Width - 400;
end;

procedure TfrmVueEnPlan.InitCaptions();
  procedure S666(const ACDC: TAction; const QCaption: string);
  var
    WU: String;
  begin
    WU := EnlevePerluete(GetResourceString(QCaption));
    ACDC.Caption := WU;
    ACDC.Hint    := WU;
  end;
begin
  S666(acF2DZoomAll         , rsCDR_VUE2D_AC_ZOOM_ALL);
  S666(acF2DZoomFenetre     , rsCDR_VUE2D_AC_ZOOM_WINDOW);
  S666(acF2DPanVue          , rsCDR_VUE2D_AC_PAN_VUE);

  S666(acF2DParamOnglet     , rsCDR_VUE2D_AC_PAN_VUE);
  //S666(acAddSerieHere     , rsCDR_VUE2D_ADD_SERIE_HERE);
  S666(acF2DDistance        , rsCDR_VUE2D_AC_DISTANCE_BT_STATIONS);
  S666(acF2DLocaliserStation   , rsCDR_VUE2D_LOCALISER_STATION);

  S666(acShowFenetreSeries          , rsWND_DATABASE);
  S666(acShowFenetreListeSimples    , rsWND_LISTES_SIMPLES);
  S666(acShowFenetreConsole         , rsWND_CONSOLE);
  S666(acCreerTimelapse             , rsCDR_VUE2D_CREATE_TIMELAPSE);
  S666(acSaveAs                     , rsSAVEAS);

  S666(acFermerUnCheminement        , rsCDR_VUE2D_CLOSE_BOUCLE);
  S666(acF2DExportSVG               , rsEXPORT_SVG);
  S666(acF2DCalculerLeReseau        , rsCOMPILE);
  S666(acF2DExtractProfilTerrain    , rsCDR_VUE2D_EXTRACT_PROFIL_FROM_MNT);
end;


function TfrmVueEnPlan.InitialiserVue2D(const D: TToporobotStructure2012;
                                        const P: TBDDEntites;
                                        const M: TMaillage;
                                        const QFileName: TStringDirectoryFilename;
                                        const QProcRecalcul: TProcedureOfObject): boolean;
begin
  result := false;
  FBDDEntites := P;
  FDocTopo    := D;
  FMaillageMNT:= M;
  FCurrentNomFichierXTB := QFileName;
  // init cadre vue 2D
  InitCaptions();
  GHTopoContext2DA1.Initialiser(FDocTopo, FBDDEntites, nil, FMaillageMNT, nil, nil, QProcRecalcul);
  PreparerVues();
  InitialiserListeLocalisation;
  FProcRecalculerReseau := QProcRecalcul;
  result := true;
end;





procedure TfrmVueEnPlan.InitialiserListeLocalisation();
begin
  CdrListesPourVisualisateurs1.InitialiseListeSelection(FDocTopo,
                                                        FBDDEntites,
                                                        GHTopoContext2DA1,
                                                        mslSERIE,
                                                        1,
                                                        false, true);
end;

procedure TfrmVueEnPlan.OngletsVuesChange(Sender: TObject);
begin
  GHTopoContext2DA1.SetCurrentIdxOnglet(OngletsVues.TabIndex);
end;



procedure TfrmVueEnPlan.PreparerVues();
var
  o: Integer;
  Ong: TVue2DParams;
begin
  // préparation des OngletsVues
  OngletsVues.Tabs.Clear;
  for o := 0 to GHTopoContext2DA1.GetNbOngletsVues() - 1 do
  begin
    Ong := GHTopoContext2DA1.GetOngletByIndex(o);
    OngletsVues.Tabs.Add(Ong.ongName);
  end;
  OngletsVues.TabIndex := 0;
  Ong := GHTopoContext2DA1.GetOngletByIndex(OngletsVues.TabIndex);
  //cdrParamsOngletVue2D1.SetValuesOnglet2D(Ong);
  GHTopoContext2DA1.SetModeRepresentation(Ong.ongModeRepresentation);
end;

end.

