unit MainWindowTablet81;
// Version de GHTopo pour tablette Touchlet XWi8 sous Windows 8.1
// Icones: Doivent être en 32x32

// TODO: Aide mémoire sous forme de textes en clair entraînant une erreur
//------------------------------------------------------------------------------
(*-- Le panneau "Stations" ne doit servir que pour l'entrée de données
Pour les infos stations, utiliser le même système que GHTopo classique (cadre masquable)

-- Immplanter une variable 'FSerieEnCoursEdition' dans Cadre...8-1
-- Saisie / édition de visées:
1. Choisir la série à traiter
2. Les dispositions du cadre Visée sont celles de TOPOROBOT Limelight
   + support DistoX ASAP
-- Dialogue de paramétrage de la vue en plan


Possibilités à ajouter:
- On peut réutiliser le gestionnaire de BDD de GHTopo classique
//*)
//------------------------------------------------------------------------------

{$INCLUDE CompilationParameters.inc}

interface

uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees,
  ToporobotClasses2012,
  CodeCalculTopo,
  UnitEntitesExtended,
  CallDialogsStdVersion, Common, CadreDessin2DTablette81, ObjetSerie,
  CadreListeViseesEnAntenne, Classes, SysUtils, FileUtil, curredit, Forms,
  Controls, Graphics, Dialogs, ActnList, Buttons, ExtCtrls, FileCtrl, StdCtrls,
  //ShellCtrls,
  ComCtrls, PairSplitter, types;

type

  { TfrmTabletteMainWindow }

  TfrmTabletteMainWindow = class(TForm)
    acQuitter: TAction;
    acOuvrirDepuisListe: TAction;
    acNouveau: TAction;
    acParametres: TAction;
    acCalculer: TAction;
    acPanN: TAction;
    acPanNE: TAction;
    acPanE: TAction;
    acPanSE: TAction;
    acPanS: TAction;
    acPanSW: TAction;
    acPanW: TAction;
    acPanNW: TAction;
    acSaveAs: TAction;
    acQSave: TAction;
    acCalculetteConvertisseur: TAction;
    acCentrerSurStation: TAction;
    acPlanAddSerie: TAction;
    acCloseDocument: TAction;
    acParametrerVue2D: TAction;
    Action1: TAction;
    acAjouterVisee: TAction;
    acSupprimerViseeActuelle: TAction;
    acGestionBDD: TAction;
    acPanVue: TAction;
    acOuvrirDoc: TAction;
    acEditSerieDepuisPlan: TAction;
    acNettoyerViseesAntennes: TAction;
    acRechercher: TAction;
    acListerAntennesStation: TAction;
    acDistanceBetween2Pts: TAction;
    acGHCaveDraw: TAction;
    acExportSVG: TAction;
    acExportGIS: TAction;
    acStatistiques: TAction;
    acCentreImpression: TAction;
    acApropos: TAction;
    acVue3DGDI: TAction;
    acUtilsDistoX: TAction;
    Action3: TAction;
    acValiderViseeActuelle: TAction;
    acZoomWnd: TAction;
    acZoomMoins: TAction;
    acZoomPlus: TAction;
    acZoomAll: TAction;
    actlstVue2D: TActionList;
    acVerrouiller: TAction;
    ActionList1: TActionList;
    BitBtn1: TBitBtn;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    BitBtn13: TBitBtn;
    BitBtn14: TBitBtn;
    BitBtn15: TBitBtn;
    BitBtn16: TBitBtn;
    BitBtn17: TBitBtn;
    BitBtn18: TBitBtn;
    BitBtn19: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn20: TBitBtn;
    BitBtn21: TBitBtn;
    BitBtn22: TBitBtn;
    BitBtn23: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    btnBasculeDossierXTB: TButton;
    btnChooseCode: TButton;
    btnChooseExpe: TButton;
    btnChooseSecteur: TButton;
    btnDefinirSerieCourante: TButton;
    btnApplyMetaFiltre: TButton;
    Button1: TButton;
    Button2: TButton;
    CdrListeViseesAntenne1: TCdrListeViseesAntenne;
    CdrVue2DTablette81_1: TCdrVue2DTablette81;
    chkDoHighLightCurrentSerie: TCheckBox;
    cmbRepresentation: TComboBox;
    cmbTypeGalerie: TComboBox;
    Edit1: TEdit;
    editCurrPt: TCurrencyEdit;
    editFiltres: TEdit;
    editStAz: TCurrencyEdit;
    editStCode: TCurrencyEdit;
    editStCommentaires: TEdit;
    editStExpe: TCurrencyEdit;
    editStHN: TCurrencyEdit;
    editStHZ: TCurrencyEdit;
    editStIDTerrain: TEdit;
    editStLD: TCurrencyEdit;
    editStLG: TCurrencyEdit;
    editStLongueur: TCurrencyEdit;
    editStPente: TCurrencyEdit;
    editStSecteur: TCurrencyEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    lbNomSerie: TStaticText;
    lbNumeroSerie: TStaticText;
    lbQMessages: TStaticText;
    lsbListeFichiersTopo: TFileListBox;
    ImageList1: TImageList;
    imglstVue2D: TImageList;
    lsbJournal: TListBox;
    lsbMessagesErreur: TListBox;
    PageControl1: TPageControl;
    PairSplitter1: TPairSplitter;
    PairSplitter2: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    PairSplitterSide3: TPairSplitterSide;
    PairSplitterSide4: TPairSplitterSide;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    pnlVueEnPlan: TPanel;
    pnlUneVisee: TPanel;
    pnlCurrentSerie: TPanel;
    Panel7: TPanel;
    pnlListeViseesEnAntenne: TPanel;
    pnlListeFichiersTopo: TPanel;
    pnlActionsEditionPlan: TPanel;
    pnlMenuPrincipal: TPanel;
    sclStations: TScrollBar;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton25: TSpeedButton;
    SpeedButton26: TSpeedButton;
    SpeedButton27: TSpeedButton;
    SpeedButton28: TSpeedButton;
    SpeedButton29: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton30: TSpeedButton;
    SpeedButton31: TSpeedButton;
    SpeedButton32: TSpeedButton;
    SpeedButton33: TSpeedButton;
    SpeedButton36: TSpeedButton;
    SpeedButton37: TSpeedButton;
    SpeedButton38: TSpeedButton;
    SpeedButton39: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton40: TSpeedButton;
    SpeedButton41: TSpeedButton;
    SpeedButton42: TSpeedButton;
    SpeedButton43: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    lbInitialDir: TStaticText;
    btnDistoXStatus: TStaticText;
    tabshtUtilitaires: TTabSheet;
    tabShtGeneral: TTabSheet;
    tabShtJournal: TTabSheet;
    tabShtVueEnPlan: TTabSheet;
    procedure acAjouterViseeExecute(Sender: TObject);
    procedure acAproposExecute(Sender: TObject);
    procedure acCalculerExecute(Sender: TObject);
    procedure acCalculetteConvertisseurExecute(Sender: TObject);
    procedure acCentreImpressionExecute(Sender: TObject);
    procedure acCentrerSurStationExecute(Sender: TObject);
    procedure acCloseDocumentExecute(Sender: TObject);
    procedure acDistanceBetween2PtsExecute(Sender: TObject);
    procedure acEditSerieDepuisPlanExecute(Sender: TObject);
    procedure acExportGISExecute(Sender: TObject);
    procedure acExportSVGExecute(Sender: TObject);
    procedure acGestionBDDExecute(Sender: TObject);
    procedure acGHCaveDrawExecute(Sender: TObject);
    procedure acListerAntennesStationExecute(Sender: TObject);
    procedure acNettoyerViseesAntennesExecute(Sender: TObject);
    procedure acNouveauExecute(Sender: TObject);
    procedure acOuvrirDepuisListeExecute(Sender: TObject);
    procedure acOuvrirDocExecute(Sender: TObject);
    procedure acPanEExecute(Sender: TObject);
    procedure acPanNEExecute(Sender: TObject);
    procedure acPanNExecute(Sender: TObject);
    procedure acPanNWExecute(Sender: TObject);
    procedure acPanSEExecute(Sender: TObject);
    procedure acPanSExecute(Sender: TObject);
    procedure acPanSWExecute(Sender: TObject);
    procedure acPanVueExecute(Sender: TObject);
    procedure acPanWExecute(Sender: TObject);
    procedure acParametrerVue2DExecute(Sender: TObject);
    procedure acParametresExecute(Sender: TObject);
    procedure acPlanAddSerieExecute(Sender: TObject);
    procedure acQSaveExecute(Sender: TObject);
    procedure acQuitterExecute(Sender: TObject);
    procedure acRechercherExecute(Sender: TObject);
    procedure acSaveAsExecute(Sender: TObject);
    procedure acStatistiquesExecute(Sender: TObject);
    procedure acSupprimerViseeActuelleExecute(Sender: TObject);
    procedure acUtilsDistoXExecute(Sender: TObject);
    procedure acVue3DGDIExecute(Sender: TObject);
    procedure acZoomAllExecute(Sender: TObject);
    procedure acZoomMoinsExecute(Sender: TObject);
    procedure acZoomPlusExecute(Sender: TObject);
    procedure acValiderViseeActuelleExecute(Sender: TObject);
    procedure acZoomWndExecute(Sender: TObject);
    procedure btnApplyMetaFiltreClick(Sender: TObject);
    procedure btnBasculeDossierXTBClick(Sender: TObject);
    procedure btnChooseCodeClick(Sender: TObject);
    procedure btnChooseExpeClick(Sender: TObject);
    procedure btnChooseSecteurClick(Sender: TObject);
    procedure btnDefinirSerieCouranteClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure chkDoHighLightCurrentSerieChange(Sender: TObject);
    procedure cmbRepresentationChange(Sender: TObject);
    procedure editCurrPtChange(Sender: TObject);
    procedure editFiltresKeyPress(Sender: TObject; var Key: char);
    procedure editStAzChange(Sender: TObject);
    procedure editStAzClick(Sender: TObject);
    procedure editStHNClick(Sender: TObject);
    procedure editStHZClick(Sender: TObject);
    procedure editStLDChange(Sender: TObject);
    procedure editStLDClick(Sender: TObject);
    procedure editStLGClick(Sender: TObject);
    procedure editStLongueurChange(Sender: TObject);
    procedure editStLongueurClick(Sender: TObject);
    procedure editStPenteClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure InitialiserContexteTopo;
    procedure FinaliserContexteTopo;
    procedure CloseAllDocuments;
    procedure PageControl1Change(Sender: TObject);
    procedure PairSplitterSide3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlUneViseeClick(Sender: TObject);
    procedure pnlVueEnPlanClick(Sender: TObject);
    procedure sclStationsChange(Sender: TObject);
    procedure SpeedButton27Click(Sender: TObject);
    procedure tabShtGeneralContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure tabshtUtilitairesContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure tabShtVueEnPlanContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure ListerFichiersTopo(const qInitialDir: string);
  private
    { private declarations }
    FDocTopoOpened    : boolean;
    FCanDisplayPlan   : boolean;
    FDocumentTopo     : TToporobotStructure2012;
    FTopoCompilee     : TBDDEntites;
    FCurrentIdxSerieInEdition: integer;
    FCurrentIdxPt     : integer;
    FNomFichierXTB    : string;

    function  CalculerLeReseauExt: boolean;
    procedure ChargerLaTopoExt(const FC: string; const DoCalc: boolean);
    function  GetStationFromForm: TUneVisee;
    function  InitialiserLaVue2D: boolean;
    procedure SetCurrentStationInForm;
    procedure SetCurrentSerieAndStation;
    procedure SetNomFichierXTB(const S: string);
    function  GetNomFichierXTB: string;
    procedure RafraichirListeViseesEnAntennes;
    procedure EnableDisableActions(const B: boolean);

  public
    { public declarations }
  end;

var
  frmTabletteMainWindow: TfrmTabletteMainWindow;

implementation

{$R *.lfm}

// utilisation du clavier spécifique tablettes
{$define USE_CLAVIER_NUM_FOR_TABLETTE}
{$undef USE_CLAVIER_NUM_FOR_TABLETTE}


uses
  dlgProjectManagerWideScreen
  {$DEFINE MSWINDOWS}
  , frmUtilsDistoX
  {$UNDEF}
  ;

{ TfrmTabletteMainWindow }
const
  STEP_DEPLACEMENT_VUE = 4;
  //MAIN_WND_WIDTH  = 1280;
  //MAIN_WND_HEIGHT =  800;
const
  BTN_BASCULE_SAVE_BACKUPS = 'Backups';
  BTN_BASCULE_SAVE_STD     = 'Etudes';
  DOSSIER_BACKUP           = 'Sauvegardes_rapides';




procedure TfrmTabletteMainWindow.FormShow(Sender: TObject);
  procedure SetAcHint(const A: TAction; const H: string);
  begin
    A.Caption    := GetResourceString(H);
    A.Hint       := A.Caption;
  end;
begin
  EnableDisableActions(false);
  //self.Width  := MAIN_WND_WIDTH;
  //self.Height := MAIN_WND_HEIGHT;
  self.WindowState := wsMaximized;
  //self.Width    := Screen.Width  - 20;
  //self.Height   := Screen.Height - 40;
  self.Position := poScreenCenter;

  self.Caption  := Format(rsMAINMENUCAPTION,['Untitled']);
  ListerFichiersTopo(GetGHTopoDirectory());
  btnBasculeDossierXTB.Caption := BTN_BASCULE_SAVE_BACKUPS;
  with cmbTypeGalerie do
  begin
    Clear;
    Items.Add(GetResourceString(rsTYPE_VISEE_DEFAULT));
    Items.Add(GetResourceString(rsTYPE_VISEE_ENTRANCE));
    Items.Add(GetResourceString(rsTYPE_VISEE_FOSSILE));
    Items.Add(GetResourceString(rsTYPE_VISEE_VADOSE));
    Items.Add(GetResourceString(rsTYPE_VISEE_ENNOYABLE));
    Items.Add(GetResourceString(rsTYPE_VISEE_SIPHON));
    Items.Add(GetResourceString(rsTYPE_VISEE_FIXPOINT));
    Items.Add(GetResourceString(rsTYPE_VISEE_SURFACE));
    Items.Add(GetResourceString(rsTYPE_VISEE_TUNNEL));
    Items.Add(GetResourceString(rsTYPE_VISEE_MINE));
    Items.Add(GetResourceString(rsTYPE_VISEE_ANTENNE));
    ItemIndex := 0;
  end;
  with cmbRepresentation do
  begin
    Clear;
    Items.Add(GetResourceString(rsVUE2D_REPRESENTATION_NETWORKS));
    Items.Add(GetResourceString(rsVUE2D_REPRESENTATION_SECTEURS));
    Items.Add(GetResourceString(rsVUE2D_REPRESENTATION_EXPES));
    Items.Add(GetResourceString(rsVUE2D_REPRESENTATION_GRAY));
    Items.Add(GetResourceString(rsVUE2D_REPRESENTATION_DEPTH));
    ItemIndex := 2; // par expés
  end;
  SetNomFichierXTB('');
  // panel des visées en antenne masqué
  pnlListeViseesEnAntenne.Visible := false;

end;

procedure TfrmTabletteMainWindow.InitialiserContexteTopo;
begin
  AfficherMessage(Format('%s.InitialiserContexteTopo', [ClassName]));
  DefaultFormatSettings.DecimalSeparator := '.';
  FCurrentIdxPt  := -1;
  FDocTopoOpened := false;
  FCanDisplayPlan:= false;
  FDocumentTopo    := TToporobotStructure2012.Create;
  FTopoCompilee    := TBDDEntites.Create;
  AfficherMessage(GetResourceString(rsCHOOSELANGUAGE));
  EnableDisableActions(false);
end;

procedure TfrmTabletteMainWindow.FinaliserContexteTopo;
begin
  AfficherMessage(Format('%s.FinaliserContexteTopo', [ClassName]));
  try
    if FDocTopoOpened then
    begin
      FDocumentTopo.Finaliser;
      FTopoCompilee.Finalise;
      //FListeQRStations.fi;
    end
    else
      ShowMessage(GetResourceString(rsMSG_NOFILEOPENED));
    // libération des bases mémoire
    try
    finally
      FDocumentTopo.Free;
      FTopoCompilee.Free;
    end;
  finally
  end;
end;

procedure TfrmTabletteMainWindow.CloseAllDocuments;
begin
  if Not(FDocTopoOpened) then Exit;
  AfficherMessage('CloseAllDocuments');
  FDocTopoOpened:=False;
  FDocumentTopo.ReInitialiser(True);

  //CloseVues;
  EnableDisableActions(False);
  //FVuePM.Visible        := false;
  //FVueEnPlanExt.Visible := false;
  self.Caption:=Format(rsMAINMENUCAPTION,['Untitled']);
end;

procedure TfrmTabletteMainWindow.PageControl1Change(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.PairSplitterSide3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

end;

procedure TfrmTabletteMainWindow.pnlUneViseeClick(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.pnlVueEnPlanClick(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.sclStationsChange(Sender: TObject);
begin
  FCurrentIdxPt := sclStations.Position;
  SetCurrentStationInForm;
end;

procedure TfrmTabletteMainWindow.SpeedButton27Click(Sender: TObject);
begin

end;



procedure TfrmTabletteMainWindow.tabShtGeneralContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TfrmTabletteMainWindow.tabshtUtilitairesContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TfrmTabletteMainWindow.tabShtVueEnPlanContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TfrmTabletteMainWindow.ListerFichiersTopo(const qInitialDir: string);
begin
  lbInitialDir.Caption           := qInitialDir;
  lsbListeFichiersTopo.Directory := qInitialDir;
  lsbListeFichiersTopo.Mask      := '*.xtb;*.tab';
  lsbListeFichiersTopo.ItemIndex := 0;
  lsbListeFichiersTopo.UpdateFileList;
end;




// charger et calculer la topo
// Chargement de la topo
procedure TfrmTabletteMainWindow.ChargerLaTopoExt(const FC: string; const DoCalc: boolean);
begin
  FDocTopoOpened := False;
  AfficherMessage(Format('%s.ChargerLaTopoExt: %s', [ClassName, FC]));
  with FDocumentTopo do
  begin
    //ReInitialiser;
    SetDatabaseName(FC);
    // vérifier si c'est un fichier Text
    if (Pos('.text', LowerCase(FC))>0) then
    begin
      if (LoadFichierText(FC) < 0) then
      begin
        AfficherMessageErreur('Le fichier comporte des erreurs - Voir le rapport');
        // Echec = on détruit l'objet
        FDocumentTopo.Finaliser;
        Exit;
      end;
    end
    else if (Pos('.gtx', FC) > 0) then // fichier GHTopo XML ?
    begin
      if (LoadFromXML(FC) < 0) then
      begin
        AfficherMessageErreur('Le fichier comporte des erreurs. Il doit être audité dans un éditeur XML');
        // Echec = on détruit l'objet
        FDocumentTopo.Finaliser;
        Exit;
      end;
    end
    else
    begin // sinon, c'est un fichier supposé Tab ou XTB
      if (LoadFichierTab(FC)<0) then
      begin
        AfficherMessageErreur('Le fichier comporte des erreurs - Voir le rapport');
        DisplayTextEditor(GetGHTopoDirectory() + ChangeFileExt(ExtractFileName(GetDatabaseName), '.err'),
                          True);
        // Echec = on détruit l'objet
        FDocumentTopo.Finaliser;
        Exit;
      end;
    end;
    //ShowMessage(DatabaseName);
    self.Caption:=Format(rsMAINMENUCAPTION, [ExtractFileName(FC)]);
    FDocTopoOpened := True;
    Application.ProcessMessages;
    // calculer le réseau dans tous les cas
    if (DoCalc) then CalculerLeReseauExt;
    // afficher le gestionnaire de la BDD
    Application.ProcessMessages;
    //AfficherMessage('Préparation du frontal de la base de données');

    //(*** A REACTIVER APRES PORTAGE ***
    // afficher la vue en plan
    //Showmessage(FNomFichierTOP);
    //FCanDisplayPlan := FVueEnPlanExt.InitialiseBDDEntites(FTopoCompilee, FDocumentToporobot, FListeQRStations);

    FCanDisplayPlan := InitialiserLaVue2D;
    //FCanDisplayPlan := false;
    if (FCanDisplayPlan) then
    begin
      (*FVueEnPlanExt.Width  := Trunc(0.80 * Screen.Width);
      FVueEnPlanExt.Height := Trunc(0.80 * Screen.Height);
      FVueEnPlanExt.Left   := Screen.Width - 10 - FVueEnPlanExt.Width;
      FVueEnPlanExt.Top    := self.Height + 20;
      //*)
      //VueEnPlanExt.FormStyle := fsStayOnTop;
      //FVueEnPlanExt.Show;
    end;
    //************************)
    //ActiverMenus(True);
   end; // with FDocumentToporobot
   //dlgProcessing.SetProgressWindow(10, Screen.Height - 120, 700, 70,fsNormal);
   //rendre visibles toutes les options des menus
   EnableDisableActions(True);

   // passer au mode Vue en plan
   PageControl1.ActivePageIndex := 1;
   Application.ProcessMessages;
end;
procedure TfrmTabletteMainWindow.SetCurrentStationInForm;
var
  MyStation: TUneVisee;
  MySerie: TObjSerie;
begin
  //editCurrSer.AsInteger := EWE.Entite_Serie;
  if (FCurrentIdxSerieInEdition > 0) then
  begin
    MySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);

    editCurrPt.AsInteger  := FCurrentIdxPt;

    MyStation := MySerie.GetVisee(FCurrentIdxPt);
    editStIDTerrain.Text    := _AnsiToLCLStr(MyStation.IDTerrainStation);
    editStSecteur.AsInteger := MyStation.IDSecteur;
    editStCode.AsInteger    := MyStation.Code;
    editStExpe.AsInteger    := MyStation.Expe;

    editStLongueur.Value := MyStation.Longueur;
    editStAz.Value       := MyStation.Azimut;
    editStPente.Value    := MyStation.Pente;
    editStLG.Value       := MyStation.LG;
    editStLD.Value       := MyStation.LD;
    editStHZ.Value       := MyStation.HZ;
    editStHN.Value       := MyStation.HN;
    editStCommentaires.Text := MyStation.Commentaires;
    cmbTypeGalerie.ItemIndex:= Ord(MyStation.TypeVisee);
    // éventuellement rafraichir la liste des antennes
    RafraichirListeViseesEnAntennes;
  end;
end;
function TfrmTabletteMainWindow.GetStationFromForm: TUneVisee;
begin
  Result.NoVisee := FCurrentIdxPt;
  Result.IDTerrainStation := FormatterIDTerrainStation(editStIDTerrain.Text);
  Result.IDSecteur     := editStSecteur.AsInteger;
  Result.Code          := editStCode.AsInteger;
  Result.Expe          := editStExpe.AsInteger;
  Result.Longueur      := editStLongueur.Value;
  Result.Azimut        := editStAz.Value;
  Result.Pente         := editStPente.Value;
  Result.LG            := editStLG.Value;
  Result.LD            := editStLD.Value;
  Result.HZ            := editStHZ.Value;
  Result.HN            := editStHN.Value;
  Result.Commentaires  := _LCLStrToAnsi(Trim(editStCommentaires.Text));
  Result.TypeVisee     := TTypeDeVisee(cmbTypeGalerie.ItemIndex);
end;
procedure TfrmTabletteMainWindow.SetCurrentSerieAndStation;
var
  MySerie : TObjSerie;
  EWE: TEntiteEtendue;
  WU: Integer;
begin
  EWE := CdrVue2DTablette81_1.GetCurrentEntite;
  if (EWE.Entite_Serie > 0) then
  begin
    WU := FDocumentTopo.GetIdxSerieByNumero(EWE.Entite_Serie);
    if (WU > 0) then
    begin
      FCurrentIdxSerieInEdition := WU;
      FCurrentIdxPt          := EWE.Entite_Station;
      MySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);
      lbNumeroSerie.Caption  := Format('%d', [MySerie.GetIndexSerie]);
      lbNomSerie.Caption     := _AnsiToLCLStr(MySerie.GetNomSerie);
      // cadre station
      SetCurrentStationInForm;
      CdrVue2DTablette81_1.SetCurrentNumeroSerieByCurrentEntite;
      // barre stations
      sclStations.Min := 0;
      sclStations.Max := MySerie.GetNbVisees - 1;
      sclStations.Position := FCurrentIdxPt;

      CdrVue2DTablette81_1.RedessinEcran(false);

    end;
  end;
end;

procedure TfrmTabletteMainWindow.SetNomFichierXTB(const S: string);
begin
  FNomFichierXTB := S;
end;

function TfrmTabletteMainWindow.GetNomFichierXTB: string;
begin
  Result := FNomFichierXTB;
end;

procedure TfrmTabletteMainWindow.RafraichirListeViseesEnAntennes;
var
  mySerie: TObjSerie;
begin
  if (not FDocTopoOpened) then Exit;
  if (pnlListeViseesEnAntenne.Visible) then
  begin
    mySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);
    CdrListeViseesAntenne1.RefreshListe(FDocumentTopo,
                                        mySerie.GetIndexSerie,
                                        FCurrentIdxPt);

  end;
end;

procedure TfrmTabletteMainWindow.EnableDisableActions(const B: boolean);
begin
  // actifs en permanence
  acQuitter.Enabled              := True;
  acApropos.Enabled              := True;
  acNouveau.Enabled              := True;
  acCloseDocument.Enabled        := True;
  acCalculetteConvertisseur.Enabled := True;
  // fichier
  acQSave.Enabled                := B;
  acSaveAs.Enabled               := B;
  acGestionBDD.Enabled           := B;
  acVue3DGDI.Enabled             := B;
  // topo
  acCalculer.Enabled             := B;
  // édition
  acAjouterVisee.Enabled         := B;
  acNettoyerViseesAntennes.Enabled := B;
  // panneau serie courante
  pnlCurrentSerie.Enabled        := B;
  // panneau UneVisée
  pnlUneVisee.Enabled            := B;
  // panneau Plan
  pnlVueEnPlan.Enabled           := B;
  // export
  acGHCaveDraw.Enabled           := B;
  acExportGIS.Enabled            := B;
  acExportSVG.Enabled            := B;
  // impression
  acCentreImpression.Enabled     := B;
  // stats
  acStatistiques.Enabled         := B;
end;

function TfrmTabletteMainWindow.InitialiserLaVue2D: boolean;
begin
  AfficherMessage(Format('%s.InitialiserLaVue2D', [ClassName]));
  try
    CdrVue2DTablette81_1.Initialiser(FDocumentTopo, FTopoCompilee, nil);
    Result := True;
  finally
  end;
end;

// calcul de la topo
function TfrmTabletteMainWindow.CalculerLeReseauExt: boolean;
var
  CodeCalcul: TCodeDeCalcul;
begin
  Result := False;
  AfficherMessage('-- Calcul du reseau (nouvelle version)');
  FDocumentTopo.RecenserLesIDsTerrain;
  CodeCalcul := TCodeDeCalcul.Create;
  try
    CodeCalcul.Initialiser(FDocumentTopo, '');
    Result    := CodeCalcul.CalculComplet(FTopoCompilee, False);
    //EWE       := ExtractFilePath(ParamStr(0)) + TEMP_COORDS_FILE;
    //CodeCalcul.GenererFichierSyntheseAvecCoordonnees(FTopoCompilee, EWE);
    CodeCalcul.Finaliser;
    AfficherMessage('Calcul OK');
  finally
    CodeCalcul.Free;
  end;
end;

procedure TfrmTabletteMainWindow.FormCreate(Sender: TObject);
begin
  InitialiserContexteTopo;
end;

procedure TfrmTabletteMainWindow.acQuitterExecute(Sender: TObject);
begin
  self.Close;
end;

procedure TfrmTabletteMainWindow.acRechercherExecute(Sender: TObject);
var
  QCle: String;
  EWE: TEntiteEtendue;
  QIdxSerie, QIdxPt: integer;
  QIdxIDTerrainFound: Integer;
begin
  if (Not FDocTopoOpened) then Exit;

  QIdxSerie := -1;
  QIdxPt    := -1;
  QIdxIDTerrainFound := -1;
  if (SelectIDTerrain(FDocumentTopo, QIdxIDTerrainFound)) then

  //if (GHTopoInputQuery(GetResourceString(rsDLG_FIND_PT_BY_ID_TITLE),
  //                     GetResourceString(rsDLG_FIND_PT_BY_ID_PROMPT),
  //                     QCle)) then
  begin
    QCle := FDocumentTopo.GetIDTerrain(QIdxIDTerrainFound);
    ShowMessage(QCle);
    if (FDocumentTopo.FindPtTopoByCle(QCle, QIdxSerie, QIdxPt)) then
    //if (FTopoCompilee.FindStationByCle(Trim(QCle), EWE)) then
    begin
      //ShowMessage(Format('Station: %s - %d, %d', [QCle, QIdxSerie, QIdxPt]));
      if (FTopoCompilee.GetEntiteFromSerSt(QIdxSerie, QIdxPt, EWE)) then
      begin
        CdrVue2DTablette81_1.SetCurrentEntite(EWE);
        // définir comme courant
        SetCurrentSerieAndStation;
        // zoom sur l'objet trouvé
        CdrVue2DTablette81_1.CentrerVueSurPointXY(EWE.Une_Station_2_X, EWE.Une_Station_2_Y);
      end
      else ShowMessage(GetResourceString(rsMATCHNOTFOUND));

    end
    else ShowMessage(GetResourceString(rsMATCHNOTFOUND));
  end;
end;

procedure TfrmTabletteMainWindow.acSaveAsExecute(Sender: TObject);
var
  EWE: String;
begin
  if (not FDocTopoOpened) then Exit;
  // Pas de factorisation avec DoDialogSaveFile(): FilterIndex est utilisé;
  with TSaveDialog.Create(Application) do
  begin
    try
      FileName   := FNomFichierXTB;
      Filter     := GetResourceString(rsGHTOPO_FILE_FILTER_WO_TEXT);
      DefaultExt := '.xtb';
      Options := Options + [ofOverwritePrompt];
      if (Execute) then
      begin
        case FilterIndex of
          1: FDocumentTopo.SaveToFile(FileName,mtabEXTENDEDTAB, tfWINDOWS);
          2: FDocumentTopo.SaveToXML(FileName); // futur format standard de GHTopo
          3: FDocumentTopo.SaveToFile(FileName,mtabTOPOROBOT, tfMAC);
          4: FDocumentTopo.ExporterVersToporobotTEXT(FileName, 160.00);
        end; // case FilterIndex
        // actualisation du nouveau nom de fichier
        FNomFichierXTB := FileName;
        self.Caption:=Format(rsMAINMENUCAPTION,[FNomFichierXTB]);
        ListerFichiersTopo(GetGHTopoDirectory());
      end;
    finally
      Free;
    end;
  end;
end;

procedure TfrmTabletteMainWindow.acStatistiquesExecute(Sender: TObject);
begin
  if (FDocTopoOpened) then
  begin
    DisplayStatistiquesExt(FDocumentTopo, FTopoCompilee);
    // retrier le tableau par profondeurs
    FTopoCompilee.SortByDepth;
  end;
end;

procedure TfrmTabletteMainWindow.acSupprimerViseeActuelleExecute(Sender: TObject);
var
  MySerie: TObjSerie;
  qNb: Integer;
  WU: Integer;
begin
  if (FCurrentIdxPt > 0) then // on ne peut pas supprimer la visée 0
  begin
    MySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);
    if ((MySerie.GetIndexSerie > 0) and (MySerie.GetNbVisees > 0)) then
    begin
      if (GHTopoQuestionOuiNon(Format('Supprimer la station %d.%d', [FCurrentIdxSerieInEdition, FCurrentIdxPt]))) then
      begin
        // d'abord, on jarte les antennes dépendantes
        WU := FDocumentTopo.RemoveViseesRayonnantesAssocieesAStation(FCurrentIdxSerieInEdition, FCurrentIdxPt);

        MySerie.DeleteVisee(FCurrentIdxPt);
        qNb := MySerie.GetNbVisees - 1;                             // 2. Point courant: Inchangé
        if (FCurrentIdxPt > qNb) then FCurrentIdxPt := qNb;         // sinon,
        SetCurrentStationInForm;                                    // MAJ formulaire visée
        // mise à jour du point d'arrivée
        MySerie.SetNoPointArr(qNb);                                 // 3. actualiser point d'arrivée série
        FDocumentTopo.PutSerie(FCurrentIdxSerieInEdition, MySerie); // 4. et on met à jour la base
        sclStations.Max := qNb;                                     // 5. actu de la scrollbar
        sclStations.Position := FCurrentIdxPt;                      // et on recalcule puis réaffiche le plan
        acCalculerExecute(self);
      end;
    end;
  end;
end;

procedure TfrmTabletteMainWindow.acUtilsDistoXExecute(Sender: TObject);
begin
  with TdlgUtilsDistoX.Create(Application) do
  begin
    try
      if (InitialiserDialogDistoX()) then
      begin
        ShowModal;
        FinaliserCalib;
      end;
    finally
      Release;
    end;
  end;
end;

procedure TfrmTabletteMainWindow.acVue3DGDIExecute(Sender: TObject);
begin
  if (FDocTopoOpened) then
  begin
    DisplayVue3DGDIExt(FTopoCompilee, '');
    // retrier le tableau par profondeurs
    FTopoCompilee.SortByDepth;
  end;
end;

procedure TfrmTabletteMainWindow.acZoomAllExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.ResetVue;
end;

procedure TfrmTabletteMainWindow.acZoomMoinsExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.ZoomerPM(1.10, True);
end;

procedure TfrmTabletteMainWindow.acZoomPlusExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.ZoomerPM(1.10, False);
end;

procedure TfrmTabletteMainWindow.acValiderViseeActuelleExecute(Sender: TObject);
var

  MyVisee: TUneVisee;
  MySerie: TObjSerie;
begin
  if (FCurrentIdxPt > 0) then
  begin
    MySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);
    if (MySerie.GetIndexSerie > 0) then
    begin
      MyVisee := GetStationFromForm;
      MySerie.PutVisee(FCurrentIdxPt, MyVisee);
      FDocumentTopo.PutSerie(FCurrentIdxSerieInEdition, MySerie);
      acCalculerExecute(self);
    end;
  end;
end;

procedure TfrmTabletteMainWindow.acZoomWndExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.SetModeTravail(mtZOOM_PREMIER_COIN);
end;

procedure TfrmTabletteMainWindow.btnApplyMetaFiltreClick(Sender: TObject);
begin
  CdrVue2DTablette81_1.SetFiltre(Trim(editFiltres.Text));
end;

procedure TfrmTabletteMainWindow.btnBasculeDossierXTBClick(Sender: TObject);
var
  EWE: String;
begin
  if (btnBasculeDossierXTB.Caption = BTN_BASCULE_SAVE_BACKUPS) then
  begin
    // lister dossier de sauvegardes
    EWE := GetGHTopoDirectory() + DOSSIER_BACKUP + PathDelim;
    btnBasculeDossierXTB.Caption := BTN_BASCULE_SAVE_STD;
  end
  else
  begin
    // lister dossier standard
    EWE := GetGHTopoDirectory();
    btnBasculeDossierXTB.Caption := BTN_BASCULE_SAVE_BACKUPS;
  end;
  ListerFichiersTopo(EWE);
end;

procedure TfrmTabletteMainWindow.btnChooseCodeClick(Sender: TObject);
begin
  editStCode.AsInteger := SelectionDansListe(FDocumentTopo,
                                             mslCODE,
                                             editStCode.AsInteger,
                                             False);
end;

procedure TfrmTabletteMainWindow.btnChooseExpeClick(Sender: TObject);
begin
  editStExpe.AsInteger := SelectionDansListe(FDocumentTopo,
                                             mslEXPE,
                                             editStExpe.AsInteger,
                                             False);
end;

procedure TfrmTabletteMainWindow.btnChooseSecteurClick(Sender: TObject);
begin
  editStSecteur.AsInteger := SelectionDansListe(FDocumentTopo,
                                             mslSECTEURS,
                                             editStSecteur.AsInteger,
                                             False);
end;

procedure TfrmTabletteMainWindow.btnDefinirSerieCouranteClick(Sender: TObject);
begin
  SetCurrentSerieAndStation;
end;

procedure TfrmTabletteMainWindow.Button1Click(Sender: TObject);
var
  EWE: Boolean;
begin
  EWE := GHTopoQuestionOuiNon('LLANFAIRPWLLGWYNGYLLGOGERYCHWYRNDROBWLLLLANDISILIOGOGOGOCH');
  EWE := GHTopoQuestionOuiNon('ghtopo ' + #13#10 +
                              'fatche');
  EWE := GHTopoQuestionOuiNon('ghtopo fjkghqsgf hlskgjfhlgksjhlqs kjllkjhgql sz klj' + #13#10 +
                              'fatche' + #13#10 +
                              'ljkgfhqslgjkqljhlqsfk' + #13#10+
                              'kùwjkdq lkfhgmqsjhf ljfgkmqsh jilmjfjkgh');


end;

procedure TfrmTabletteMainWindow.Button2Click(Sender: TObject);
begin
  Label8.Caption := ExtractIDTerrainFromComment(Edit1.Text);
end;

procedure TfrmTabletteMainWindow.chkDoHighLightCurrentSerieChange(
  Sender: TObject);
begin
  CdrVue2DTablette81_1.SetHighLightCurrentSerie(chkDoHighLightCurrentSerie.Checked);
end;

procedure TfrmTabletteMainWindow.cmbRepresentationChange(Sender: TObject);
var
  WU: TModeRepresentationGaleries;
begin
  WU := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  CdrVue2DTablette81_1.SetModeRepresentation(WU);
end;

procedure TfrmTabletteMainWindow.editCurrPtChange(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.editFiltresKeyPress(Sender: TObject;
  var Key: char);
begin
  if (key = #13) then CdrVue2DTablette81_1.SetFiltre(Trim(editFiltres.Text));
end;



procedure TfrmTabletteMainWindow.editStAzChange(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.editStAzClick(Sender: TObject);
begin
  {$IFDEF USE_CLAVIER_NUM_FOR_TABLETTE} editStAz.Value := SaisirValeurNumerique('Azimut', editStAz.Value); {$ENDIF}
end;

procedure TfrmTabletteMainWindow.editStHNClick(Sender: TObject);
begin
  {$IFDEF USE_CLAVIER_NUM_FOR_TABLETTE} editStHN.Value := SaisirValeurNumerique('Bas', editStHN.Value);  {$ENDIF}
end;

procedure TfrmTabletteMainWindow.editStHZClick(Sender: TObject);
begin
  {$IFDEF USE_CLAVIER_NUM_FOR_TABLETTE} editStHZ.Value := SaisirValeurNumerique('Haut', editStHZ.Value);  {$ENDIF}
end;

procedure TfrmTabletteMainWindow.editStLDChange(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.editStLDClick(Sender: TObject);
begin
  {$IFDEF USE_CLAVIER_NUM_FOR_TABLETTE} editStLD.Value := SaisirValeurNumerique('Droite', editStLD.Value); {$ENDIF}
end;

procedure TfrmTabletteMainWindow.editStLGClick(Sender: TObject);
begin
  {$IFDEF USE_CLAVIER_NUM_FOR_TABLETTE} editStLG.Value := SaisirValeurNumerique('Gauche', editStLG.Value);  {$ENDIF}
end;

procedure TfrmTabletteMainWindow.editStLongueurChange(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.editStLongueurClick(Sender: TObject);
begin
  {$IFDEF USE_CLAVIER_NUM_FOR_TABLETTE} editStLongueur.Value := SaisirValeurNumerique('Longueur', editStLongueur.Value);  {$ENDIF}
end;

procedure TfrmTabletteMainWindow.editStPenteClick(Sender: TObject);
begin
  {$IFDEF USE_CLAVIER_NUM_FOR_TABLETTE} editStPente.Value := SaisirValeurNumerique('Pente', editStPente.Value);  {$ENDIF}
end;

procedure TfrmTabletteMainWindow.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
begin
  CanClose := False;
  if (GHTopoQuestionOuiNon(EnlevePerluete(GetResourceString(rsGHTOPO_QUIT)))) then
  begin
    FinaliserContexteTopo;
    CanClose := True;
  end;
end;



procedure TfrmTabletteMainWindow.acOuvrirDepuisListeExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (FDocTopoOpened) then
  begin
    ShowMessage(GetResourceString(rsWARN_FILEALREADYOPEN));
    Exit;
  end;
  QFileName := lsbListeFichiersTopo.Directory +
               lsbListeFichiersTopo.Items[lsbListeFichiersTopo.ItemIndex];
  //ShowMessage(QFileName);
  ChargerLaTopoExt(QFileName, True);
  SetNomFichierXTB(QFileName);
end;

procedure TfrmTabletteMainWindow.acOuvrirDocExecute(Sender: TObject);
begin
  if (FDocTopoOpened) then
  begin
    case MessageDlg(GetResourceString(rsWARN_FILEALREADYOPEN), mtConfirmation, [mbYes, mbNO],0) of
      mrYes: ;
      mrNO : Exit;
    end;
  end;
  with TOpenDialog.Create(Application) do
  begin
    try
      InitialDir := GetGHTopoDirectory();
      Filter     := GetResourceString(rsGHTOPO_FILE_FILTER_W_TEXT); //'Fichiers GHTopo |*.xtb; *.tab; *.Text|Tous |*.*';
      DefaultExt := '.xtb';
      FileName   := 'Topographie1.xtb';
      if (Execute) then
      begin
        CloseAllDocuments;
        ChargerLaTopoExt(Filename, true); //QuestionOuiNon('Recalculer le réseau'));
        AfficherMessage('PRET');
      end;
    finally
      Free;
    end;
  end;
end;

procedure TfrmTabletteMainWindow.acPanEExecute(Sender: TObject);
begin
   CdrVue2DTablette81_1.DeplacerVue(-STEP_DEPLACEMENT_VUE, 0);
end;

procedure TfrmTabletteMainWindow.acPanNEExecute(Sender: TObject);
begin
   CdrVue2DTablette81_1.DeplacerVue(-STEP_DEPLACEMENT_VUE, STEP_DEPLACEMENT_VUE);
end;

procedure TfrmTabletteMainWindow.acPanNExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.DeplacerVue(0, STEP_DEPLACEMENT_VUE);
end;

procedure TfrmTabletteMainWindow.acPanNWExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.DeplacerVue(STEP_DEPLACEMENT_VUE, STEP_DEPLACEMENT_VUE);
end;

procedure TfrmTabletteMainWindow.acPanSEExecute(Sender: TObject);
begin
   CdrVue2DTablette81_1.DeplacerVue(-STEP_DEPLACEMENT_VUE, -STEP_DEPLACEMENT_VUE);
end;

procedure TfrmTabletteMainWindow.acPanSExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.DeplacerVue(0, -STEP_DEPLACEMENT_VUE);
end;

procedure TfrmTabletteMainWindow.acPanSWExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.DeplacerVue(STEP_DEPLACEMENT_VUE, -STEP_DEPLACEMENT_VUE);
end;

procedure TfrmTabletteMainWindow.acPanVueExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.SetModeTravail(mtPAN_PREMIER_POINT);
end;

procedure TfrmTabletteMainWindow.acPanWExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.DeplacerVue(STEP_DEPLACEMENT_VUE, 0);
end;

procedure TfrmTabletteMainWindow.acParametrerVue2DExecute(Sender: TObject);
var
  WU  : TVue2DParams;
begin
  if (not FDocTopoOpened) then Exit;
  WU  := CdrVue2DTablette81_1.GetVue2DParams;
  WU  := ParametrerOngletVue2D(WU);
  CdrVue2DTablette81_1.SetVue2DParams(WU);
end;

procedure TfrmTabletteMainWindow.acParametresExecute(Sender: TObject);
begin

end;

procedure TfrmTabletteMainWindow.acPlanAddSerieExecute(Sender: TObject);
var
  E: TEntiteEtendue;
  WU: String;
begin
  if (not FDocTopoOpened) then Exit;
  E := CdrVue2DTablette81_1.GetCurrentEntite;
  if (E.Entite_Serie > 0) then
  begin
    WU := Format('Ajouter une série à la station %d.%d [%s]', [E.Entite_Serie, E.Entite_Station, E.oIDLitteral]);
    if (GHTopoQuestionOuiNon(WU)) then
    begin
      //if (DoTabletteDialogEditSerie(mamAJOUT, FDocumentTopo, FTopoCompilee, E)) then
      //begin
      //  acCalculerExecute(self);
      //end;
    end;
  end;
end;
// sauvegarde rapide avec date et heure courante
procedure TfrmTabletteMainWindow.acQSaveExecute(Sender: TObject);
var
  DateSauvegrd: TDateTime;
  YYYY, MM, DD, HH, MN, SS, MS: word;
  QFileName: String;
begin

  DateSauvegrd := Now();
  DecodeDate(DateSauvegrd, YYYY, MM, DD);
  DecodeTime(DateSauvegrd, HH, MN, SS, MS);
  ForceDirectories(DOSSIER_BACKUP);

  QFileName := GetGHTopoDirectory +
               DOSSIER_BACKUP + PathDelim +
               Format('0_0QSave_%.4d-%.2d-%.2d_%.2dh%.2dm%.2ds.xtb',
                      [YYYY, MM, DD, HH, MN, SS]);
  FDocumentTopo.SaveToFile(QFileName, mtabEXTENDEDTAB, tfWINDOWS);
  ListerFichiersTopo(GetGHTopoDirectory() + DOSSIER_BACKUP + PathDelim);
end;

procedure TfrmTabletteMainWindow.acNouveauExecute(Sender: TObject);
var
  QFileName: String;
begin
   if (FDocTopoOpened) then begin
    ShowMessage('Un document est déjà ouvert');
    Exit;
  end;
  CloseAllDocuments;
  // L'assistant provoque une erreur inexplicable (Invalid handle file) lors du chargement
  // --> contournement via un fichier ébauche
  QFileName   := GetGHTopoDirectory() + '00_CaveStub.xtb';
  if (not FileExistsUTF8(QFileName)) then RegenererEbaucheXTB(QFileName);
  ChargerLaTopoExt(QFilename, True);
end;

procedure TfrmTabletteMainWindow.acCalculerExecute(Sender: TObject);
var
  EWE: TEntiteEtendue;
  MySerie: TObjSerie;
begin
  if (not FDocTopoOpened) then Exit;
  CalculerLeReseauExt;
  Application.ProcessMessages;
  FCanDisplayPlan := InitialiserLaVue2D;
  MySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);
  if (FTopoCompilee.GetEntiteFromSerSt(MySerie.GetIndexSerie, FCurrentIdxPt, EWE)) then
  begin
    if (EWE.Entite_Serie > 0) then
    begin
      CdrVue2DTablette81_1.CentrerSurStation(EWE, 50.00);
    end;
  end;
end;

procedure TfrmTabletteMainWindow.acAjouterViseeExecute(Sender: TObject);
var
  MyVisee: TUneVisee;
  MySerie: TObjSerie;
begin
  if (not FDocTopoOpened) then Exit;
  MySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);
  if (MySerie.GetIndexSerie > 0) then
  begin
    MyVisee := GetStationFromForm;
    MySerie.AddVisee(MyVisee);                                // 1. Ajout de la visée
    FCurrentIdxPt := MySerie.GetNbVisees - 1;                 // 2. Point courant = dernière visée
    MySerie.SetNoPointArr(FCurrentIdxPt);                     // 3. actualiser point d'arrivée série
    FDocumentTopo.PutSerie(FCurrentIdxSerieInEdition, MySerie); // 4. et on met à jour la base
    sclStations.Max := FCurrentIdxPt;                           // 5. actu de la scrollbar
    sclStations.Position := FCurrentIdxPt;                      // et on recalcule puis réaffiche le plan
    acCalculerExecute(self);
  end;
end;

procedure TfrmTabletteMainWindow.acAproposExecute(Sender: TObject);
begin
  DisplayHelpSystem('');
end;

procedure TfrmTabletteMainWindow.acCalculetteConvertisseurExecute(Sender: TObject);
var
  Coords        : TPoint2Df;
  ResultatCalcul: double;
  Declimag      : double;
begin
  Coords := MakeTPoint2Df(0.00, 0.00);
  ResultatCalcul := 0.00;
  Declimag       := 0.00;
  CallCalculette('', Coords, ResultatCalcul, Declimag);
end;

procedure TfrmTabletteMainWindow.acCentreImpressionExecute(Sender: TObject);
begin
  if (FDocTopoOpened) then DisplayCentreImpressionExt(FDocumentTopo, FTopoCompilee);
end;

procedure TfrmTabletteMainWindow.acCentrerSurStationExecute(Sender: TObject);
var
  EWE: TEntiteEtendue;
  MySerie: TObjSerie;
begin
  if (not FDocTopoOpened) then Exit;
  MySerie := FDocumentTopo.GetSerie(FCurrentIdxSerieInEdition);
  if (FTopoCompilee.GetEntiteFromSerSt(MySerie.GetIndexSerie,
                                       FCurrentIdxPt,
                                       EWE)) then
  begin
    CdrVue2DTablette81_1.SetCurrentEntite(EWE);
    CdrVue2DTablette81_1.CentrerVueSurPointXY(EWE.Une_Station_2_X, EWE.Une_Station_2_Y);
  end;
end;

procedure TfrmTabletteMainWindow.acCloseDocumentExecute(Sender: TObject);
begin
  if (FDocTopoOpened) then
  begin
    case MessageDlg(GetResourceString(rsSAVECHANGES), mtConfirmation,
                  [mbYes, mbNo, mbCancel],0) of
    mrYes: begin
             // sauvegarder ici
             // tout fermer
             CloseAllDocuments;

           end;
    mrNo : begin
             CloseAllDocuments;
           end;
    mrCancel: exit;
    end;
  end;
end;

procedure TfrmTabletteMainWindow.acDistanceBetween2PtsExecute(Sender: TObject);
begin
  CdrVue2DTablette81_1.SetModeTravail(mtDISTANCE_PREMIER_POINT);
end;

procedure TfrmTabletteMainWindow.acEditSerieDepuisPlanExecute(Sender: TObject);
var
  E: TEntiteEtendue;
begin
  if (not FDocTopoOpened) then Exit;
  E := CdrVue2DTablette81_1.GetCurrentEntite;
  SetCurrentSerieAndStation;
  if (E.Entite_Serie > 0) then
  begin
    //if (DoTabletteDialogEditSerie(mamMODIFICATION, FDocumentTopo, FTopoCompilee, E)) then
    //begin
    //  acCalculerExecute(self);
    //end;
  end;
end;

procedure TfrmTabletteMainWindow.acExportGISExecute(Sender: TObject);
begin
  if (FDocTopoOpened) then
  begin
    DisplayExportSIG(FTopoCompilee);
    // retrier le tableau par profondeurs
    FTopoCompilee.SortByDepth;
  end;
end;

procedure TfrmTabletteMainWindow.acExportSVGExecute(Sender: TObject);
var
  EWE: TVue2DParams;
  QAT: TStringDirectoryFilename;
  WU: TModeRepresentationGaleries;
  QIdxFilter: integer;
begin
  QAT := 'SVG_2D_001.svg';
  if (DoDialogSaveFile('Scalable Vector Graphics (*.svg)|*.svg', '.svg', QAT, QIdxFilter)) then
  begin
    EWE := CdrVue2DTablette81_1.GetVue2DParams;
    WU  := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
    FTopoCompilee.ExportVue2DSVG(QAT, False, WU, EWE.ongElementsDrawn);
    ShowMessage('Done');
  end;
end;

procedure TfrmTabletteMainWindow.acGestionBDDExecute(Sender: TObject);
var
  WBDD: TdlgProjectManagerWdScr;
begin
  if (not FDocTopoOpened) then Exit;
  WBDD := TdlgProjectManagerWdScr.Create(Application);
  try
    WBDD.Init(FDocumentTopo);
    WBDD.ShowModal;
  finally
    WBDD.Release;
  end;
end;

procedure TfrmTabletteMainWindow.acGHCaveDrawExecute(Sender: TObject);
  procedure MiouMiou(const QBDD: TBDDEntites; const FicGCP: string);
  begin
    QBDD.SetProcDisplayProgression(nil);
    QBDD.ExportForGHCaveDraw(FicGCP, '');
  end;

var
  WU: TStringDirectoryFilename;
  QIdxFilter: integer;
begin
  if (not FDocTopoOpened) then Exit;
  WU := ChangeFileExt(FNomFichierXTB, '.gcp');
  if (DoDialogSaveFile('GHCaveDraw Polygonal (*.gcp)', '.gcp', WU, QIdxFilter)) then MiouMiou(FTopoCompilee, WU);
end;

procedure TfrmTabletteMainWindow.acListerAntennesStationExecute(Sender: TObject);
begin
  pnlListeViseesEnAntenne.Visible := not pnlListeViseesEnAntenne.Visible;
  RafraichirListeViseesEnAntennes;
end;

procedure TfrmTabletteMainWindow.acNettoyerViseesAntennesExecute(Sender: TObject);
var
  WU: Integer;
begin
  if (not FDocTopoOpened) then Exit;
  WU  := FDocumentTopo.NettoyerAntennes(50, -1, -1);
  acCalculerExecute(self);
  ShowMessage(Format('%d antennes supprimées', [WU]));
end;

end.

