unit ViewerMainFrm;

{$INCLUDE CompilationParameters.inc}

// Visualisateur de topos GHCaveDraw
// Permet tous les exports (SVG, OSM, ...) et impressions

interface

uses
  SysUtils
  , Classes
  {$IFDEF LANGUAGE_FRENCH}
    , UnitMessages_fr
  {$ENDIF}
  , GHCD_Types
  , GeneralFunctions
  , UnitDocDessin
  , CallDialogs
  , cdrdessincanvasBGRA, CdrListeGroupes
  , FileUtil, curredit
  , Forms, Controls, Graphics,
  Dialogs, StdCtrls, ActnList, Menus, ComCtrls, PairSplitter, CheckLst,
  ExtCtrls, Buttons, ButtonPanel;


type

  { TMainWndViewer }

  TMainWndViewer = class(TForm)
    acApplyMetaFiltre: TAction;
    acBasculerVisibiliteGroupes: TAction;
    acCancelCourbe: TAction;
    acClosePolylign: TAction;
    acCourbeAffecterCurrGrp: TAction;
    acCourbeAffecterGroupe: TAction;
    acCourbeAffecterStyle: TAction;
    acDefCurrentGroupe: TAction;
    acDeleteCourbe: TAction;
    acDeleteLigne: TAction;
    acDeletePolygone: TAction;
    acDeletePolyline: TAction;
    acDeleteScrap: TAction;
    acDeleteSymbole: TAction;
    acDeleteTexte: TAction;
    acDispCodeGHCaveDrawObjet: TAction;
    acDisplayDebugPanel: TAction;
    acDisplayDebugTexts: TAction;
    acDisplayIDStations: TAction;
    acDrawLine: TAction;
    acEditSection: TAction;
    acGroupeDecale: TAction;
    acGroupeVerrouille: TAction;
    acGroupeVisible: TAction;
    acLigneAffecterGroupe: TAction;
    acLigneAffecterStyle: TAction;
    acLineAffecterCurrGrp: TAction;
    acLockCurrentStation: TAction;
    acMasquerTousGroupes: TAction;
    acNewGroupe: TAction;
    acNone: TAction;
    acPanVue: TAction;
    acPolygonAffecterCurrGrp: TAction;
    acPolygoneAffecterGroupe: TAction;
    acPolygoneAffecterStyle: TAction;
    acPolylignAffecterCurrGrp: TAction;
    acPolyLineAffecterGroupe: TAction;
    acPolylineAffecterStyle: TAction;
    acQuit: TAction;
    acOpen: TAction;
    acRedess: TAction;
    acRendreVisiblesGroupesSelected: TAction;
    acReverseCourbe: TAction;
    acReversePolyline: TAction;
    acSave: TAction;
    acExportSVG: TAction;
    acRefresh: TAction;
    acScrapAffecterCurrGrp: TAction;
    acScrapAffecterGroupe: TAction;
    acSectionTransversale: TAction;
    acSelectionZoom: TAction;
    acSetCurrGroupeByObject: TAction;
    acStylesObjets: TAction;
    acPan2Points: TAction;
    acChargerCanevasTopo: TAction;
    acRechercher: TAction;
    acApropos: TAction;
    acGenererDessinOOoDraw: TAction;
    acExportXHTML: TAction;
    acSupprimerObjetsGroupe: TAction;
    acSymboleAffecterCurrGrp: TAction;
    acSymboleAffecterGroupe: TAction;
    acSymboleAffecterStyle: TAction;
    acTexteAffecterCurrGrp: TAction;
    acTexteAffecterGroupe: TAction;
    acTexteAffecterStyle: TAction;
    acPanLeft: TAction;
    acGenererCarteLeaflet: TAction;
    acExportSVGScrapsOnly: TAction;
    ActionList1: TActionList;
    acPanRight: TAction;
    acPanUp: TAction;
    acPanDown: TAction;
    acExportImgVueCourante: TAction;
    acQSave: TAction;
    acGenererPDF: TAction;
    acMergeScraps: TAction;
    acMergeLastScraps: TAction;
    acMergeCourbes: TAction;
    acMergeLastCourbes: TAction;
    acMergePolylines: TAction;
    acMergeLastPolylines: TAction;
    acMergePolygones: TAction;
    acMergeLastPolygones: TAction;
    acExportKML: TAction;
    acExportOSM: TAction;
    acHierarchieObjets: TAction;
    acExportImgAllReseau: TAction;
    Action4: TAction;
    acCreerUnAtlasHTML: TAction;
    acDialogimage: TAction;
    acNouveauDessin: TAction;
    acMnuExportImages: TAction;
    acValidateCourbe: TAction;
    acVue: TAction;
    acZoomPlus: TAction;
    acZoomMoins: TAction;
    acZoom2Points: TAction;
    acZoomTout: TAction;
    acZoomWindow: TAction;
    acZoomAll: TAction;
    actlstMenus: TActionList;
    acZoomWindow1: TAction;
    btnAddGroupe: TButton;
    btnAffecterAuGroupeCourant: TSpeedButton;
    btnAffecterGroupeByCombo: TSpeedButton;
    btnAffecterNatureByCombo: TSpeedButton;
    btnAffecterNatureByCombo1: TSpeedButton;
    btnAssignFiltreGrpCourant: TButton;
    btnBackGrndColor: TColorButton;
    btnDeleteObject: TSpeedButton;
    btnDispCodeGHCaveDraw: TSpeedButton;
    btnDispListeImages: TButton;
    btnDrwObjMode29: TSpeedButton;
    btnDrwObjMode30: TSpeedButton;
    btnDrwObjMode31: TSpeedButton;
    btnDrwObjMode32: TSpeedButton;
    btnDrwObjMode33: TSpeedButton;
    btnDrwObjMode34: TSpeedButton;
    btnDrwObjMode35: TSpeedButton;
    btnDrwObjMode36: TSpeedButton;
    btnDrwObjMode37: TSpeedButton;
    btnDrwObjMode38: TSpeedButton;
    btnDrwObjMode39: TSpeedButton;
    btnDrwObjMode40: TSpeedButton;
    btnDrwObjMode41: TSpeedButton;
    btnDrwObjMode42: TSpeedButton;
    btnDrwObjMode43: TSpeedButton;
    btnDrwObjMode44: TSpeedButton;
    btnDrwObjMode45: TSpeedButton;
    btnDrwObjMode46: TSpeedButton;
    btnDrwObjMode47: TSpeedButton;
    btnDrwObjMode48: TSpeedButton;
    btnDrwObjMode49: TSpeedButton;
    btnDrwObjMode50: TSpeedButton;
    btnDrwObjMode51: TSpeedButton;
    btnDrwObjMode52: TSpeedButton;
    btnDrwObjMode53: TSpeedButton;
    btnDrwObjMode55: TSpeedButton;
    btnDrwObjMode56: TSpeedButton;
    btnDrwObjMode57: TSpeedButton;
    btnDrwObjMode58: TSpeedButton;
    btnDrwObjMode59: TSpeedButton;
    btnDrwObjMode60: TSpeedButton;
    btnDrwObjMode61: TSpeedButton;
    btnEditObject: TSpeedButton;
    btnEditObjectSpecial: TSpeedButton;
    btnFermerCourbePolyligne: TSpeedButton;
    btnInvertChkGroupes: TButton;
    btnMetaFiltre: TButton;
    btnPanelDebug: TButton;
    btnRecupereFiltreDepuisGroupe: TButton;
    btnScrapColorDefault: TColorButton;
    btnUnvisibleAllGroupes: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CadreDessin1: TCadreDessinBGRA;
    CadreListeGroupes1: TCadreListeGroupes;
    CdrDrawActionList: TActionList;
    CdrDrwImageList: TImageList;
    chkBaseStationLocked: TCheckBox;
    chkDecalageActif: TCheckBox;
    chkDispBBXGroupes: TCheckBox;
    chkDispCenterLine: TCheckBox;
    chkDispEchelleNord: TCheckBox;
    chkDispIDStations: TCheckBox;
    chkDispImages: TCheckBox;
    chkDispPenteSuperieureA: TCheckBox;
    chkDispPhotos: TCheckBox;
    chkDispQuadrilles: TCheckBox;
    chkDispScraps: TCheckBox;
    chkDispTexteDebug: TCheckBox;
    chkDispTextes: TCheckBox;
    chkLocked: TCheckBox;
    chkMetafiltreActif: TCheckBox;
    chkScrapsEnNB: TCheckBox;
    chkVisible: TCheckBox;
    cmbGroupeObjet: TComboBox;
    cmbNatureObjet: TComboBox;
    cmbTypeQuadrillage: TComboBox;
    editFiltre: TEdit;
    editFindingGroupe: TEdit;
    editGrdSpacing: TCurrencyEdit;
    editLimiteDispPente: TCurrencyEdit;
    editTailleEchelle: TCurrencyEdit;
    GroupBox1: TGroupBox;
    hcColonnes: THeaderControl;
    ImageList1: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    lbColorGroupe: TStaticText;
    lbCurrentGroupe: TStaticText;
    lbCurrentObject: TLabel;
    lbIDBaseStation: TStaticText;
    lbIDGroupe: TStaticText;
    lbMessages: TStaticText;
    lbMessagesProgression: TLabel;
    lbModeTravail: TStaticText;
    lbMousePos: TStaticText;
    lbNbGroupes: TLabel;
    lbNbObjets: TStaticText;
    lbNomGroupe: TStaticText;
    lbZOrder: TStaticText;
    ListBox1: TListBox;

    imglstActionsMenus: TImageList;
    lsbGroupes: TListBox;
    lsbValeurs: TListBox;
    MainMenu1: TMainMenu;
    MainProgressBar: TProgressBar;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem26: TMenuItem;
    MenuItem29: TMenuItem;
    MenuItem30: TMenuItem;
    MenuItem44: TMenuItem;
    MenuItem45: TMenuItem;
    MenuItem47: TMenuItem;
    MenuItem48: TMenuItem;
    MenuItem49: TMenuItem;
    MenuItem51: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem68: TMenuItem;
    MenuItem69: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem70: TMenuItem;
    MenuItem71: TMenuItem;
    MenuItem72: TMenuItem;
    MenuItem73: TMenuItem;
    MenuItem74: TMenuItem;
    MenuItem75: TMenuItem;
    MenuItem76: TMenuItem;
    MenuItem77: TMenuItem;
    MenuItem78: TMenuItem;
    MenuItem79: TMenuItem;
    MenuItem80: TMenuItem;
    MenuItem81: TMenuItem;
    MenuItem82: TMenuItem;
    MenuItem83: TMenuItem;
    MenuItem84: TMenuItem;
    MenuItem85: TMenuItem;
    MenuItem86: TMenuItem;
    MenuItem87: TMenuItem;
    MenuItem88: TMenuItem;
    MenuItem89: TMenuItem;
    MenuItem90: TMenuItem;
    MenuItem91: TMenuItem;
    MenuItem92: TMenuItem;
    MenuItem93: TMenuItem;
    mnuAddColorAtFiltre: TMenuItem;
    mnuAddSerieAtFiltre: TMenuItem;
    mnuAddStationAtFiltre: TMenuItem;
    mnuCourbe: TPopupMenu;
    mnuExportAsImage: TMenuItem;
    MenuItem37: TMenuItem;
    mnuAide: TMenuItem;
    MenuItem23: TMenuItem;
    mnuEDITION: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    mnuAFFICHAGE: TMenuItem;
    mnuFichier: TMenuItem;
    mnuFiltres: TMenuItem;
    mnuFILTRES_COULEURS: TMenuItem;
    mnuFILTRES_SERIE: TMenuItem;
    mnuFILTRES_STATION: TMenuItem;
    PairSplitter1: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    pnlDebug: TPanel;
    pnlEditDessin: TPanel;
    pnlExport: TPanel;
    pnlFichier: TPanel;
    Panel4: TPanel;
    pnlBtnControleVue: TPanel;
    pnlFiltres: TPanel;
    pnlProgression: TPanel;
    pnlTypeObjet: TPanel;
    PopUpGeneral: TPopupMenu;
    popupListeGroupes: TPopupMenu;
    TabSheet1: TTabSheet;
    Vue: TPaintBox;
    procedure acAproposExecute(Sender: TObject);
    procedure acExportImgAllReseauExecute(Sender: TObject);
    procedure acExportKMLExecute(Sender: TObject);
    procedure acExportOSMExecute(Sender: TObject);
    procedure acExportSVGExecute(Sender: TObject);
    procedure acExportSVGScrapsOnlyExecute(Sender: TObject);
    procedure acExportXHTMLExecute(Sender: TObject);
    procedure acGenererCarteLeafletExecute(Sender: TObject);
    procedure acGenererDessinOOoDrawExecute(Sender: TObject);
    procedure acHierarchieObjetsExecute(Sender: TObject);
    procedure acOpenExecute(Sender: TObject);
    procedure acPan2PointsExecute(Sender: TObject);
    procedure acPanDownExecute(Sender: TObject);
    procedure acPanLeftExecute(Sender: TObject);
    procedure acPanUpExecute(Sender: TObject);
    procedure acPanVueExecute(Sender: TObject);
    procedure acQuitExecute(Sender: TObject);
    procedure acReattribBasePointsExecute(Sender: TObject);
    procedure acRechercherExecute(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure acExportImgVueCouranteExecute(Sender: TObject);
    procedure acSetModeTravailNoneExecute(Sender: TObject);
    procedure acStylesObjetsExecute(Sender: TObject);
    procedure acPanRightExecute(Sender: TObject);
    procedure acZoom2PointsExecute(Sender: TObject);
    procedure acZoomAllExecute(Sender: TObject);
    procedure acZoomMoinsExecute(Sender: TObject);
    procedure acZoomPlusExecute(Sender: TObject);
    procedure acZoomWindowExecute(Sender: TObject);
    procedure btnBackGrndColorColorChanged(Sender: TObject);

    procedure btnScrapColorDefaultColorChanged(Sender: TObject);
    procedure Button1Click(Sender: TObject);

    procedure Button2Click(Sender: TObject);
    procedure chkDispBBXGroupesChange(Sender: TObject);
    procedure chkDispCenterLineChange(Sender: TObject);
    procedure chkDispEchelleNordChange(Sender: TObject);
    procedure chkDispIDStationsChange(Sender: TObject);
    procedure chkDispImagesChange(Sender: TObject);
    procedure chkDispPenteSuperieureAChange(Sender: TObject);
    procedure chkDispPhotosChange(Sender: TObject);
    procedure chkDispQuadrillesChange(Sender: TObject);
    procedure chkDispTexteDebugChange(Sender: TObject);
    procedure chkDispTextesChange(Sender: TObject);
    procedure chkDispScrapsChange(Sender: TObject);
    procedure chkScrapsEnNBChange(Sender: TObject);
    procedure chkVisibleChange(Sender: TObject);
    procedure cmbTypeQuadrillageChange(Sender: TObject);
    procedure editNumsCourbesPolyChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure InitCaptions;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    // nom du fichier actuel
    FNomFichierActuel: string;
    procedure acCreerUnAtlasHTMLExecute(Sender: TObject);
    procedure Redessiner();

    function ChargerLeDessin(const MonDessin: TStringDirectoryFileName): Boolean;
    // remplacement d'une polygonale
    function  RemplacerCanevasTopo(const FichierGCD: string): boolean;
    procedure DispInfoBasePoint(const B: TBaseStation);
    procedure DispInfosScrap(const S: TScrap; const IdxScrap: Int64);
    procedure DispInfosCourbe(const C: TCourbe; const IdxCourbe: Int64);
    procedure DispInfosPolyligne(const P: TPolyLigne; const IdxPolygone: Int64);



    procedure DispInfosPolygone(const P: TPolygone; const IdxPolygone: Int64);
    procedure DispInfosPonctObject(const O: TSymbole; const IdxObj: Int64);
    procedure DispInfosSimpleLine(const L: TSimpleLigne; const IdxLine: Int64);
    procedure DispInfosTextObject(const T: TTextObject; const IdxTxtObj: Int64);
    procedure InitialiserGHC();
    procedure SetModeSelectionEntites(const MS: TModeSelectionEntites);
    procedure ShowMenus(const R90: boolean);

    { private declarations }
    procedure S666(const WU: TSpeedButton; const QAction: TAction); inline;
    procedure RemplirChxElementsDrawn();

  public
    { public declarations }
  end;

var
  MainWndViewer: TMainWndViewer;

implementation

{$R *.lfm}
uses
  frmJournal
  , UnitAtlasHTML
  , frmParametrageAtlas
  {$IFDEF MSWINDOWS}
  //, frmBGRAPrintingCenter // Module d'impression désactivé
  //, frmExportPDF
  {$ENDIF}
  {$IFDEF LINUX}
  {$ENDIF}

  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
  {$ENDIF}
  ;

CONST DEFAULT_MODE_OPERATIONS_BOOLEENNES = 1;

{ TMainWndViewer }
procedure TMainWndViewer.S666(const WU: TSpeedButton; const QAction: TAction); inline;
begin

 WU.Glyph  := nil;
 WU.Action := QAction;
 AfficherMessageErreur(QAction.Caption);
end;

// initialisation
procedure TMainWndViewer.ShowMenus(const R90: boolean);
begin
  (*
  acGridSettings.Visible         := R90;
  acSave.Visible                 := R90;
  acStylesObjets.Visible         := R90;
  // dessin
  acModeSelect.Visible           := R90;
  acLine.Visible                 := R90;
  acCurve.Visible                := R90;
  acPolygone.Visible             := R90;
  acPolygoneCentre.Visible       := R90;
  acSymbole.Visible              := R90;
  acTexte.Visible                := R90;
  acRecalcBBGrps.Visible         := R90;
  // impression
  acPrint.Visible                := R90;
  // vues et zoom
  acZoomWindow.Visible           := R90;
  acZoomTout.Visible             := R90;
  acPanVue.Visible               := R90;
  acRedess.Visible               := R90;
  acSelectZoom.Visible           := R90;
  // sélection
  //lbSelectionnables.Visible      := R90;
  //cmbModeSelectEntites.Visible   := R90;
  // édition
  acDeleteLast.Visible           := R90;
  // éditeur de section
  acEditerSection.Visible        := R90;
  //*)
end;






// chargement du dessin
function TMainWndViewer.ChargerLeDessin(const MonDessin: TStringDirectoryFileName): Boolean;
begin
  AfficherMessage('Dessin à charger: ' + MonDessin);
  Result := False;
  CadreDessin1.DoDraw := False;
  Result := CadreDessin1.ChargerInitialiserDessin(MonDessin);
  if Not(Result) then
    Exit
  else begin
    ShowMenus(Result);
    //RefreshOnglets;
    CadreDessin1.SetCurrentGroupeByIdx(0);

    CadreDessin1.SetCurrentNatureCourbe(nocPAROI);
    CadreDessin1.SetCurrentNatureLigne(nolPENTE);
    CadreDessin1.SetCurrentNaturePolygone(nopARGILE);
    CadreDessin1.SetCurrentNatureSymbole(nosPHOTO);
    CadreDessin1.SetCurrentNatureTexte(notDEBUG);

    CadreDessin1.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);

    // peupler les listes
    CadreListeGroupes1.Initialiser(false); // lecture seule
    CadreListeGroupes1.Rafraichir(CadreDessin1);
    // nom actuel du dessin
    FNomFichierActuel := MonDessin;
    self.Caption := Trim(Format(FMT_APPLICATION_TITLE,[ExtractFileName(FNomFichierActuel), 'Viewer']));
    Result := True;
  end;
end;



procedure TMainWndViewer.chkDispBBXGroupesChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawBoundingBoxGroupes(chkDispBBXGroupes.Checked);
end;

procedure TMainWndViewer.chkDispCenterLineChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawCenterLine(chkDispCenterLine.Checked);
end;

procedure TMainWndViewer.chkDispEchelleNordChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawEchelle(chkDispEchelleNord.Checked, editTailleEchelle.Value);
end;






procedure TMainWndViewer.InitialiserGHC;
var
  i  : integer;
  PMG: TParamsGrilleDessin;
begin
  AfficherMessage(Classname, 'Init');
  FNomFichierActuel := '';
  self.Caption := Trim(Format(FMT_APPLICATION_TITLE,['<Aucun dessin>', 'Viewer']));
  // armement des menus
  ShowMenus(False);
  AfficherMessage(' --> Initialisation du contexte de dessin');
  CadreDessin1.MyProcGetInfoBasePoint := DispInfoBasePoint;
  CadreDessin1.MyProcGetScrap         := DispInfosScrap;
  CadreDessin1.MyProcGetCourbe        := DispInfosCourbe;
  CadreDessin1.MyProcGetPolyligne     := DispInfosPolyligne;
  CadreDessin1.MyProcGetPolygon       := DispInfosPolygone;
  CadreDessin1.MyProcGetSimpleline    := DispInfosSimpleLine;
  CadreDessin1.MyProcGetTextObject    := DispInfosTextObject;
  CadreDessin1.MyProcGetPonctObject   := DispInfosPonctObject;

  //CadreDessin1.MyProcActualiserOnglet := ActuParamOnglet;
  //*)

  if (CadreDessin1.CdrDrwInitialize) then
  begin
    // paramètres de grille
    with PMG do begin
      GrdTypeQuadrillage := tqGRID;
      GrdBackGroundColor := clWhite;
      GrdMainGridColor   := RGBToColor(255, 128,  64);//clGray;
      GrdSecGridColor    := RGBToColor(242, 203, 159); // (//clSilver;
      GrdSpcMainGrid     := 100;
      GrdSpcSecGrid      := GrdSpcMainGrid / 10;
      GrdDispMainGrid    := True;
      GrdDispSecGrid     := True;
      GroupeBackColor    := RGBToColor(205, 254, 239);
    end;
    CadreDessin1.SetCtxtDessin(PMG);
    //SetModeSelectionEntites(mseNONE);
    CadreDessin1.SetCurrentGroupeByIdx(0);

    FCurrParamsVue := DefineOnglet(Format('Vue %d',[i+1]), '',
                                      PMG,
                                      CadreDessin1.GetDrwCoinBasGauche,
                                      CadreDessin1.GetDrwCoinHautDroit);
    // index de styles courants
    CadreDessin1.SetCurrentNatureLigne(nolPENTE);
    CadreDessin1.SetCurrentNatureCourbe(nocPAROI);
    CadreDessin1.SetCurrentNaturePolygone(nopARGILE);
    CadreDessin1.SetCurrentNatureSymbole(nosPHOTO);
    CadreDessin1.SetCurrentNatureTexte(notDEBUG);
    // cadre des groupes
    //CadreListeGroupes1.Initialise(CadreDessin1);
    // charger le dessin si spécifié dans ParamStr
    if (ParamCount=1) then begin
      if Not(ChargerLeDessin(Trim(ParamStr(1)))) then
        ShowMessage('Echec en chargement du dessin - Démarrage avec un document vierge');
    end;
  end else
  begin
    ShowMessage('Echec du démarrage de l''éditeur graphique');
    Application.Terminate;
  end;
end;

function TMainWndViewer.RemplacerCanevasTopo(const FichierGCD: string): boolean;
var
  SauveGrdTXT: String;
  FMyDocDessin: TDocumentDessin;

begin
  Result := False;
  // sauvegarde du canevas topo
  SauveGrdTXT := ExtractFilePath(FNomFichierActuel) +
                 'Polygonale_' + ExtractFileNameOnly(FNomFichierActuel) + '.txt';
  FMyDocDessin := CadreDessin1.MyDocumentDessin;
  FMyDocDessin.ExportBasePoints(SauveGrdTXT);
  if (FMyDocDessin.ImportBasePoints(FichierGCD)) then
  begin
    FMyDocDessin.CalcBoundingBoxAllGroupes;
    CadreDessin1.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
  end
  else
  begin
    ShowMessage(GetResourceString(rsERR_MSG_IMPORT_CENTERLINE));
  end;
end;

procedure TMainWndViewer.RemplirChxElementsDrawn();
var
  DC: TDocumentDessin;
  ED: TELementsDrawn;
begin
  DC := CadreDessin1.GetDocDessin;
  ED := CadreDessin1.GetElementsDessines();
  chkDispTexteDebug.Checked     := (tedDEBUG_TEXTS in ED);
  chkDispEchelleNord.Checked    := (tedECHELLE_NORD in ED);
  chkDispQuadrilles.Checked     := (tedQUADRILLES in ED);
  chkDispCenterLine.Checked     := (tedCENTERLINES in ED);
  chkDispIDStations.Checked     := (tedIDSTATIONS in ED);
  chkDispTextes.Checked         := (tedDEBUG_TEXTS in ED);
  chkDispPhotos.Checked         := (tedCADRES_PHOTO in ED);
  chkDispScraps.Checked         := (tedSCRAPS in ED);
  chkDispImages.Checked         := (tedIMAGES in ED);
  chkDispPenteSuperieureA.Checked  := (tedDISP_PENTES in ED);
end;

procedure TMainWndViewer.SetModeSelectionEntites(const MS: TModeSelectionEntites);
begin
;
end;

// fonction retournant le basepoint le plus proche
procedure TMainWndViewer.DispInfoBasePoint(const B: TBaseStation);
begin
  //lb;
  //FDlgStationCourante.SetInfosStation(B);
  //if not (FDlgStationCourante.Visible) then FDlgStationCourante.Show;
end;
procedure TMainWndViewer.DispInfosCourbe(const C: TCourbe; const IdxCourbe: Int64);
begin
  ; //if not FDlgToolEntites.Visible then FDlgToolEntites.Show;
  //FDlgToolEntites.DispInfosCourbe(C, IdxCourbe, CadreDessin1.GetCurrentGroupeIdx);
end;

procedure TMainWndViewer.DispInfosPolyligne(const P: TPolyLigne; const IdxPolygone: Int64);
begin

end;

procedure TMainWndViewer.DispInfosPolygone(const P: TPolygone; const IdxPolygone: Int64);
begin
  ; //if not FDlgToolEntites.Visible then FDlgToolEntites.Show;
  //FDlgToolEntites.DispInfosPolygone(P, IdxPolygone, CadreDessin1.GetCurrentGroupeIdx);
end;

procedure TMainWndViewer.DispInfosTextObject(const T: TTextObject; const IdxTxtObj: Int64);
begin
  ; //if not FDlgToolEntites.Visible then FDlgToolEntites.Show;
  //FDlgToolEntites.DispInfosTextObject(T, IdxTxtObj, CadreDessin1.GetCurrentGroupeIdx);
end;



procedure TMainWndViewer.DispInfosPonctObject(const O: TSymbole; const IdxObj: Int64);
begin
  ; //if not FDlgToolEntites.Visible then FDlgToolEntites.Show;
  //ShowMessagefmt('Objet ponctuel %d',[IdxObj]);
  //;FDlgToolEntites.DispInfosPonctObject(O, IdxObj, CadreDessin1.GetCurrentGroupeIdx);
end;

procedure TMainWndViewer.DispInfosScrap(const S: TScrap; const IdxScrap: Int64);
begin
  ;
end;


procedure TMainWndViewer.DispInfosSimpleLine(const L: TSimpleLigne; const IdxLine: Int64);
begin
  ; //if not FDlgToolEntites.Visible then FDlgToolEntites.Show;
  //FDlgToolEntites.DispInfosSimpleLine(L, IdxLine, CadreDessin1.GetCurrentGroupeIdx);
end;
//------------------------------------------------------------------------------
procedure TMainWndViewer.FormCreate(Sender: TObject);
begin
  //inherited;
  DefaultFormatSettings.DecimalSeparator := '.';
  {$IFDEF MSWINDOWS}
  dlgProcessing := TdlgProcessing.Create(Application);
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
  dlgProcessing := TdlgProcessing.Create(Application);
  {$ENDIF}
  {$IFDEF LINUX}
  ;
  {$ENDIF}
end;

procedure TMainWndViewer.InitCaptions;
  procedure S777(const WU: TAction; const CaptionHint: string);
  begin
    WU.Caption  := GetResourceString(CaptionHint);
    WU.Hint     := GetResourceString(CaptionHint);
  end;
begin
  mnuFichier.Caption    := rsMNU_FILE;
    S777(acNouveauDessin  , rsMNU_NEW_DRAWING);
    S777(acOpen           , rsMNU_OPEN);
    S777(acSave           , rsMNU_SAVE);
    S777(acQSave          , rsMNU_QUICK_SAVE);
    //S777(acPrint          , rsMNU_PRINT);
    S777(acExportSVG      , rsMNU_SVG);
    S777(acExportSVGScrapsOnly, rsMNU_SVG_SCRAPS_ONLY);
    S777(acGenererDessinOOoDraw, rsMNU_ODG);
    S777(acMnuExportImages, rsMNU_EXPORT_IMAGE);
      S777(acExportImgVueCourante , rsMNU_EXPORT_IMG_CURR_VUE);
      S777(acExportImgAllReseau   , rsMNU_EXPORT_IMG_ALL);
    S777(acGenererPDF            , rsMNU_PDF);
    S777(acExportImgVueCourante  , rsMNU_VUE_IMAGE);
    S777(acChargerCanevasTopo    , rsMNU_POLYGO_GHTOPO);
    S777(acExportKML             , rsMNU_EXPORT_SCRAPS_KML);
    S777(acExportOSM             , rsMNU_EXPORT_SCRAPS_OSM);
    S777(acGenererCarteLeaflet   , rsMNU_EXPORT_LEAFLET);
    s777(acCreerUnAtlasHTML      , rsMNU_GENERER_ATLAS);
    S777(acQuit                  , rsMNU_QUIT);

  //mnuDESSIN.Caption   := rsMNU_DESSIN;

  mnuEDITION.Caption  := rsMNU_EDITION;
    S777(acStylesObjets   , rsMNU_STYLES_OBJETS);
    s777(acRechercher     , rsMNU_RECHERCHER);
  mnuAFFICHAGE.Caption  := rsMNU_AFFICHAGE;
    s777(acRefresh        , rsMNU_REDESS);
    S777(acZoomAll        , rsMNU_ZOOMALL);
    S777(acZoomWindow     , rsMNU_ZOOMWND);
    S777(acPan2Points     , rsMNU_PANVUE);
    S777(acZoomPlus       , rsMNU_ZOOM_PLUS);
    S777(acZoomMoins      , rsMNU_ZOOM_MOINS);
    S777(acPanLeft        , rsMNU_PAN_LEFT);
    S777(acPanRight       , rsMNU_PAN_RIGHT);
    S777(acPanUp          , rsMNU_PAN_UP);
    S777(acPanDown        , rsMNU_PAN_DOWN);



  mnuAide.Caption       := rsMNU_AIDE;
  chkDispTexteDebug.Caption := rsCHK_DRAW_TEXTE_DEBUG;
  chkDispIDStations.Caption := rsCHK_DRAW_ID_STATIONS;

  // checkbox d'affichage
  chkDispBBXGroupes.Caption       := GetResourceString(rsCHK_DISP_BOUNDING_BOX);
  chkDispCenterLine.Caption       := GetResourceString(rsCHK_DISP_CENTERLINE);
  chkDispIDStations.Caption       := GetResourceString(rsCHK_DISP_ID_STATIONS);
  chkDispQuadrilles.Caption       := GetResourceString(rsCHK_DISP_QUADRILLES);
  chkDispEchelleNord.Caption      := GetResourceString(rsCHK_DISP_ECHELLE);
  chkDispTextes.Caption           := GetResourceString(rsCHK_DISP_TEXTES);
  chkDispPhotos.Caption           := GetResourceString(rsCHK_DISP_PHOTOS);
  chkDispScraps.Caption           := GetResourceString(rsCHK_DISP_SCRAPS);
  chkDispTexteDebug.Caption       := GetResourceString(rsCHK_DISP_TEXTE_DEBUG);
  chkDispPenteSuperieureA.Caption := GetResourceString(rsCHK_DISP_PENTES_SUP_A);
end;


procedure TMainWndViewer.acQuitExecute(Sender: TObject);
begin
  self.Close;
end;

// réattribuer les points de base de tous les objets du groupe courant
// vers les basepoints métafiltrés
// Utilisation type: On a créé des objets sans avoir filtré les centerlines
//                   et on veut les accrocher aux bons basepoints
procedure TMainWndViewer.acReattribBasePointsExecute(Sender: TObject);
var
  FD: TDocumentDessin;
  QIdx: TIDGroupeEntites;
  Grp: TGroupeEntites;
  QFiltres: String;
begin
  if (Not QuestionOuiNon(rsMISC_SAUVEGARDE_CONSEILLEE)) then Exit;
  FD := CadreDessin1.GetDocDessin;
  QIdx := CadreDessin1.GetCurrentGroupeIdx();
  if (QIdx < 0) then Exit;
  Grp := FD.GetGroupeByIDGroupe(QIdx);
  QFiltres := CadreDessin1.GetMetaFiltre();
  FD.ReattribBasepointsAllObjetsGroupe(Grp, QFiltres);
end;

// Recalcule les points de base de l'objet courant
// à partir de la certerline métafiltrée


procedure TMainWndViewer.acRechercherExecute(Sender: TObject);
var
  WU: String;
begin
  WU := '';
  if (InputQuery(rsMISC_DLG_FIND_STATION_TITRE, rsMISC_DLG_FIND_STATION_PROMPT, WU)) then
  begin
    CadreDessin1.RechercherStation(WU);
  end;
end;

procedure TMainWndViewer.acRefreshExecute(Sender: TObject);
begin
  CadreDessin1.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
end;

procedure TMainWndViewer.acSaveExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;

  QFileName := FNomFichierActuel;
  if (DoDialogSaveFilename('Fichiers GCD|*.gcd', '.gcd', QFileName)) then
  begin
    CadreDessin1.MyDocumentDessin.SaveToFile(QFileName, -1, True);
    AfficherMessage(GetResourceString(rsMISC_DONE_WITH_SUCCESS));
  end;
end;

procedure TMainWndViewer.acExportImgVueCouranteExecute(Sender: TObject);
var
  QFileName: string;
  QC1, QC2: TPoint2Df;
  EWE: TRect2Df;
  WU: String;
  QAT: double;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName := 'Vue001.png';
  QAT := 4000;
  if (InputNumValue('Génération d''une image', 'Taille de l''image', 500, 32000, QAT)) then
  begin
    if (DoDialogSaveFilename('Image PNG|*.png|Image JPG|*.jpg', '.png', QFileName)) then
    begin
      //CadreDessin1.SaveVueAsImage(QFileName);
      QC1 := CadreDessin1.GetDrwCoinBasGauche();
      QC2 := CadreDessin1.GetDrwCoinHautDroit();
      EWE := MakeTRect2Df(QC1.X, QC1.Y, QC2.X, QC2.Y);
      CadreDessin1.ExporterTopoEnImage(QFileName, EWE, Trunc(QAT));
      ShowMessage(GetResourceString(rsMISC_DONE_WITH_SUCCESS));
    end;
  end;
end;

procedure TMainWndViewer.acSetModeTravailNoneExecute(Sender: TObject);
begin
  CadreDessin1.SetModeTravail(mtNONE);
  //CadreDessin1.SetModeSelectionDesEntites(mseNONE);
end;

procedure TMainWndViewer.acStylesObjetsExecute(Sender: TObject);
begin
  if (CadreDessin1.DoDraw) then
  begin
    EditerStylesObjets(CadreDessin1.MyDocumentDessin, Redessiner);
    CadreDessin1.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
  end;
end;


procedure TMainWndViewer.acPanRightExecute(Sender: TObject);
begin
  CadreDessin1.SetWindowView(1.0, -0.05, 0.0);
end;

procedure TMainWndViewer.acZoom2PointsExecute(Sender: TObject);
begin
  CadreDessin1.SetModeTravail(mtZOOM_PREMIER_COIN);
end;

procedure TMainWndViewer.acZoomAllExecute(Sender: TObject);
begin
  //SetModeSelectionEntites(mseNONE);
  CadreDessin1.SetModeTravail(mtNONE);
  CadreDessin1.ResetViewLimits;
end;

procedure TMainWndViewer.acZoomMoinsExecute(Sender: TObject);
begin
  CadreDessin1.SetWindowView(0.95, 0.0, 0.0);
end;

procedure TMainWndViewer.acZoomPlusExecute(Sender: TObject);
begin
  CadreDessin1.SetWindowView(1.05, 0.0, 0.0);
end;

procedure TMainWndViewer.acZoomWindowExecute(Sender: TObject);
begin
  CadreDessin1.SetModeTravail(mtZOOM_PREMIER_COIN);
end;




procedure TMainWndViewer.btnBackGrndColorColorChanged(Sender: TObject);
begin
  CadreDessin1.SetBackGrndColor(btnBackGrndColor.ButtonColor);
  CadreDessin1.Vue.Invalidate;
end;


procedure TMainWndViewer.btnScrapColorDefaultColorChanged(Sender: TObject);
begin
  CadreDessin1.SetColorDefaultScrapsTransparents(btnScrapColorDefault.ButtonColor);
end;

procedure TMainWndViewer.Button1Click(Sender: TObject);
var
  QAT: Integer;
  FD: TDocumentDessin;
  QC1: TPoint3Df;
  QC2: TPoint3Df;
  EWE: TRect2Df;
  QFileName: string;
  WU: TELementsDrawn;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  Button1.Enabled := false;
  WU := CadreDessin1.GetFlagsDraw();
  CadreDessin1.SetFlagsDraw(WU - [tedDETAILS,
                                  tedIDSTATIONS,
                                  tedIMAGES,
                                  tedCADRES_PHOTO,
                                  tedECHELLE_NORD,
                                  tedQUADRILLES
                                  ]);
  try
    QFileName := ExtractFileNameWithoutExt(FNomFichierActuel);
    QFileName := QFileName + '_thumbnail.png';

    showmessage(QFileName);
    //exit;
    QAT := 400;
    FD := CadreDessin1.GetDocDessin();
    FD.SetMiniEtMaxi;
    QC1 := FD.GetCoordsMini();
    QC2 := FD.GetCoordsMaxi();
    EWE := MakeTRect2Df(QC1.X, QC1.Y, QC2.X, QC2.Y);
    CadreDessin1.ExporterTopoEnImage(QFileName, EWE, Trunc(QAT));
  except
  end;
  CadreDessin1.SetFlagsDraw(WU);
  Button1.Enabled := True;
end;

procedure TMainWndViewer.chkDispIDStationsChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawIDStations(chkDispIDStations.Checked);
end;

procedure TMainWndViewer.chkDispImagesChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawImages(chkDispImages.Checked);
end;

procedure TMainWndViewer.chkDispPenteSuperieureAChange(Sender: TObject);
begin
   CadreDessin1.SetFlagDrawPentes(chkDispPenteSuperieureA.Checked);
   if (chkDispPenteSuperieureA.Checked) then CadreDessin1.SetLimiteDispPente(editLimiteDispPente.Value);
end;

procedure TMainWndViewer.chkDispPhotosChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawCadresPhotos(chkDispPhotos.Checked);
end;

procedure TMainWndViewer.chkDispQuadrillesChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawQuadrilles(chkDispQuadrilles.Checked);
  //CadreDessin1.SetTypeQuadrillage(TTypeQuadrillage(cmbTypeQuadrillage.ItemIndex));
end;

procedure TMainWndViewer.chkDispTexteDebugChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawTexteDebug(chkDispTexteDebug.Checked);
end;

procedure TMainWndViewer.chkDispTextesChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawTextObjects(chkDispTextes.Checked);
end;

procedure TMainWndViewer.chkScrapsEnNBChange(Sender: TObject);
begin
  CadreDessin1.SetFlagScrapsTransparents(chkScrapsEnNB.Checked);
end;

procedure TMainWndViewer.chkVisibleChange(Sender: TObject);
begin

end;

procedure TMainWndViewer.cmbTypeQuadrillageChange(Sender: TObject);
begin
  CadreDessin1.SetTypeQuadrillage(TTypeQuadrillage(cmbTypeQuadrillage.ItemIndex));
end;



procedure TMainWndViewer.chkDispScrapsChange(Sender: TObject);
begin
  CadreDessin1.SetFlagDrawScraps(chkDispScraps.Checked);
end;

procedure TMainWndViewer.editNumsCourbesPolyChange(Sender: TObject);
begin

end;




procedure TMainWndViewer.acOpenExecute(Sender: TObject);
var
  QFileName: String;
begin
  QFileName :=  GetGHCaveDrawDirectory() + 'Dessin001.gcd';
  if (DoDialogOpenFilename('Fichiers GCD|*.gcd|Polygonales GCP|*.gcp|Tous|*.*', QFileName)) then
  begin
    if (ChargerLeDessin(QFileName)) then
    begin
      AfficherMessage(GetResourceString(rsMISC_DONE_WITH_SUCCESS));
    end
    else
    begin
      ShowMessage(GetResourceString(rsERR_MSG_LOAD_GCD_FAIL));
    end;
  end;
end;

procedure TMainWndViewer.acPan2PointsExecute(Sender: TObject);
begin
  CadreDessin1.SetModeTravail(mtPAN_PREMIER_POINT);
end;

procedure TMainWndViewer.acPanDownExecute(Sender: TObject);
begin
  CadreDessin1.SetWindowView(1.0, 0.00, 0.05);
end;

procedure TMainWndViewer.acPanLeftExecute(Sender: TObject);
begin
  CadreDessin1.SetWindowView(1.0, 0.05, 0.00);
end;

procedure TMainWndViewer.acPanUpExecute(Sender: TObject);
begin
  CadreDessin1.SetWindowView(1.0, 0.00, -0.05);
end;

procedure TMainWndViewer.acPanVueExecute(Sender: TObject);
begin

end;

procedure TMainWndViewer.acExportSVGExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName  := GetGHCaveDrawDirectory() + 'Svg001.svg';
  if (DoDialogSaveFilename('Fichiers SVG (*.svg)|*.svg|Tous|*.*', '.svg', QFileName)) then
  begin
    if (Not CadreDessin1.MyDocumentDessin.ExportToSvg(QFileName, False, False, '', '')) then ShowMessage(rsMSG_ERR_CTXT_SVG);
    AfficherMessage(GetResourceString(rsMISC_DONE_WITH_SUCCESS));
  end;
end;

procedure TMainWndViewer.acExportSVGScrapsOnlyExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName  := GetGHCaveDrawDirectory() + 'Svg001.svg';
  if (DoDialogSaveFilename('Fichiers SVG (*.svg)|*.svg|Tous|*.*', '.svg', QFileName)) then
  begin
    if (Not CadreDessin1.MyDocumentDessin.ExportToSvg(QFileName, True, False, '', '')) then ShowMessage(rsMSG_ERR_CTXT_SVG);
    AfficherMessage(GetResourceString(rsMISC_DONE_WITH_SUCCESS));
  end;
end;

procedure TMainWndViewer.acExportXHTMLExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName  := GetGHCaveDrawDirectory() + 'Svg001.xhtml';
  if (DoDialogSaveFilename('Fichiers SVG (XHTML) (*.xhtml)|*.xhtml|Tous|*.*', '.xhtml', QFileName)) then
  begin
    if (Not CadreDessin1.MyDocumentDessin.ExportToSvg(QFileName, False, True,
                                                      'Dessin',
                                                      'Generated by GHCaveDraw')) then ShowMessage(rsMSG_ERR_CTXT_SVG);
  end;
end;

procedure TMainWndViewer.acGenererCarteLeafletExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName   := 'OSMLeafLet001.htm';
  if (DoDialogSaveFilename('HTML document (*.htm)|*.htm', '.htm', QFileName)) then
  begin
    CadreDessin1.MyDocumentDessin.GenererCarteLeaflet(QFileName, 1200, 800);
  end;
end;

procedure TMainWndViewer.acGenererDessinOOoDrawExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName   := 'PlanTopo001.odg';
  if (DoDialogSaveFilename('OpenOffice / LibreOffice Draw (*.odg)|*.odg', '.odg', QFileName)) then
  begin
    CadreDessin1.MyDocumentDessin.ExportToODG(QFileName, false);
  end;
end;



procedure TMainWndViewer.acHierarchieObjetsExecute(Sender: TObject);
begin
  DisplayHierarchieObjets(CadreDessin1.GetDocDessin());
end;



procedure TMainWndViewer.acExportImgAllReseauExecute(Sender: TObject);
var
  QFileName: string;
  QC1, QC2: TPoint3Df;
  EWE: TRect2Df;
  FD: TDocumentDessin;
  QAT: double;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QAT := 4000;
  if (InputNumValue('Génération d''une image', 'Taille de l''image', 500, 32000, QAT)) then
  begin
    QFileName := 'Vue001.png';
    if (DoDialogSaveFilename('Image PNG|*.png|Image JPG|*.jpg', '.png', QFileName)) then
    begin
      FD := CadreDessin1.GetDocDessin();
      //CadreDessin1.SaveVueAsImage(QFileName);
      FD.SetMiniEtMaxi;
      QC1 := FD.GetCoordsMini();
      QC2 := FD.GetCoordsMaxi();
      EWE := MakeTRect2Df(QC1.X, QC1.Y, QC2.X, QC2.Y);
      CadreDessin1.ExporterTopoEnImage(QFileName, EWE, Trunc(QAT));
      ShowMessage(GetResourceString(rsMISC_DONE_WITH_SUCCESS));
    end;
  end;
end;

procedure TMainWndViewer.acExportKMLExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName  := GetGHCaveDrawDirectory() + 'KML001.kml';
  if (DoDialogSaveFilename('Fichiers KML (*.kml)|*.kml|Tous|*.*', '.kml', QFileName)) then
  begin
    if (Not CadreDessin1.MyDocumentDessin.ExporterScrapsToKMLorOSM(QFileName, gisGOOGLE_EARTH)) then ShowMessage(rsMSG_ERR_EXPORT_KML);
  end;
end;

procedure TMainWndViewer.acExportOSMExecute(Sender: TObject);
var
  QFileName: String;
begin
  if (Not CadreDessin1.DoDraw) then Exit;
  QFileName  := GetGHCaveDrawDirectory() + 'OSM001.kml';
  if (DoDialogSaveFilename('Fichiers OpenStreetMap (*.osm)|*.osm|Tous|*.*', '.osm', QFileName)) then
  begin
    if (Not CadreDessin1.MyDocumentDessin.ExporterScrapsToKMLorOSM(QFileName, gisOPEN_STREET_MAP)) then ShowMessage(rsMSG_ERR_EXPORT_OSM);
  end;
end;


procedure TMainWndViewer.acCreerUnAtlasHTMLExecute(Sender: TObject);
var
  PD: TdlgParametrageAtlas;
begin
  PD := TdlgParametrageAtlas.Create(application);
  try
    PD.Initialiser(CadreDessin1.GetDocDessin(),
                   CadreDessin1.GetTexturesPolygones(),
                   CadreDessin1.GetParametresGrille(),
                   CadreDessin1.GetElementsDessines());
    PD.ShowModal;
  finally
    PD.Release;
  end;
end;





procedure TMainWndViewer.acAproposExecute(Sender: TObject);
begin
  DisplayHelpSystem(CadreDessin1.GetDocDessin, '');
end;


procedure TMainWndViewer.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  Canclose := QuestionOuiNon(rsMSG_QUIT);
end;


procedure TMainWndViewer.Button2Click(Sender: TObject);
begin
  CadreDessin1.SetTailleEchelle(editTailleEchelle.Value);
end;



//******************************************************************************

procedure TMainWndViewer.FormDestroy(Sender: TObject);
begin
  {$IFDEF MSWINDOWS}
  dlgProcessing.Release;
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
  dlgProcessing.Release;
  {$ENDIF}
  {$IFDEF LINUX}
  ;
  {$ENDIF}
end;

procedure TMainWndViewer.FormShow(Sender: TObject);
begin
  InitCaptions;
  {$IFDEF MSWINDOWS}
  dlgProcessing.Show;
  EnvoyerFenetreVersMoniteur(dlgProcessing, -1, 100, 100, 640, 480);
  EnvoyerFenetreVersMoniteur(self, 0, 10, 10, Screen.Width -20, Screen.Height - 100);
  {$ENDIF}
  {$IFDEF MAC_OS_X_VERSION_MIN_REQUIRED}
  dlgProcessing.Show;
  EnvoyerFenetreVersMoniteur(dlgProcessing, -1, 100, 100, 640, 480);
  EnvoyerFenetreVersMoniteur(self, 0, 10, 10, Screen.Width -20, Screen.Height - 100);
  {$ENDIF}
  {$IFDEF LINUX}
  ;
  {$ENDIF}
  AfficherMessage('Démarrage de GHCaveDraw');
  InitialiserGHC();
  self.Width    := Screen.Width - 60;
  self.Height   := Screen.Height - 100;

end;

procedure TMainWndViewer.Redessiner;
begin
  CadreDessin1.Vue.Invalidate; //CadreDessin1.RedessinEcran(false);
end;



end.

