unit VueEn3DExt;

// Date: 07/11/2013
// Statut: Opérationnel
// Appel par passage de pointeur sur BDD entités: OK
// Appel par chargement de fichier: OK
// 27/04/2016: Nombreuses corrections et mises à jour

{$INCLUDE CompilationParameters.inc}
interface
uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees, Common, UnitEntitesExtended, UnitClasseMaillage,
  ToporobotClasses2012,
  CallDialogsStdVersion,
  unitUtilsComposants,
  CadreVue3DExt, CadreFiltres, UnitListesSimplesWithGeneriques, Classes, SysUtils, FileUtil, curredit, Forms,
  Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, ActnList, Buttons, Spin, ComCtrls, Types, LCLType;

type

  { TfrmVue3DExt }

  TfrmVue3DExt = class(TForm)
    acProjXY: TAction;
    acProjYZ: TAction;
    acProjXZ: TAction;
    acProjIso: TAction;
    acParamVue3D: TAction;
    acExporterSVG: TAction;
    acRegenerer: TAction;
    acRedessiner: TAction;
    acExportNuageDePoints: TAction;
    ActionList2: TActionList;
    BitBtn1: TBitBtn;
    btnColorZMaxi: TColorButton;
    btnColorZMini: TColorButton;
    Button1: TButton;
    btnExportGCP: TButton;
    Button2: TButton;
    Button3: TButton;
    btnProfilsTopo: TButton;
    CdrVue3DExt1: TCdrVue3DExt;
    chkFiltrer: TCheckBox;
    chkDrawVolumes: TCheckBox;
    cmbRepresentation: TComboBox;
    editFactZ: TCurrencyEdit;
    editFiltres3D: TEdit;
    editPhi: TSpinEdit;
    editZoom: TFloatSpinEdit;
    ImageList2: TImageList;
    Label1: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    editTheta: TSpinEdit;
    procedure ac3DIsoExecute(Sender: TObject);
    procedure acExporterSVGExecute(Sender: TObject);
    procedure acExportNuageDePointsExecute(Sender: TObject);
    procedure acExportNuagePointsExecute(Sender: TObject);
    procedure acExportSVGExecute(Sender: TObject);
    procedure acParamVue3DExecute(Sender: TObject);
    procedure acProjIsoExecute(Sender: TObject);
    procedure acProjXYExecute(Sender: TObject);
    procedure acProjXZExecute(Sender: TObject);
    procedure acProjYZExecute(Sender: TObject);
    procedure acRedessExecute(Sender: TObject);
    procedure acRedessinerExecute(Sender: TObject);
    procedure acRegenererExecute(Sender: TObject);
    procedure acRegenExecute(Sender: TObject);
    procedure acSetElementsDrawnExecute(Sender: TObject);
    procedure acVueXYExecute(Sender: TObject);
    procedure acVueXZExecute(Sender: TObject);
    procedure acVueYZExecute(Sender: TObject);
    procedure btnColorZMiniClick(Sender: TObject);
    procedure btnExportGCPClick(Sender: TObject);
    procedure btnProfilsTopoClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure chkDoFiltrerChange(Sender: TObject);
    procedure chkDrawVolumesChange(Sender: TObject);
    procedure chkFiltrerChange(Sender: TObject);
    procedure cmbRepresentationChange(Sender: TObject);
    procedure editThetaChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);


  private
    { private declarations }
    FDocTopo   : TToporobotStructure2012;
    FBDDEntites: TBDDEntites;
    FMyMaillage: TMaillage;

    FBddDemarreeDepuisFichier: boolean;
    procedure Redessiner();
    procedure RefreshControlesParametresVue();
  public
    { public declarations }
    function InitialiseByPointer(const QBDD: TBDDEntites; const DT: TToporobotStructure2012; const MyMaillage: TMaillage; const QFiltres: string): boolean;
    // libération du contexte
    procedure Finaliser();
  end;

var
  frmVue3DExt: TfrmVue3DExt;

implementation

{$R *.lfm}

{ TfrmVue3DExt }

procedure TfrmVue3DExt.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Finaliser();
end;

procedure TfrmVue3DExt.FormCreate(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.FormShow(Sender: TObject);
var
  WU: TModeRepresentationGaleries;
  MH, MV: Integer;
begin
  MH := 40;
  MV := 40;
  self.Top    := MV;
  self.Left   := MH;
  self.Width  := Screen.Width  - 2 * MH;
  self.Height := Screen.Height - 5 * MH;
  //self.Position := poScreenCenter;

  //lbRepresentation.Caption := GetResourceString(rsVUE2D_REPRESENTATION_MODE);
  InitialiserComboBoxRepresentationVisees(cmbRepresentation, rgDEPTH);
  self.Width  := Screen.Width - 200;
  self.Height := Screen.Height - 160;
  self.Position := poScreenCenter;
  CdrVue3DExt1.InitialiseVue3D(FBDDEntites, FMyMaillage, Trim(editFiltres3D.Text), RefreshControlesParametresVue);
  self.Redessiner;
end;



// callback pour rafraichissement des contrôles
procedure TfrmVue3DExt.RefreshControlesParametresVue;
begin
  AfficherMessageErreur('TProcRefreshControlsBy3DView');
  editTheta.Value := CdrVue3DExt1.GetTheta;
  editPhi.Value   := CdrVue3DExt1.GetPhi;
  editZoom.Value  := CdrVue3DExt1.GetZoom;
end;


procedure TfrmVue3DExt.Redessiner;
var
  WU: TModeRepresentationGaleries;
begin
  try
    WU := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
    CdrVue3DExt1.SetAndRedessVue3D(WU,
                                   btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                   editTheta.Value, editPhi.Value,
                                   editZoom.Value,
                                   editFactZ.Value,
                                   Trim(editFiltres3D.Text),
                                   chkFiltrer.Checked,
                                   chkDrawVolumes.Checked);

  except
  end;
end;

procedure TfrmVue3DExt.acRegenExecute(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.acSetElementsDrawnExecute(Sender: TObject);
var
  WU: TVue3DParams;
begin

  //CdrVue3DExt1.SetAndRedessVue3D(WU);
end;

procedure TfrmVue3DExt.acVueXYExecute(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.acVueXZExecute(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.acVueYZExecute(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.btnColorZMiniClick(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.btnExportGCPClick(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QIdxFilter: integer;
  QPhi      : Double;
begin
  QPhi := CdrVue3DExt1.GetPhi;
  if (Trunc(QPhi) > 0) then exit();
  if (DoDialogSaveFile('Fichier GCP|*.gcp|Tous|*.*', '.gcp', QFileName, QIdxFilter)) then
  begin
    CdrVue3DExt1.ExportGCP(QFileName);
  end;
end;

procedure TfrmVue3DExt.btnProfilsTopoClick(Sender: TObject);
begin
  DisplayListeProfils(FDocTopo, FMyMaillage);
end;

procedure TfrmVue3DExt.Button2Click(Sender: TObject);
var
  QIdxFilter: integer;
  QFileName: TStringDirectoryFilename;
begin
  QFileName := 'VRML1.x3dv';
  if (DoDialogSaveFile('Fichier VRML|*.wrl', '.wrl', QFileName, QIdxFilter)) then
  begin
    //FBDDEntites.ExportX3D(QFileName, True, Trim(editFiltres3D.Text));
  end;
end;

procedure TfrmVue3DExt.Button3Click(Sender: TObject);
var
  QIdxFilter, QIdx: integer;
  QFileName: TStringDirectoryFilename;
  EWE: Boolean;
  QExt, WU: String;
begin

  EWE := True;
  QExt := IIF(EWE, '.x3d', '.x3dv');
  QFileName := 'Cavite001' + QExt;
  WU := IIF(EWE, 'Volumes X3D (format XML)|*', 'Volumes X3D (format VRML)|*') + QExt;
  //if (DoDialogSaveFile(WU, QExt, QFileName, QIdx)) then FBDDEntites.ExportX3D(QFileName, EWE, '');
end;

procedure TfrmVue3DExt.chkDoFiltrerChange(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.chkDrawVolumesChange(Sender: TObject);
begin
end;

procedure TfrmVue3DExt.chkFiltrerChange(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.cmbRepresentationChange(Sender: TObject);
begin
end;

procedure TfrmVue3DExt.editThetaChange(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.acRedessExecute(Sender: TObject);
begin

end;

procedure TfrmVue3DExt.acRedessinerExecute(Sender: TObject);
begin
  CdrVue3DExt1.SetAndRedessVue3D(TModeRepresentationGaleries(cmbRepresentation.ItemIndex),
                                   btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                   editTheta.Value, editPhi.Value,
                                   editZoom.Value, editFactZ.Value,
                                   editFiltres3D.Text, chkFiltrer.Checked, chkDrawVolumes.Checked);

end;

procedure TfrmVue3DExt.acRegenererExecute(Sender: TObject);
begin
  CdrVue3DExt1.InitialiseVue3D(FBDDEntites, FMyMaillage, Trim(editFiltres3D.Text), RefreshControlesParametresVue);
  CdrVue3DExt1.SetAndRedessVue3D(TModeRepresentationGaleries(cmbRepresentation.ItemIndex),
                                 btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                 45, 32,
                                 1.00, 1.00,
                                 '', false, True);
end;

procedure TfrmVue3DExt.ac3DIsoExecute(Sender: TObject);
begin
  CdrVue3DExt1.SetAndRedessVue3D(TModeRepresentationGaleries(cmbRepresentation.ItemIndex),
                                   btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                   45, 32,
                                   editZoom.Value, editFactZ.Value,
                                   editFiltres3D.Text, chkFiltrer.Checked, chkDrawVolumes.Checked);
end;

procedure TfrmVue3DExt.acExporterSVGExecute(Sender: TObject);
var
  EWE: TStringDirectoryFilename;
  beuh: String;
  DoXHTML: Boolean;
  QFilterIndex: integer;
  QParam3D: TVue3DParams;
begin
  //WU  := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  QParam3D := CdrVue3DExt1.GetParamsVue3D();
  EWE := 'SVG_3D_001.svg';
  if (DoDialogSaveFile('Scalable Vector Graphics (*.svg)|*.svg|' +
                       'XHTML document (*.xhtml)|*.xhtml',
                       '.svg', EWE, QFilterIndex)) then
  begin
    beuh := ExtractFileExt(EWE);
    DoXHTML := (Pos(beuh, 'xht') > 0);
    CdrVue3DExt1.ExporterVue3DEnSVG_TSVGCanvas(EWE, DoXHTML, QParam3D.ModeRepresentation, QParam3D.FillOpacity);
  end;
end;

procedure TfrmVue3DExt.acExportNuageDePointsExecute(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
  QFilterIndex: integer;
begin
  QFileName := 'NuagePoints001.csv';
  if (DoDialogSaveFile('Fichiers CSV (*.csv)|*.csv|Tous|*.*', '.csv', QFileName, QFilterIndex)) then
  begin
    FBDDEntites.ExporterAntennesNuagePoints(QFileName);
  end;
end;

procedure TfrmVue3DExt.acExportNuagePointsExecute(Sender: TObject);
var
  QFileName: string;
begin

end;

procedure TfrmVue3DExt.acExportSVGExecute(Sender: TObject);
var
  WU     : TModeRepresentationGaleries;
  DoXHTML: Boolean;
  EWE    : String;
  beuh   : String;
begin

end;

procedure TfrmVue3DExt.acParamVue3DExecute(Sender: TObject);
var
  WU: TVue3DParams;
begin
  WU  := CdrVue3DExt1.GetParamsVue3D();
  if (ParametrerOngletVue3D(WU)) then
  begin
    CdrVue3DExt1.SetAndRedessVue3D(WU);
  end;
end;

procedure TfrmVue3DExt.acProjIsoExecute(Sender: TObject);
begin
  CdrVue3DExt1.SetAndRedessVue3D(TModeRepresentationGaleries(cmbRepresentation.ItemIndex),
                                   btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                   45, 32, editZoom.Value, editFactZ.Value,
                                   editFiltres3D.Text, chkFiltrer.Checked, chkDrawVolumes.Checked);
end;

procedure TfrmVue3DExt.acProjXYExecute(Sender: TObject);
begin
  CdrVue3DExt1.SetAndRedessVue3D(TModeRepresentationGaleries(cmbRepresentation.ItemIndex),
                                   btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                   270, 90, editZoom.Value, editFactZ.Value,
                                   editFiltres3D.Text, chkFiltrer.Checked, chkDrawVolumes.Checked);
end;

procedure TfrmVue3DExt.acProjXZExecute(Sender: TObject);
begin
  CdrVue3DExt1.SetAndRedessVue3D(TModeRepresentationGaleries(cmbRepresentation.ItemIndex),
                                 btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                 270, 0, editZoom.Value, editFactZ.Value,
                                 editFiltres3D.Text, chkFiltrer.Checked, chkDrawVolumes.Checked);
end;

procedure TfrmVue3DExt.acProjYZExecute(Sender: TObject);
begin
 CdrVue3DExt1.SetAndRedessVue3D(TModeRepresentationGaleries(cmbRepresentation.ItemIndex),
                                btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor,
                                0, 0, editZoom.Value, editFactZ.Value,
                                editFiltres3D.Text, chkFiltrer.Checked, chkDrawVolumes.Checked);
end;

function TfrmVue3DExt.InitialiseByPointer(const QBDD: TBDDEntites; const DT: TToporobotStructure2012; const MyMaillage: TMaillage; const QFiltres: string): boolean;
var
  QDevelViseesVisibles: double;
begin
  Result := False;
  FDocTopo    := DT;
  FMyMaillage := MyMaillage;
  editFiltres3D.Text := QFiltres;
  FBddDemarreeDepuisFichier := false;
  FBDDEntites := QBDD;
  try
    FBDDEntites.MetaFiltre(QFiltres, QDevelViseesVisibles);
    Result := True;
    //ShowMessage('InitialiseByPointer()');
  finally
  end;
end;







procedure TfrmVue3DExt.Finaliser;
begin
  if (FBddDemarreeDepuisFichier) then
  begin
    try
      FBDDEntites.Finaliser();
    finally
      FBDDEntites.Free;
    end;
  end;
  CdrVue3DExt1.FinaliseVue3D();
end;

end.

