unit VueEn3DOpenGLExt;

// Date: 07/11/2013
// Statut: Opérationnel
// Appel par passage de pointeur sur BDD entités: OK
// Appel par chargement de fichier: En cours
// 01/06/2015 : Support des maillages de surface
{$INCLUDE CompilationParameters.inc}
interface
uses
  {$INCLUDE SelectionLangues.inc} // insère les unités en fonction de la langue
  StructuresDonnees, Common, UnitEntitesExtended, UnitClasseMaillage,
  unitUtilsComposants,
  CadreVue3DOpenGLExt, CadreFiltres, CallDialogsStdVersion, Classes, SysUtils,
  FileUtil, curredit, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  ComCtrls;

type

  { TfrmVueEn3DOpenGLExt }

  TfrmVueEn3DOpenGLExt = class(TForm)
    btnColorZMaxi: TColorButton;
    btnColorZMaxi1: TColorButton;
    btnColorZMini: TColorButton;
    btnColorZMiniMaillage: TColorButton;
    btnCouleurCube: TColorButton;
    btnCouleurFond: TColorButton;
    btnCouleurReferentiel: TColorButton;
    btnRegen: TButton;
    btnRedess: TButton;
    Button1: TButton;
    Button2: TButton;
    CdrMetaFiltre1: TCdrMetaFiltre;
    CdrVue3DOpenGLExt1: TCdrVue3DOpenGLExt;
    cmbModeRepresentationMaillage: TComboBox;
    cmbRepresentation: TComboBox;
    editFactZ: TCurrencyEdit;
    editPhi: TCurrencyEdit;
    editTheta: TCurrencyEdit;
    editZoom: TCurrencyEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lbRepresentation: TLabel;
    Panel1: TPanel;
    sclPhi: TScrollBar;
    sclTheta: TScrollBar;
    sclZoom: TScrollBar;
    lbStatusMaillage: TStaticText;
    trkbTransparence: TTrackBar;
    procedure btnRegenClick(Sender: TObject);
    procedure btnRedessClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cmbModeRepresentationMaillageChange(Sender: TObject);
    procedure cmbRepresentationChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OpenGLControl1Click(Sender: TObject);
    procedure sclPhiChange(Sender: TObject);
    procedure sclThetaChange(Sender: TObject);
    procedure sclZoomChange(Sender: TObject);
  private
    { private declarations }
    FBDDEntites: TBDDEntites;
    FBddDemarreeDepuisFichier: boolean;
    FElementsDrawn: TElementsDrawn;
    procedure RedessinerLaVue3D();
    procedure InitialiserVue();
    procedure RefreshControlesParametresVue();
    procedure AfficherInfosMaillage();
  public
    { public declarations }
    function InitialiseByPointer(const QBDD: TBDDEntites; const QFiltres: string): boolean;
    // initialisation depuis un fichier (FBDDEntites est local)
    function InitialiseByFichier(const QFileName: string; const QFiltres: string; const PositionPointZero: TPoint3Df): boolean;
    // libération du contexte
    procedure Finaliser;
  end;

var
  frmVueEn3DOpenGLExt: TfrmVueEn3DOpenGLExt;

implementation

{$R *.lfm}

{ TfrmVueEn3DOpenGLExt }

procedure TfrmVueEn3DOpenGLExt.InitialiserVue;
var
  WU: TModeRepresentationGaleries;
  EWE: String;
begin
  WU := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  EWE := CdrMetaFiltre1.GetFiltre;
  CdrVue3DOpenGLExt1.InitialiserVue3D(FBDDEntites,
                                      EWE,
                                      RefreshControlesParametresVue);
  CdrVue3DOpenGLExt1.SetColorsElementsScene(WU, btnCouleurFond.ButtonColor, btnCouleurCube.ButtonColor, btnCouleurReferentiel.ButtonColor);
  CdrVue3DOpenGLExt1.SetColorsByDepth(WU, btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor);
  CdrVue3DOpenGLExt1.SetParamsAndRegenVue3D(sclTheta.Position, sclPhi.Position, sclZoom.Position/100, editFactZ.Value, EWE, CdrMetaFiltre1.IsMetafiltreActif());
end;

procedure TfrmVueEn3DOpenGLExt.RefreshControlesParametresVue;
begin
  // Indispensable
end;


procedure TfrmVueEn3DOpenGLExt.btnRegenClick(Sender: TObject);
var
  WU: TModeRepresentationGaleries;
  EWE: String;
begin
  WU  := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  EWE := CdrMetaFiltre1.GetFiltre;
  CdrVue3DOpenGLExt1.SetColorsElementsScene(WU, btnCouleurFond.ButtonColor, btnCouleurCube.ButtonColor, btnCouleurReferentiel.ButtonColor);
  CdrVue3DOpenGLExt1.SetColorsByDepth(WU, btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor);
  CdrVue3DOpenGLExt1.SetParamsAndRegenVue3D(sclTheta.Position, sclPhi.Position, sclZoom.Position/100, editFactZ.Value, EWE, CdrMetaFiltre1.IsMetafiltreActif());
end;
procedure TfrmVueEn3DOpenGLExt.RedessinerLaVue3D();
var
  WU: TModeRepresentationGaleries;
  EWE: String;
begin
  WU  := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  EWE := CdrMetaFiltre1.GetFiltre;
  CdrVue3DOpenGLExt1.SetColorsElementsScene(WU, btnCouleurFond.ButtonColor, btnCouleurCube.ButtonColor, btnCouleurReferentiel.ButtonColor);
  CdrVue3DOpenGLExt1.SetParamsVue3D(WU,
                                    FElementsDrawn,
                                    sclTheta.Position,
                                    sclPhi.Position,
                                    sclZoom.Position,
                                    editFactZ.Value);

end;

procedure TfrmVueEn3DOpenGLExt.AfficherInfosMaillage;
var
  BF: TColor;
  EWE: String;
  QMaillage : TMaillage;
begin
  BF := clSilver;
  QMaillage := CdrVue3DOpenGLExt1.GetMaillage();
  if (QMaillage.IsValidMaillage()) then
  begin
    BF := clGreen;
    case QMaillage.GetTypeMaillage() of
      tmREGULAR_GRID : EWE := Format('Grid %dx%d', [QMaillage.GetNbCellsX(), QMaillage.GetNbCellsY()]);
      tmTRIANGLES    : EWE := Format('TIN: %d vertex, %d triangles', [QMaillage.GetNbVertex(), QMaillage.GetNbTriangles()]);
    else
      EWE := 'Unknown MNT type';
    end;
  end
  else
  begin
    BF := clRed;
  end;
  ShowMessage(EWE);
  lbStatusMaillage.Color := BF;
  lbStatusMaillage.Caption := EWE;
end;

procedure TfrmVueEn3DOpenGLExt.btnRedessClick(Sender: TObject);
begin
  RedessinerLaVue3D;
end;

procedure TfrmVueEn3DOpenGLExt.Button1Click(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
begin
  if (DoDialogOpenFile('Fichiers maillages (*.mai)|*.mai|Tous (*.*)|*.*', '.mai', QFileName)) then
  begin
    CdrVue3DOpenGLExt1.ChargerMaillageMAI(QFileName);
    AfficherInfosMaillage();
  end;
end;

procedure TfrmVueEn3DOpenGLExt.Button2Click(Sender: TObject);
var
  QFileName: TStringDirectoryFilename;
begin
  if (DoDialogOpenFile('Fichiers maillages VTopo (*.sur)|*.sur|Tous (*.*)|*.*', '.sur', QFileName)) then
  begin
    CdrVue3DOpenGLExt1.ChargerMaillageSUR(QFileName);
  end;
end;



procedure TfrmVueEn3DOpenGLExt.cmbModeRepresentationMaillageChange(Sender: TObject);
var
  WU: TMNTModeDessinMaillage;
begin
  WU := TMNTModeDessinMaillage(cmbModeRepresentationMaillage.ItemIndex);
  CdrVue3DOpenGLExt1.SetParamsMaillage(WU, trkbTransparence.Position / 100);
  if (WU in [M3D_WIRE_FRAME .. M3D_BLEND]) then FElementsDrawn := FElementsDrawn + [edMaillages]
                                           else FElementsDrawn := FElementsDrawn - [edMaillages];
end;

procedure TfrmVueEn3DOpenGLExt.cmbRepresentationChange(Sender: TObject);
var
  WU: TModeRepresentationGaleries;
  EWE: String;
begin
  WU  := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  EWE := CdrMetaFiltre1.GetFiltre();
  CdrVue3DOpenGLExt1.SetColorsElementsScene(WU, btnCouleurFond.ButtonColor, btnCouleurCube.ButtonColor, btnCouleurReferentiel.ButtonColor);
  CdrVue3DOpenGLExt1.SetColorsByDepth(WU, btnColorZMini.ButtonColor, btnColorZMaxi.ButtonColor);
  CdrVue3DOpenGLExt1.SetParamsAndRegenVue3D(sclTheta.Position, sclPhi.Position, sclZoom.Position/100, editFactZ.Value, EWE, CdrMetaFiltre1.IsMetafiltreActif());
end;

procedure TfrmVueEn3DOpenGLExt.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Finaliser;
end;

procedure TfrmVueEn3DOpenGLExt.FormCreate(Sender: TObject);
begin

end;



procedure TfrmVueEn3DOpenGLExt.FormShow(Sender: TObject);
begin
  self.Width  := Screen.Width  - 160;
  self.Height := Screen.Height - 200;
  self.Left   := 80;
  self.Top    := 50;
  self.Position := poDesigned;
  lbRepresentation.Caption := GetResourceString(rsVUE2D_REPRESENTATION_MODE);
  InitialiserComboBoxRepresentationVisees(cmbRepresentation, rgSEANCES);
  InitialiserVue();
end;

procedure TfrmVueEn3DOpenGLExt.OpenGLControl1Click(Sender: TObject);
begin

end;

procedure TfrmVueEn3DOpenGLExt.sclPhiChange(Sender: TObject);
var
  WU: TModeRepresentationGaleries;
begin
  WU := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  editPhi.Value   := sclPhi.Position;
  CdrVue3DOpenGLExt1.SetParamsVue3D(WU,
                                    FElementsDrawn,
                                    sclTheta.Position, sclPhi.Position, sclZoom.Position/100, editFactZ.Value);
end;

procedure TfrmVueEn3DOpenGLExt.sclThetaChange(Sender: TObject);
var
  WU: TModeRepresentationGaleries;
begin
  WU := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  editTheta.Value := sclTheta.Position;
  CdrVue3DOpenGLExt1.SetParamsVue3D(WU, FElementsDrawn, sclTheta.Position, sclPhi.Position, sclZoom.Position/100, editFactZ.Value);
end;

procedure TfrmVueEn3DOpenGLExt.sclZoomChange(Sender: TObject);
var
  WU: TModeRepresentationGaleries;
begin
  WU := TModeRepresentationGaleries(cmbRepresentation.ItemIndex);
  editZoom.Value  := sclZoom.Position;
  CdrVue3DOpenGLExt1.SetParamsVue3D(WU, FElementsDrawn, sclTheta.Position, sclPhi.Position, sclZoom.Position/100, editFactZ.Value);
end;

function TfrmVueEn3DOpenGLExt.InitialiseByPointer(const QBDD: TBDDEntites; const QFiltres: string): boolean;
var
  QDevelViseesVisibles: double;
begin
  Result := False;
  cmbModeRepresentationMaillage.ItemIndex := 0;
  CdrMetaFiltre1.SetFiltre(QFiltres);
  FBddDemarreeDepuisFichier := false;
  FBDDEntites := QBDD;
  FElementsDrawn := [edBounds, edPolygonals, edANTENNES, edVolumes];
  try
    FBDDEntites.MetaFiltre(QFiltres, QDevelViseesVisibles);
    Result := True;
  finally
  end;
end;

function TfrmVueEn3DOpenGLExt.InitialiseByFichier(const QFileName: string; const QFiltres: string; const PositionPointZero: TPoint3Df): boolean;
begin
  Result := False;
  cmbModeRepresentationMaillage.ItemIndex := 0;
  CdrMetaFiltre1.SetFiltre(QFiltres);
  FBddDemarreeDepuisFichier := True;
  FElementsDrawn := [edBounds, edPolygonals, edANTENNES, edVolumes];
  FBDDEntites := TBDDEntites.Create;
  try
   FBDDEntites.Initialiser(PositionPointZero);
   Result := FBDDEntites.LoadFromFile(QFileName);
  except
  end;
end;

procedure TfrmVueEn3DOpenGLExt.Finaliser;
begin
  if (FBddDemarreeDepuisFichier) then
  begin
    try
      FBDDEntites.Finaliser();
    finally
      FBDDEntites.Free;
    end;
  end;
  CdrVue3DOpenGLExt1.FinaliserVue3D;
end;

end.

